import { ConfigAPIAction, ConfigAPIActions } from './actions';
import { IConfigState } from './model';
// import { indexBy, prop } from 'ramda';
import { tassign } from 'tassign';
import { Action } from 'redux';

const INITIAL_STATE: IConfigState = {
    configs: [],
    selected_value: '',
    loading: false,
    error: null,
};

export function createConfigReducer() {
  return function configReducer(state: IConfigState = INITIAL_STATE,
    a: Action): IConfigState {

    const action = a as ConfigAPIAction;

    if (!action.meta) {
       return state;
    }
    switch (action.type) {

        case ConfigAPIActions.LOAD_STARTED:
           return tassign(state, { loading: true, error: null});

        case ConfigAPIActions.LOAD_SUCCEEDED:
         
          return tassign(state, {
            configs: action.payload.settings,
            error: null,
            loading: false
          });

       case ConfigAPIActions.LOAD_FAILED:
          return tassign(state, { loading: false, error: action.error});

      case ConfigAPIActions.GET_CONFIG:
        // action.payload should be id of config
        const configs = state.configs;
        let selected_value = '';
        for (const config of configs) {
            if (config.id === action.payload) {
                selected_value = config.value;
            }
        }
        return tassign(state, {
            selected_value: selected_value
        });
      }

    return state;
  };
}
