import { Injectable } from '@angular/core';
import { ConfigAPIActions } from '../reducer/actions';
import { HttpClient } from '@angular/common/http';
import { ConfigSettingsService } from './settings.service';
import { CoreAPIActions } from '../../pages/core/reducer/actions';
import { select } from '@angular-redux/store';
import { Observable } from 'rxjs/Observable';

@Injectable()
export class ConfigDataService {

  @select(['configuration', 'configs'])
  readonly configs$: Observable<any>;

  Configs: any = [];
  constructor(
    private settings: ConfigSettingsService,
    private http: HttpClient,
    private actions: ConfigAPIActions,
    private coreActions: CoreAPIActions) {
        this.configs$.subscribe(configs => {
            this.Configs = configs;
        });
     }

  LoadRecords(FilterOptions) {
      const URL = this.settings.getApiOptions().load;
     
      this.actions.loadStarted();
      this.http.post(URL, JSON.stringify(FilterOptions))
        .subscribe((data: any) => {
          // update core data
          this.actions.loadSucceeded(data);
      }, err => {
          this.actions.loadFailed(err);
      });
  }

  getConfigValue(config_id: number) {
        if (config_id === 0)
        {
            return 1;
        }

        let selected_value = '';

        for (const config of this.Configs) {
            if (config.id === config_id) {
                selected_value = config.value;
            }
        }
        return selected_value;
  }

}
