// export const APIURL = 'http://localhost:4147/';
export class NormalRegex {
    static readonly USERNAME_REGEX = '^[a-z0-9_-]{5,15}$';
    static readonly PASSWORD_REGEX = '^(?=.*[0-9])(?=.*[!@#$%^&*])[a-zA-Z0-9!@#$%^&*]{6,16}$';
    static readonly WEBSITE_REGEX = 'https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)';
}

/* toggle on | off features */
export class AppFeatures {
    static readonly FEATURES = {
        videos: true,
        photos: false,
        artists: true,
        forums: false,
        qa: false,
        polls: false,
        blogs: false,
        wiki: false
     };
}

export class ContentTypes {
    static readonly MAILTEMPLATE_TYPES = [
        { title: 'General', value: '0' },
        { title: 'Members', value: '1' },
        { title: 'Videos', value: '2' },
        { title: 'Audio', value: '3' },
        { title: 'Blogs', value: '8' }
    ];

    static readonly CATEGORY_TYPES = [
        { title: 'Videos', value: '0' },
        { title: 'Audio', value: '7' },
        { title: 'Abuse Report', value: '4' },
        { title: 'Channels', value: '2' }
    ];

    static readonly TAG_TYPES = [
        { title: 'Videos', value: '0' },
        { title: 'Audio', value: '4' }
    ];

    static readonly ALBUM_TYPES = [
        { title: 'Videos', value: 1 },
        { title: 'Audio', value: 2 }
    ];

    static readonly MEDIA_TYPES = [
        { title: 'Video', value: 0 },
        { title: 'Audio', value: 1 }
    ];

    static readonly ROLE_TYPES = [
        { title: 'Roles', value: '1', add_title: 'Add Role', add_tooltip: 'Add new role' },
        { title: 'Role Objects', value: '2', add_title: 'Add Role Object', add_tooltip: 'Add new role' }
    ];

    static readonly USER_TYPES = [
        { title: 'User', value: '0' },
        { title: 'Administrator', value: '1' },
        { title: 'Certified User', value: '2' }
    ];

}
