import { Injectable } from '@angular/core';
import { CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs/Observable';
import { Route, Router, CanLoad, CanActivateChild } from '@angular/router';
import { select, select$ } from '@angular-redux/store';

@Injectable()
export class JMediaLazyGuard implements CanActivate {

  @select(['users', 'auth'])
  readonly auth$: Observable<any>;

  isAuth: any;

  constructor(private router: Router) {
      this.auth$.subscribe(auth => {
        console.log('auth is');
        console.log(auth);
        this.isAuth = auth;
      });
  }

  canActivate(
    next: ActivatedRouteSnapshot,
    state: RouterStateSnapshot): Observable<boolean> | Promise<boolean> | boolean {
      console.log('reached');
      console.log(this.isAuth);
      if (this.isAuth.isAuthenticated) {
          return true;
      } else {
         this.router.navigate(['']);
         return false;
      }
  }
}

/*@Injectable()
export class JMediaLazyGuard implements CanLoad {
  canLoad(route: Route): Observable<boolean>|Promise<boolean>|boolean {
      console.log('reached');
      alert('you are not allowed to access this area');
      return false;
  }
}*/

/*@Injectable()
export class JMediaChildGuardGuard implements CanActivateChild {

  constructor(private router: Router) {
  }
  canActivateChild(childRoute: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean | Observable<boolean> | Promise<boolean> {
    console.log('redirecting home due to access Rights..');
    this.router.navigate(['']);
        return false;
  }
}*/
/*
created via cli -> ng g g jMediaGuard
*/
