import { Component, OnInit, HostBinding }    from '@angular/core';
import { ActivatedRoute }       from '@angular/router';
import { Observable }           from 'rxjs/Observable';

import { fadeInAnimation }   from '../../animations/core';
// import { SelectivePreloadingStrategy } from '../selective-preloading-strategy';

import 'rxjs/add/operator/map';

@Component({
   templateUrl: './dashboard.html',
   animations: [ fadeInAnimation ],
   host: { '[@fadeInAnimation]': '' }
})
export class MemberDashboardComponent implements OnInit {
  //@HostBinding('@slideInOutAnimation') slideInOutAnimation = true;
  sessionId: Observable<string>;
  token: Observable<string>;
  modules: string[];

  constructor(
    private route: ActivatedRoute
  ) {
    // this.modules = preloadStrategy.preloadedModules;
  }

  ngOnInit() {
    // Capture the session ID if available
    this.sessionId = this.route
      .queryParamMap
      .map(params => params.get('session_id') || 'None');

    // Capture the fragment if available
    this.token = this.route
      .fragment
      .map(fragment => fragment || 'None');
  }
}
