import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';

import { AdvertisemntComponent } from './advertisement.component';
import { ListComponent } from './partials/list.component';

/* services */
import { SettingsService } from './services/settings.service';
import { DataService } from './services/data.service';

/* actions */
import { AdvertisementAPIActions } from './reducer/actions';

import { PartialModule } from '../../../partials/shared.module';


@NgModule({
  imports: [
    CommonModule,
    PartialModule,
    FormsModule
  ],
  declarations: [
    AdvertisemntComponent,
    ListComponent
  ],
  exports: [
    AdvertisemntComponent
  ],
  providers: [
    SettingsService, DataService, AdvertisementAPIActions
  ]
})
export class AdverisementModule { }
