import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { CategoriesComponent } from './categories.component';
import { ListComponent } from './partials/list.component';


/* services */
import { SettingsService } from './services/settings.service';
import { DataService } from './services/data.service';

/* actions */
import { CategoriesAPIActions } from './reducer/actions';

import { PartialModule } from '../../../partials/shared.module';


@NgModule({
  imports: [
    CommonModule,
    PartialModule,
    FormsModule,
    RouterModule
  ],
  declarations: [
    CategoriesComponent,
    ListComponent
  ],
  exports: [
    CategoriesComponent
  ],
  providers: [
    SettingsService, DataService, CategoriesAPIActions
  ]
})
export class CategoriesModule { }
