import { ConfigurationsAPIAction, ConfigurationsAPIActions, ConfigurationsBLL } from './actions';
import { IConfigurationState, IPagination, IFilterOption } from './model';
import { tassign } from 'tassign';
import { Action } from 'redux';
import { CoreService } from '../../../../pages/core/coreService';

const INITIAL_STATE: IConfigurationState = {
    posts: [],
    loading: false,
    error: null,
    isloaded: false
};

export function createConfigurationsReducer() {
  return function configurationsReducer(state: IConfigurationState = INITIAL_STATE,
    a: Action): IConfigurationState {

    const action = a as ConfigurationsAPIAction;

    const bll = new ConfigurationsBLL();
    if (!action.meta) {
      return state;
    }
    switch (action.type) {

          case ConfigurationsAPIActions.LOAD_STARTED:
            return tassign(state, { loading: true, error: null});

          case ConfigurationsAPIActions.LOAD_SUCCEEDED:
            return bll.loadSucceeded(state, action);

          case ConfigurationsAPIActions.LOAD_FAILED:
              return tassign(state, { loading: false, error: action.error});

          case ConfigurationsAPIActions.UPDATE_CONFIGS:
              return bll.updateConfigs(state, action);
      }

    return state;
  };
}
