import { Injectable } from '@angular/core';
import { ConfigurationsAPIActions } from '../reducer/actions';
import { HttpClient } from '@angular/common/http';

import { SettingsService } from './settings.service';
import { CoreAPIActions } from '../../../core/reducer/actions';


@Injectable()
export class DataService {

  constructor(

    private settings: SettingsService,
    private http: HttpClient,
    private actions: ConfigurationsAPIActions,
    private coreActions: CoreAPIActions) { }

  LoadRecords() {
      const URL = this.settings.getApiOptions().load;
      this.actions.loadStarted();
      this.http.post(URL, { })
        .subscribe((data: any) => {
          // update core data
          this.actions.loadSucceeded(data);
      }, err => {
          this.actions.loadFailed(err);
      });

  }

  Update(configs, payload) {

     const updated_config_arr = this.processSubmittedConfigData(configs, payload);
     this.actions.updateConfigs(updated_config_arr);

     return this.http.post(this.settings.getApiOptions().proc, updated_config_arr);

  }

 processSubmittedConfigData(configs, payload) {
    const arr = [];
    for (const prop of Object.keys(payload)) {
        if (!prop.includes('section_')) {
            arr.push({
                id: prop.replace('config_', ''),
                value: payload[prop],
                description: ''
            });
        }
      }
      return arr;
    }

}
