import { Component, OnInit } from '@angular/core';
import { select } from '@angular-redux/store';
import { Observable } from 'rxjs/Observable';

import { CoreService } from '../../core/coreService';
import { PermissionService } from '../../../pages/users/services/permission.service';
@Component({
  templateUrl: './dashboard.html'
})
export class SettingsDashboardComponent implements OnInit {

  NavList: any;

  @select(['users', 'auth'])
   readonly auth$: Observable<any>;

  // permission logic
  isAccessGranted = false; // Granc access on resource that can be full access or read only access with no action rights
  isActionGranded = false; // Grand action on resources like add / edit /delete

  constructor(private coreService: CoreService, public permission: PermissionService) {}

   ngOnInit() {
      // user authentication & access right management
      // full resource access key and readonly key can be generated via roles management
      this.auth$.subscribe((auth: any) => {
        const FullAccessID = '1521396255768';
        const ReadOnlyAccessID = '1521396280060';
        if (this.permission.GrandResourceAccess(false, FullAccessID, ReadOnlyAccessID, auth.Role)) {
            this.isAccessGranted = true;
            if (this.permission.GrandResourceAction(FullAccessID, auth.Role)) {
                this.isActionGranded = true;
            }
        }
    });
      this.NavList = this.coreService.getSettingsNavList();
   }
}
