import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';

import { LogComponent } from './log.component';
import { ListComponent } from './partials/list.component';
import { ViewComponent } from './partials/modal.component';

/* services */
import { SettingsService } from './services/settings.service';
import { DataService } from './services/data.service';

/* actions */
import { LogAPIActions } from './reducer/actions';

import { PartialModule } from '../../../partials/shared.module';


@NgModule({
  imports: [
    CommonModule,
    PartialModule,
    FormsModule
  ],
  declarations: [
    LogComponent,
    ListComponent,
    ViewComponent
  ],
  entryComponents: [
    ViewComponent
  ],
  exports: [
    LogComponent
  ],
  providers: [
    SettingsService, DataService, LogAPIActions
  ]
})
export class LogModule { }
