import { ROLEAPIAction, ROLEAPIActions, RolesBLL } from './actions';
import { IRoles, IPagination, IRoleFilterOption, IObjectsFilterOption } from './model';
import { tassign } from 'tassign';
import { Action } from 'redux';
import { CoreService } from '../../../../pages/core/coreService';

const INITIAL_STATE: IRoles = {
    roles: [],
    objects: [],
    role_records: 0,
    object_records: 0,
    role_permissions: [],
    loading: false,
    error: null,
    pagination: IPagination,
    role_filteroptions: IRoleFilterOption,
    object_fileoptions: IObjectsFilterOption,
    selectall: false,
    itemsselected: false,
    isroleloaded: false,
    isobjectloaded: false
};


export function createRoleReducer() {
  return function roleReducer(state: IRoles = INITIAL_STATE,
    a: Action): IRoles {

    const action = a as ROLEAPIAction;

    const bll = new RolesBLL();
    if (!action.meta) {
        return state;
    }
    switch (action.type) {
          case ROLEAPIActions.IS_ITEM_SELECTED:
             return tassign(state, { itemsselected: action.payload });

          case ROLEAPIActions.LOAD_ROLE_STARTED:
            return tassign(state, { loading: true, error: null});

          case ROLEAPIActions.LOAD_ROLE_SUCCEEDED:
            return bll.loadRoleSucceeded(state, action);

          case ROLEAPIActions.LOAD_ROLE_STARTED:
              return tassign(state, { loading: false, error: action.error});

          case ROLEAPIActions.LOAD_OBJECT_STARTED:
            return tassign(state, { loading: true, error: null});

          case ROLEAPIActions.LOAD_OBJECT_SUCCEEDED:
            return bll.loadObjectSucceeded(state, action);

          case ROLEAPIActions.LOAD_OBJECT_FAILED:
              return tassign(state, { loading: false, error: action.error});

          /* add record */
          case ROLEAPIActions.ADD_ROLE:
             return bll.addRole(state, action);

         case ROLEAPIActions.ADD_OBJECT:
             return bll.addObject(state, action);

         case ROLEAPIActions.UPDATE_OBJECT:
             return bll.updateObject(state, action);

         case ROLEAPIActions.APPLY_ROLE_CHANGES:
             return bll.applyRoleChanges(state, action);

         case ROLEAPIActions.APPLY_OBJECT_CHANGES:
             return bll.applyObjectChanges(state, action);
         // remove loader
        case ROLEAPIActions.LOAD_END:
        return tassign(state, { loading: false });

        case ROLEAPIActions.REFRESH_PAGINATION:
        return bll.refreshpagination(state, action);

      }


    return state;
  };
}
