import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';

import { TagsComponent } from './tags.components';
import { ListComponent } from './partials/list.component';

/* services */
import { SettingsService } from './services/settings.service';
import { DataService } from './services/data.service';

/* actions */
import { TagsAPIActions } from './reducer/actions';

import { PartialModule } from '../../../partials/shared.module';


@NgModule({
  imports: [
    CommonModule,
    PartialModule,
    FormsModule
  ],
  declarations: [
    TagsComponent,
    ListComponent
  ],
  exports: [
    TagsComponent
  ],
  providers: [
    SettingsService, DataService, TagsAPIActions
  ]
})
export class TagsModule { }
