import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';

import { UserProfileComponent } from './process.component';
import { AvatorComponent } from './partials/avator';
import { UserRoleComponent } from './partials/role.component';
/* services */
import { SettingsService } from '../services/settings.service';
import { DataService } from '../services/data.service';
import { FormService } from '../services/form.service';
/* actions */
import { UserAPIActions } from '../reducer/actions';

import { PartialModule } from '../../../partials/shared.module';

@NgModule({
  imports: [
    CommonModule,
    PartialModule,
    FormsModule
  ],
  declarations: [
    UserProfileComponent,
    AvatorComponent,
    UserRoleComponent
  ],
  exports: [
    UserProfileComponent
  ],
  providers: [
    SettingsService, DataService, FormService, UserAPIActions
  ]
})
export class UserProfileModule { }
