import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
/* custom component */
import { VideoProfileComponent } from './process.component';
import { VideoProfileInfoComponent } from './partials/info.component';
/* services */
import { SettingsService } from '../services/settings.service';
import { DataService } from '../services/data.service';
import { FormService } from '../services/form.service';

/* actions */
import { VideoAPIActions } from '../reducer/actions';
import { PartialModule } from '../../../partials/shared.module';

@NgModule({
  imports: [
    CommonModule,
    PartialModule,
    RouterModule,
    FormsModule
  ],
  declarations: [
    VideoProfileComponent,
    VideoProfileInfoComponent
  ],
  exports: [
    VideoProfileComponent
  ],
  providers: [
    SettingsService, DataService, FormService, VideoAPIActions
  ]
})
export class VideoProfileModule { }
