import { Component, Input, Output, EventEmitter, OnChanges } from '@angular/core';
import { AppConfig } from '../../../../../configs/app.config';

@Component({
  selector: 'app-uploader',
  templateUrl: './uploader.html'
})
export class VideoUploadComponent implements OnChanges {

  constructor(private config: AppConfig) {}

    @Input() uploadedFiles = [];
    @Input() Info: any = {};
    @Output() OnUploaded = new EventEmitter<any>();
    @Output() onRemove = new EventEmitter<any>();

    InitUploader = false;
    uploadoptions = {
        handlerpath: this.config.getConfig('host') + 'api/ffmpeg/upload',
        pickfilecaption: 'Upload Videos',
        pickbuttoncss: 'btn btn-success',
        uploadfilecaption: 'Start Uploading',
        maxfilesize: '1000mb',
        chunksize: '8mb',
        headers: {},
        extensiontitle: 'Video Files',
        extensions: 'mp4',
        filepath: '',
        username: '',
        removehandler: '',
        maxallowedfiles: 5,
        showFileName: false, // show filename with media file
        showoriginalSize: false, // show media in original size
        avatormode: false, // if enabled it will allow single upload and replace existing photo with uploaded photo
        value: []
    };

    ngOnChanges() {
       console.log('handler apth is');
       console.log(this.config.getConfig('host') + 'api/ffmpeg/upload');
       this.uploadoptions.username = this.Info.username;
       if (this.uploadoptions.username !== undefined) {
           this.InitUploader = true;
       }
    }

    /*remove(obj, index, event) {
        if (index > -1) {
          this.uploadedFiles.splice(index, 1);
          this.onRemove.emit({ files: this.uploadedFiles, removedItems: obj });
        }
        event.stopPropagation();
    }*/

    filesUploaded(files: any) {
        //  this.uploadedFiles = []; // need to replace existing image with uploaded image
        console.log('uploaded files');
        console.log(files);
        /*const mediafiles = [];
        for (const file of files) {
            files.push(file);
        }*/
        this.OnUploaded.emit(files);
    }
}
