import { Component, Input, OnInit }  from '@angular/core';
import { FormGroup }                 from '@angular/forms';

import { FormBase }              from './model/base';
import { ControlService }    from './services/control.service';

@Component({
  selector: 'dynamic-form',
  templateUrl: './form.component.html',
  providers: [ ControlService ]
})
export class DynamicFormComponent implements OnInit {

  @Input() controls: FormBase<any>[] = [];
  form: FormGroup;
  payLoad = '';

  constructor(private qcs: ControlService) {  }

  ngOnInit() {
    this.form = this.qcs.toFormGroup(this.controls);
  }

  onSubmit() {
    this.payLoad = JSON.stringify(this.form.value);
    console.log('payload is');
    console.log(this.payLoad);
  }
}
