import { Component, OnInit, EventEmitter, Input, Output } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { select } from '@angular-redux/store';

@Component({
  selector: 'app-pageheading',
  template: `<div class="page-header page-header-default">
      <div class="page-header-content">
        <div class="page-title">
          <h4><i class="icon-arrow-left52 position-left"></i> <span class="text-semibold">{{heading}}</span> - {{subheading}}</h4>
        </div>

        <div class="heading-elements">
          <div class="heading-btn-group">
            <a href="#" class="btn btn-link btn-float has-text"><i class="icon-bars-alt text-primary"></i><span>Statistics</span></a>
            <a href="#" class="btn btn-link btn-float has-text"><i class="icon-calculator text-primary"></i> <span>Invoices</span></a>
            <a href="#" class="btn btn-link btn-float has-text"><i class="icon-calendar5 text-primary"></i> <span>Schedule</span></a>
          </div>
        </div>
      </div>

      <div class="breadcrumb-line">
        <ul class="breadcrumb">
          <li *ngIf="(liststats$ | async).totalrecords > 0">
            Showing <strong>{{(liststats$ | async).first_boundary}}</strong> to <strong>{{(liststats$ | async).last_boundary}}</strong> 
            of <strong>{{(liststats$ | async).totalrecords}}</strong> records
          </li>
        </ul>

        <ul *ngIf="futureFeatures" class="breadcrumb-elements">
          <li><a href="#"><i class="icon-comment-discussion position-left"></i> Support</a></li>
          <li class="dropdown">
            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
              <i class="icon-gear position-left"></i>
              Settings
              <span class="caret"></span>
            </a>

            <ul class="dropdown-menu dropdown-menu-right">
              <li><a href="#"><i class="icon-user-lock"></i> Account security</a></li>
              <li><a href="#"><i class="icon-statistics"></i> Analytics</a></li>
              <li><a href="#"><i class="icon-accessibility"></i> Accessibility</a></li>
              <li class="divider"></li>
              <li><a href="#"><i class="icon-gear"></i> All settings</a></li>
            </ul>
          </li>
        </ul>
      </div>
    </div>`
})
export class PageHeaderComponent implements OnInit {

  @Input() heading = "";
  @Input() subheading = "";
  @Input() Options: any;

  @select(['core', 'liststats'])
  readonly liststats$: Observable<any>;
  
  futureFeatures: boolean = false;
  //@Output() OnSelection = new EventEmitter<number>();
  ngOnInit() {

  }

}
