/**
 * desc：select2
 * how to use: <select2 [(ngModel)]='your_prop' [options]='your_options' [disabled]='your_condition' ></select2>
 */
declare var require: any
const $ = require('jquery');
require('../../../assets/js/plugins/forms/selects/select2.min.js');
import { Component, Input, Output, AfterViewInit, ElementRef, EventEmitter, OnChanges, ViewEncapsulation } from '@angular/core';
import { CustomInputComponent, customInputAccessor } from './custom-input';

@Component({
    selector: 'select2',
    template: `<select class="select" [(ngModel)]="value" [disabled]="disabled">
                <option [value]="item.id" *ngFor="let item of options">{{item.text}}</option>
        </select>`,
    encapsulation: ViewEncapsulation.None,
    providers: [customInputAccessor(Select2Directive)]
})
// ControlValueAccessor: A bridge between a control and a native element.
export class Select2Directive extends CustomInputComponent implements OnChanges, AfterViewInit {
    @Input() options: any[] = []; // object: {id, text} or array: []
    @Input() disabled: boolean = false;
    @Output() onSelect = new EventEmitter<any>();

    select2: any;
    private el: ElementRef;

    constructor(el: ElementRef) {
        super();
        this.el = el;
      //  console.log("triggered");
      //  console.log(this.options);
    }

    ngAfterViewInit() {
        /*if(typeof this.value != "undefined") {
            this.select2.select2('val', this.value);
        }*/
    }

    ngOnChanges() {
        this.select2 = $(this.el.nativeElement).find('select').select2({
           minimumResultsForSearch: Infinity
        }).on("select2:select", (ev: any) => {
            const { id, text } = ev['params']['data'];
            this.value = id;
            this.onSelect.emit({ id, text });
        });

    }
}
