import { Component } from '@angular/core';
import { AppState } from '../../configs/themeSettings';
import {TranslateService} from '@ngx-translate/core';
import { CookieService } from 'ngx-cookie-service';
import { Router } from '@angular/router';
import { select, select$ } from '@angular-redux/store';
import { Observable } from 'rxjs/Observable';
// reducer actions
import { UserService } from '../../pages/users/services/auth.service';
@Component({
  selector: 'app-topnav',
  templateUrl: './navigation.component.html',
  providers: [UserService]
})
export class NavigationComponent {

   LanguageList: any;
   DefaultLanguage = 'en';
   DefaultLanguageComponent: any;

   @select(['users', 'auth'])
   readonly auth$: Observable<any>;
   
   constructor(private translate: TranslateService,
     private cookieService: CookieService,
     private userService: UserService,
     private router: Router) {
       this.LanguageList = AppState.SUPPORTED_LANGS_EXTENDED;
       this.initialize();
   }

   initialize() {
      this.DefaultLanguage = AppState.DEFAULT_LANG;
      for (const lang of this.LanguageList) {
        if (lang.culture === this.DefaultLanguage) {
            this.DefaultLanguageComponent = lang;
        }
      }
   }

   toggleLanguage(lang: any, event) {
      console.log('selected lang ');
      console.log(lang);
      AppState.DEFAULT_LANG = lang.culture;
      this.cookieService.set('_LANG', lang.culture);
      console.log(AppState.DEFAULT_LANG);
      this.translate.setDefaultLang(lang.culture);
      this.initialize();
      event.stopPropagation();
   }

   signout(event: any) {
       this.userService.SignOut();
       this.router.navigate(['']);
       event.stopPropagation();
   }
}
