import { Component, OnInit } from '@angular/core';
import { select } from '@angular-redux/store';
import { Observable } from 'rxjs/Observable';
import { Router } from '@angular/router';

// User Authentication Services
import { UserService } from '../../pages/users/services/auth.service';
import {TranslateService } from '@ngx-translate/core';

@Component({
  selector: 'ma-sidebar',
  templateUrl: './sidebar.component.html',
  providers: [UserService]
})
export class SidebarComponent implements OnInit {

   param = {value: 'world'};
   
   @select(['users', 'auth'])
   readonly auth$: Observable<any>;

   @select(['core', 'features'])
   readonly core$: Observable<any>;

   constructor(
       private userService: UserService,
       private translate: TranslateService,
       private router: Router) { }


    isLoaded = false;
    RoleObject: any = [];
    ngOnInit() {
        this.auth$.subscribe((auth: any) => {
            this.RoleObject = auth.Role;
            this.isLoaded = true;
        });
    }

    signout(event: any) {
        this.userService.SignOut();
        this.router.navigate(['']);
        event.stopPropagation();
    }
}
