import { combineReducers } from 'redux';
import { composeReducers, defaultFormReducer } from '@angular-redux/form';
import { routerReducer } from '@angular-redux/router';


import { createConfigReducer } from '../configs/reducer/reducer';
import { createUsersReducer } from '../pages/users/reducer/reducer';
import { createCoreReducer } from '../pages/core/reducer/reducer';
import { createVideosReducer } from '../pages/videos/reducer/reducer';
import { createAdvertisementReducer } from '../pages/settings/advertisements/reducer/reducer';
import { createBlockIPReducer } from '../pages/settings/blockip/reducer/reducer';
import { createCategoriesReducer } from '../pages/settings/categories/reducer/reducer';
import { createConfigurationsReducer } from '../pages/settings/configurations/reducer/reducer';
import { createDictionaryReducer } from '../pages/settings/dictionary/reducer/reducer';
import { createLanguageReducer } from '../pages/settings/language/reducer/reducer';
import { createLogReducer } from '../pages/settings/log/reducer/reducer';
import { createMailTemplateReducer } from '../pages/settings/mailtemplates/reducer/reducer';
import { createPackagesReducer } from '../pages/settings/packages/reducer/reducer';
import { createTagsReducer } from '../pages/settings/tags/reducer/reducer';
import { createRoleReducer } from '../pages/settings/roles/reducer/reducer';

export const rootReducer = composeReducers(
  defaultFormReducer(),
  combineReducers({
    configuration: createConfigReducer(),
    users: createUsersReducer(),
    core: createCoreReducer(),
    videos: createVideosReducer(),
    advertisement: createAdvertisementReducer(),
    blockip: createBlockIPReducer(),
    categories: createCategoriesReducer(),
    configurations: createConfigurationsReducer(),
    dictionary: createDictionaryReducer(),
    language: createLanguageReducer(),
    log: createLogReducer(),
    mailtemplates: createMailTemplateReducer(),
    packages: createPackagesReducer(),
    tags: createTagsReducer(),
    roles: createRoleReducer(),
    router: routerReducer
  }));
