// export const APIURL = 'http://localhost:4147/';
export class NormalRegex {
    static readonly USERNAME_REGEX = '^[a-z0-9_-]{5,15}$';
    static readonly PASSWORD_REGEX = '^(?=.*[0-9])(?=.*[!@#$%^&*])[a-zA-Z0-9!@#$%^&*]{6,16}$';
    static readonly WEBSITE_REGEX = 'https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)';
}

/* toggle on | off features */
export class AppFeatures {
    static readonly FEATURES = {
        videos: true,
        photos: false,
        audio: true,
        artists: true,
        forums: false,
        qa: false,
        polls: false,
        blogs: false,
        wiki: false
     };
}

/* app support navigation menues */
export class AppNavigation {

    // myaccount top menu // db_id represent id of toggle functionality in database
    // configuration table to help enable / disable feature based on admin settings.
    static readonly MYACCOUNT_MENUS = [
        { title: 'Videos', value: '/videos', db_id: 70, index: 1 },
        { title: 'Audio', value: '/audio', db_id: 71, index: 2 },
        { title: 'Settings', value: '/', db_id: 0, index: 0 }
    ];

    // myaccount sub menus
    static readonly MYACCOUNT_SETTINGS = [
        { title: 'Overview', value: '/', index: 0 },
        { title: 'Profile Setup', value: '/profile-setup', index: 1 },
        { title: 'Email Options', value: '/email-options', index: 2 },
        { title: 'Manage Account', value: '/manage-account', index: 4 },
    ];

     // videos sub menus
     static readonly MYACCOUNT_VIDEOS = [
        { title: 'My Videos', value: '/videos', index: 0 },
        { title: 'Playlists', value: '/videos/playlists' },
        { title: 'Favorited Videos', value: '/videos/favorites', index: 1 },
        { title: 'Liked Videos', value: '/videos/liked', index: 2 }
    ];

    // audio sub menus
    static readonly MYACCOUNT_AUDIO = [
        { title: 'My Audio', value: '/audio', index: 0 },
        // { title: 'Playlists', value: '/audio/playlists', index: 2 },
        { title: 'Favorited Audio', value: '/audio/favorites', index: 2 },
        { title: 'Liked Audio', value: '/audio/liked', index: 3 }
    ];

}

export class NavigationMenuIndex {

    // Index to highlight and load appropriate sub menus for different contents
    // top menu index
    static readonly TOPMENU_SETTINGS_INDEX = 0;
    static readonly TOPMENU_VIDEOS_INDEX = 1;
    static readonly TOPMENU_AUDIO_INDEX = 2;

    // settings sub menu indexes
    static readonly SETTINGS_OVERVIEW_INDEX = 0;
    static readonly SETTINGS_PROFILE_SETUP_INDEX = 1;
    static readonly SETTINGS_EMAIL_OPTIONS_INDEX = 2;
    static readonly SETTINGS_MANAGE_ACCOUNT_INDEX = 4;

    // videos sub menu indexes
    static readonly VIDEOS_MY_INDEX = 0;
    static readonly VIDEOS_FAVORITES_INDEX = 1;
    static readonly VIDEOS_LIKED_INDEX = 2;
    static readonly VIDEOS_PLAYLIST_INDEX = 3;
    // audio sub menu indexes
    static readonly AUDIO_MY_INDEX = 0;
    static readonly AUDIO_FAVORITES_INDEX = 1;
    static readonly AUDIO_LIKED_INDEX = 2;


}

export class ContentTypes {
    static readonly MAILTEMPLATE_TYPES = [
        { title: 'General', value: '0' },
        { title: 'Members', value: '1' },
        { title: 'Videos', value: '2' },
        { title: 'Audio', value: '3' },
        { title: 'Blogs', value: '8' }
    ];

    static readonly CATEGORY_TYPES = [
        { title: 'Videos', value: '0' },
        { title: 'Audio', value: '7' },
        { title: 'Blogs', value: '6' },
        { title: 'Abuse Report', value: '4' },
        { title: 'Channels', value: '2' }
    ];

    static readonly TAG_TYPES = [
        { title: 'Videos', value: '0' },
        { title: 'Audio', value: '4' },
        { title: 'Blogs', value: '3' },
    ];

    static readonly ARTIST_SETTING_TYPES = [
        { title: 'Biography', value: '1' },
        { title: 'Services', value: '2' },
        { title: 'Rate Rules', value: '3' },
        { title: 'Social Attributes', value: '4' }
    ];

    static readonly ALBUM_TYPES = [
        { title: 'Videos', value: 1 },
        { title: 'Audio', value: 2 }
    ];

    static readonly MEDIA_TYPES = [
        { title: 'Video', value: 0 },
        { title: 'Audio', value: 1 }
    ];

    static readonly BADGES_TYPES = [
        { title: 'Badges', value: '1', add_title: 'Add Badge', add_tooltip: 'Add new badge' },
        { title: 'Rewards', value: '2', add_title: 'Add Reward', add_tooltip: 'Add new reward' },
        { title: 'Levels', value: '3', add_title: 'Add Level', add_tooltip: 'Add new level' },
        { title: 'Points', value: '4', add_title: 'Add Points', add_tooltip: 'Add new points' },
        { title: 'Credits', value: '5', add_title: 'Add Credits', add_tooltip: 'Add new credits' },
        { title: 'Packages', value: '6', add_title: 'Add Packages', add_tooltip: 'Add new packages' }
    ];

    static readonly ROLE_TYPES = [
        { title: 'Roles', value: '1', add_title: 'Add Role', add_tooltip: 'Add new role' },
        { title: 'Role Objects', value: '2', add_title: 'Add Role Object', add_tooltip: 'Add new role' }
    ];

    static readonly USER_TYPES = [
        { title: 'User', value: '0' },
        { title: 'Administrator', value: '1' },
        { title: 'Certified User', value: '2' }
    ];

}
