import { Injectable } from '@angular/core';
import { dispatch } from '@angular-redux/store';
import { FluxStandardAction } from 'flux-standard-action';
// Flux-standard-action gives us stronger typing of our actions.

type Payload = any;
interface MetaData { };
export type CoreAPIAction = FluxStandardAction<Payload, MetaData>;

@Injectable()
export class CoreAPIActions {

  static readonly SHOWMESSAGE = 'SHOWMESSAGE';
  static readonly NOTIFY = 'NOTIFY';
  static readonly REFRESHLISTSTATUS = 'REFRESHLISTSTATUS';
  static readonly RESETSTATS = 'RESET_STATS';
  @dispatch()
  showMessage = (payload: Payload): CoreAPIAction => ({
    type: CoreAPIActions.SHOWMESSAGE,
    meta: { },
    payload,
  })

  @dispatch()
  Notify = (payload: Payload): CoreAPIAction => ({
    type: CoreAPIActions.NOTIFY,
    meta: { },
    payload,
  })

  @dispatch()
  refreshListStats = (payload: Payload): CoreAPIAction => ({
    type: CoreAPIActions.REFRESHLISTSTATUS,
    meta: { },
    payload,
  })

  @dispatch()
  resetStats = (): CoreAPIAction => ({
      type: CoreAPIActions.RESETSTATS,
      meta: { },
      payload: null
  })
}
