import { CoreAPIAction, CoreAPIActions } from './actions';
import { AppFeatures } from '../../../configs/settings';
import { ICoreState } from './model';
// import { indexBy, prop } from 'ramda';
import { tassign } from 'tassign';
import { Action } from 'redux';

const INITIAL_STATE: ICoreState = {
    message: {
        alert: 'danger',
        heading: '',
        message: ''
    },
    notify: {
      title: '',
      text: '',
      css: ''
    },
    liststats: {
      first_boundary: 0,
      last_boundary: 0,
      totalrecords: 0
    },
    features: AppFeatures.FEATURES
};

export function createCoreReducer() {
  return function usersReducer(state: ICoreState = INITIAL_STATE,
    a: Action): ICoreState {

    const action = a as CoreAPIAction;

    if (!action.meta) {
       return state;
    }
    switch (action.type) {

      case CoreAPIActions.SHOWMESSAGE:
        return tassign(state, {
          message: action.payload
        });
      case CoreAPIActions.NOTIFY:
        return tassign(state, {
          notify: { title: action.payload.title, text: action.payload.text, css: action.payload.css }
        });
      case CoreAPIActions.REFRESHLISTSTATUS:
         const obj = {
            first_boundary: 1,
            last_boundary: action.payload.pagesize,
            totalrecords: action.payload.totalrecords
         };
         console.log('trigger stats ' + action.payload.totalrecords);
         console.log(obj);
         if (action.payload.totalrecords > 0) {
             obj.first_boundary = ((action.payload.pagenumber - 1) * action.payload.pagesize) + 1;
         }

         obj.last_boundary = ((action.payload.pagenumber - 1) * action.payload.pagesize) + action.payload.pagesize;

         if (obj.last_boundary > action.payload.totalrecords) {
            obj.last_boundary = action.payload.totalrecords;
         }
         return tassign(state, { liststats: Object.assign({}, state.liststats, obj) });
         // return tassign(state, { liststats: obj  });

         case CoreAPIActions.RESETSTATS:
            const init_obj = {
              first_boundary: 0,
              last_boundary: 0,
              totalrecords: 0
            };
            console.log('reset stats');
            console.log(init_obj);
         return tassign(state, { liststats: Object.assign({}, state.liststats, init_obj) });

      }

    return state;
  };
}
