import { Component, Input, ViewEncapsulation, OnInit } from '@angular/core';
import { ButtonCSS, ICONCSS, ThemeCSS } from '../../configs/themeSettings';
import { Router } from '@angular/router';
import { select, select$ } from '@angular-redux/store';
import { Observable } from 'rxjs/Observable';
import { FormService } from '../../pages/users/services/form.service';
import { DataService } from '../../pages/users/services/data.service';
import { SettingsService } from '../../pages/users/services/settings.service';
// shared services
import { CoreService } from '../../pages/core/coreService';
import { CoreAPIActions } from '../../pages/core/reducer/actions';

// reducer actions
import { UserAPIActions } from '../../pages/users/reducer/actions';
import { fadeInAnimation } from '../../animations/core';
import { CookieService } from 'ngx-cookie-service';

@Component({
    selector: 'app-dashboard',
    templateUrl: './dashboard.html',
    encapsulation: ViewEncapsulation.None,
    providers: [DataService, SettingsService, UserAPIActions, FormService, CookieService]
})
export class DashboardComponent implements OnInit {

  controls: any;
  showLoader = false;
  submitText = 'Login';
  submitCss = 'btn btn-info btn-lg btn-block text-uppercase waves-effect waves-light';

  constructor(
    private settingService: SettingsService,
    private dataService: DataService,
    private coreService: CoreService,
    private coreActions: CoreAPIActions,
    private actions: UserAPIActions,
    private formService: FormService,
    private router: Router,
    private cookieService: CookieService
    ) {}

    @select(['users', 'auth'])
    readonly auth$: Observable<any>;

    uploadedFiles = [];
    User: any = {};
    ngOnInit() {
        this.auth$.subscribe(Info => {
            this.User = Info.User;
            const _files = [];
                if (this.User.img_url !== '') {
                   _files.push();
                   this.uploadedFiles.push ({
                        fname: this.User.img_url,
                        filename: this.User.img_url,
                        filetype: '.jpg',
                        url: this.User.img_url
                    });
                }
        });
    }

    OnUploadedImages(images: any) {
        this.dataService.UpdateThumb(this.User, images);
    }
}


