import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';

import { DashboardComponent } from './dashboard.component';
import { PartialModule } from '../../partials/shared.module';

import { NavigationMenuIndex } from '../../configs/settings';

const routes: Routes = [{
        path: '',
        data: {
        title: 'My Account',
        topmenuIndex: NavigationMenuIndex.TOPMENU_SETTINGS_INDEX,
        leftmenuIndex: NavigationMenuIndex.SETTINGS_OVERVIEW_INDEX,
        urls: [
            {title: 'My Account', url: '/'},
            {title: 'Overview'}]
        },
        component: DashboardComponent
}];

@NgModule({
    imports: [
        FormsModule,
        CommonModule,
        PartialModule,
        RouterModule.forChild(routes)
    ],
    declarations: [
        DashboardComponent
    ]
})
export class DashboardModule { }
