export class FormBase<T> {
  value: T;
  key: string;
  label: string;
  labelasheading?: boolean;
  required: boolean;
  email: boolean;
  minLength?: number;
  maxLength?: number;
  pattern?: string;
  order: number;
  controlType: string;
  checked?: boolean;
  checklist?: any;
  helpblock?: any;
  uploadoptions?: any;
  colsize?: any;
  disabled?: any;
  items?: any;
  placeholder?: string;
  constructor(options: {
      value?: T,
      key?: string,
      label?: string,
      required?: boolean,
      email?: boolean,
      minLength?: number,
      maxLength?: number,
      pattern?: string,
      order?: number,
      controlType?: string,
      checked?: boolean,
      checklist?: any,

      helpblock?: any,
      uploadoptions?: any,
      colsize?: any,
      disabled?: any,
      items?: any, // for select dropdown
      placeholder?: string,
      labelasheading?: boolean
    } = {}) {
    this.value = options.value;
    this.key = options.key || '';
    this.minLength = options.minLength;
    this.maxLength = options.maxLength;
    this.pattern = options.pattern;
    this.label = options.label || '';
    this.required = !!options.required;
    this.email = !!options.email;
    this.order = options.order === undefined ? 1 : options.order;
    this.controlType = options.controlType || '';
    this.checked = options.checked === undefined ? false : options.checked;
    this.checklist = options.checklist === undefined ? [] : options.checklist;
    this.helpblock = options.helpblock === undefined ? '' : options.helpblock;
    this.uploadoptions = options.uploadoptions === undefined ? '' : options.uploadoptions;
    this.colsize = options.colsize === undefined ? 'col-md-12' : options.colsize;
    this.disabled = options.disabled === undefined ? false : options.disabled;
    this.items = options.items === undefined ? [] : options.items;
    this.placeholder = options.placeholder === undefined ? '' : options.placeholder;
    this.labelasheading = options.labelasheading === undefined ? false : options.labelasheading;
  }
}
