import { Component, OnInit } from '@angular/core';
import { AppNavigation } from '../../configs/settings';
import { Router, NavigationEnd, ActivatedRoute } from '@angular/router';
import 'rxjs/add/operator/filter';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/mergeMap';
import { ConfigDataService } from '../../configs/services/data.service';
import {TranslateService} from '@ngx-translate/core';
@Component({
  selector: 'app-leftnavigation',
  templateUrl: './left-navigation.html',
  providers: [ConfigDataService]
})
export class LeftNavigationComponent  implements OnInit {

   MyAccount_Menu: any = AppNavigation.MYACCOUNT_SETTINGS;
   leftMenuIndex = 0;
   topMenuIndex = 0;
   constructor(
        private router: Router,
        private activatedRoute: ActivatedRoute,
        private configdata: ConfigDataService,
        public translate: TranslateService
    ) {}

    ngOnInit(): void {
      this
        .router.events
        .filter(event => event instanceof NavigationEnd)
        .map(() => this.activatedRoute)
        .map(route => {
            while (route.firstChild) { route = route.firstChild; }
            return route;
        })
        .filter(route => route.outlet === 'primary')
        .mergeMap(route => route.data)
        .subscribe((event) => {
            if (event['leftmenuIndex'] !== undefined) {
                this.leftMenuIndex = event['leftmenuIndex'];
            }
            if (event['topmenuIndex'] !== undefined) {
                this.topMenuIndex = event['topmenuIndex'];
            }
            this.initMenus();
        });
    }

    initMenus() {
         switch (this.topMenuIndex) {
             // settings
             case 0:
                this.MyAccount_Menu = AppNavigation.MYACCOUNT_SETTINGS;
             break;
             case 1:
                this.MyAccount_Menu = AppNavigation.MYACCOUNT_VIDEOS;
             break;
             case 2:
                this.MyAccount_Menu = AppNavigation.MYACCOUNT_AUDIO;
             break;
         }
    }
}
