import { Component, OnInit } from '@angular/core';
import { AppNavigation } from '../../configs/settings';
import { Router, NavigationEnd, ActivatedRoute } from '@angular/router';
import 'rxjs/add/operator/filter';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/mergeMap';

import { ConfigDataService } from '../../configs/services/data.service';
import {TranslateService} from '@ngx-translate/core';

@Component({
  selector: 'app-topnavigation',
  templateUrl: './topnav-component.html',
  providers: [ConfigDataService]
})
export class TopNavigationComponent  implements OnInit {

   MyAccount_Menu: any = AppNavigation.MYACCOUNT_MENUS;
   
   constructor(
        private router: Router,
        private activatedRoute: ActivatedRoute,
        private configdata: ConfigDataService,
        public translate: TranslateService
    ) {}

    topMenuIndex = 0;

    ngOnInit(): void {
      this
        .router.events
        .filter(event => event instanceof NavigationEnd)
        .map(() => this.activatedRoute)
        .map(route => {
            while (route.firstChild) { route = route.firstChild; }
            return route;
        })
        .filter(route => route.outlet === 'primary')
        .mergeMap(route => route.data)
        .subscribe((event) => {
            if (event['topmenuIndex'] !== undefined) {
                this.topMenuIndex = event['topmenuIndex'];
            }
        });
    }
}
