// REDUX Store Implementation
import { NgModule } from '@angular/core';
import { NgReduxModule, NgRedux, DevToolsExtension } from '@angular-redux/store';
import { NgReduxRouterModule, NgReduxRouter } from '@angular-redux/router';
import { provideReduxForms } from '@angular-redux/form';

import { IAppState } from './model';
import { rootReducer } from './reducers';

@NgModule({
  imports: [NgReduxModule, NgReduxRouterModule.forRoot()],
  providers: [],
})
export class StoreModule {
  constructor(
    public store: NgRedux<IAppState>,
    devTools: DevToolsExtension,
    ngReduxRouter: NgReduxRouter
  ) {

    store.configureStore(
      rootReducer,
      {},
      [],
      devTools.isEnabled() ? [ devTools.enhancer() ] : []);

      // Enable syncing of Angular router state with our Redux store.
      if (ngReduxRouter) {
         ngReduxRouter.initialize();
      }

      // Enable syncing of Angular form state with our Redux store.
      provideReduxForms(store);
  }
}
