import { combineReducers } from 'redux';
import { composeReducers, defaultFormReducer } from '@angular-redux/form';
import { routerReducer } from '@angular-redux/router';

import { createConfigReducer } from '../configs/reducer/reducer';
import { createUsersReducer } from '../pages/users/reducer/reducer';

import { createCoreReducer } from '../pages/core/reducer/reducer';
import { createVideosReducer } from '../pages/videos/reducer/reducer';

export const rootReducer = composeReducers(
  defaultFormReducer(),
  combineReducers({

    configuration: createConfigReducer(),
    users: createUsersReducer(),
    core: createCoreReducer(),
    videos: createVideosReducer(),

    router: routerReducer
  }));
