﻿using System.Web.Optimization;

namespace JgnEnt
{
    public class BundleConfig
    {
        // For more information on bundling, visit http://go.microsoft.com/fwlink/?LinkId=301862
        public static void RegisterBundles(BundleCollection bundles)
        {          

            bundles.Add(new ScriptBundle("~/bundles/jquery").Include(
                         "~/Scripts/jquery-{version}.js"));

            bundles.Add(new ScriptBundle("~/bundles/jqueryval").Include(
                        "~/Scripts/jquery.validate*"));
            
            // Use the Development version of Modernizr to develop with and learn from. Then, when you’re
            // ready for production, use the build tool at http://modernizr.com to pick only the tests you need
            bundles.Add(new ScriptBundle("~/bundles/modernizr").Include(
                            "~/Scripts/modernizr-*"));
                       
            bundles.Add(new StyleBundle("~/bootswatch/css").Include(
               "~/Assets/css/style.css",
               "~/Assets/css/app.css",
               "~/Assets/rating/rating24.css"
            ));
            
            bundles.Add(new ScriptBundle("~/bootswatch/js").Include(
                "~/node_modules/jquery/dist/jquery.min.js",
                "~/node_modules/popper.js/dist/umd/popper.min.js",
                "~/node_modules/bootstrap/dist/js/bootstrap.min.js",
                "~/Assets/js/custom.js"));

            // fotorama plugin
            bundles.Add(new StyleBundle("~/fotorama/css").Include(
                "~/Assets/plugins/fotorama-4.6.4/fotorama.css"
            ));

            bundles.Add(new ScriptBundle("~/fotorama/js").Include(
               "~/Assets/plugins/fotorama-4.6.4/fotorama.js"));

            // chosen plugin
            bundles.Add(new StyleBundle("~/chosen/css").Include(
                "~/node_modules/bootstrap4c-chosen/dist/css/component-chosen.min.css"
            ));

            bundles.Add(new ScriptBundle("~/chosen/js").Include(
               "~/node_modules/chosen-js/chosen.jquery.js"));

            // video js
            bundles.Add(new StyleBundle("~/videojs/css").Include(
                "~/node_modules/video.js/dist/video-js.min.css"
            ));

            bundles.Add(new ScriptBundle("~/videojs/js").Include(
               "~/node_modules/video.js/dist/video.min.js",
               "~/node_modules/@videojs/http-streaming/dist/videojs-http-streaming.min.js"));

            // mediaelement (audio player)
            bundles.Add(new StyleBundle("~/mediaelement/css").Include(
                "~/node_modules/mediaelement/build/mediaelementplayer.min.css"
            ));

            bundles.Add(new ScriptBundle("~/mediaelement/js").Include(
               "~/node_modules/mediaelement/build/mediaelement.min.js"));

            // Angular 6+ JS Reference (My Account)
            bundles.Add(new ScriptBundle("~/angular/myaccount").Include(
              "~/scripts/lib/myaccount/runtime.js",
              "~/scripts/lib/myaccount/polyfills.js",
              "~/scripts/lib/myaccount/scripts.js",
              "~/scripts/lib/myaccount/main.js"));

            // Control Panel Assets
            bundles.Add(new StyleBundle("~/controlpanel/css").Include(
               "~/assets/admin/plugins/bootstrap/css/bootstrap.min.css",
               "~/assets/admin/css/style.css",
               "~/assets/admin/tinymce/skins/lightgray/skin.min.css",
               "~/assets/admin/tinymce/skins/lightgray/content.min.css",
               "~/assets/admin/css/colors/megna-dark.css"
            ));
            // Angular 6+ JS Reference (Admin Control Panel)
            bundles.Add(new ScriptBundle("~/angular/controlpanel").Include(
              "~/scripts/lib/admin/runtime.js",
              "~/scripts/lib/admin/polyfills.js",
              "~/scripts/lib/admin/scripts.js",
              "~/scripts/lib/admin/main.js"));
      
            bundles.Add(new ScriptBundle("~/bundles/ckeditor").Include(
                       "~/assets/plugins/ckeditor_basic/ckeditor.js",
                        "~/assets/plugins/ckeditor_basic/samples/js/sample.js"));

            bundles.Add(new ScriptBundle("~/bundles/ckeditorstandard").Include(
                      "~/assets/plugins/ckeditor/ckeditor.js",
                       "~/assets/plugins/ckeditor/samples/js/sample.js"));

            bundles.Add(new ScriptBundle("~/bundles/chosenjs").Include(
                    "~/assets/plugins/chosen/chosen.js"
            ));

            bundles.Add(new ScriptBundle("~/bundles/fitvids").Include(
                   "~/assets/fitvids/jquery.fitvids.js"
           ));

            bundles.Add(new ScriptBundle("~/bundles/fotorama").Include(
                  "~/assets/js/fotorama.js"
            ));

            bundles.Add(new ScriptBundle("~/bundles/carousel").Include(
                 "~/assets/js/owl-carousel.js"
           ));

            bundles.Add(new StyleBundle("~/Content/wysibb").Include(
                     "~/assets/plugins/sceditor-2.1.3/minified/themes/default.min.css"));

            bundles.Add(new ScriptBundle("~/bundles/wysibb").Include(
                     "~/assets/plugins/sceditor-2.1.3/minified/sceditor.min.js",
                     "~/assets/plugins/sceditor-2.1.3/minified/formats/bbcode.min.js"));

            BundleTable.EnableOptimizations = false;
        }
    }
}
