﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace JgnEnt
{
    public class RouteConfig
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                  null,
                  "search/result/{term}",
                  new { controller = "search", action = "result" },
                  new[] { "JgnEnt.Controllers" }
            );

           

            #region Public Pages


            routes.MapRoute(
                null,
                "album/{pid}/{mediaid}/{title}",
                new { controller = "album", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                null,
                "album/{pid}/{title}",
                new { controller = "album", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                null,
                "media/{pid}/{title}",
                new { controller = "media", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "videoframe/{pid}/{title}",
               new { controller = "videoframe", action = "Index" },
               new[] { "JgnEnt.Controllers" }
            );
           
            #region Audio

            // audio category processing routes
            routes.MapRoute(
                     null,
                     "audio/category/filter/{title}/{filter}",
                     new { controller = "audio", action = "category" },
                     new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                   null,
                   "audio/category/filter/{title}/{filter}/{pagenumber}",
                   new { controller = "audio", action = "category" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                      null,
                      "audio/category/filter/{title}/{filter}/{order}",
                      new { controller = "audio", action = "category" },
                      new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                  null,
                  "audio/category/filter/{title}/{filter}/{order}/{pagenumber}",
                  new { controller = "audio", action = "category" },
                  new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                    null,
                    "audio/category/{title}/{order}",
                    new { controller = "audio", action = "category" },
                    new[] { "JgnEnt.Controllers" }
              );
            routes.MapRoute(
                  null,
                  "audio/category/{title}/{order}/{pagenumber}",
                  new { controller = "audio", action = "category" },
                  new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                   null,
                   "audio/category/{title}",
                   new { controller = "audio", action = "category" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                 null,
                 "audio/category/{title}/{pagenumber}",
                 new { controller = "audio", action = "category" },
                 new[] { "JgnEnt.Controllers" }
            );

            // blogs tag processing routes
            routes.MapRoute(
                  null,
                  "audio/tag/filter/{title}/{filter}",
                  new { controller = "audio", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "audio/tag/filter/{title}/{filter}/{pagenumber}",
                  new { controller = "audio", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                 null,
                 "audio/tag/filter/{title}/{filter}/{order}",
                 new { controller = "audio", action = "tag" },
                 new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "audio/tag/filter/{title}/{filter}/{order}/{pagenumber}",
                  new { controller = "audio", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "audio/tag/{title}/{order}/{pagenumber}",
               new { controller = "audio", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "audio/tag/{title}/{order}",
               new { controller = "audio", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "audio/tag/{title}/{order}/{pagenumber}",
               new { controller = "audio", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "audio/tag/{title}",
               new { controller = "audio", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
               null,
               "audio/tag/{title}/{pagenumber}",
               new { controller = "audio", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );

            // audio archive processing routes

            routes.MapRoute(
               null,
               "audio/archive/{month}/{year}/{order}",
               new { controller = "audio", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
               null,
               "audio/archive/{month}/{year}/{order}/{pagenumber}",
               new { controller = "audio", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
              null,
              "audio/archive/{month}/{year}",
              new { controller = "audio", action = "archive" },
              new[] { "JgnEnt.Controllers" }
           );

            routes.MapRoute(
               null,
               "audio/archive/{month}/{year}/{pagenumber}",
               new { controller = "audio", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "audio/searchoptions",
                new { controller = "audio", action = "searchoptions" },
                new[] { "JgnEnt.Controllers" }
            );
            /* audio categories */
            routes.MapRoute(
                  null,
                  "audio/categories",
                  new { controller = "audio", action = "categories" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "audio/categories/{pagenumber}",
                  new { controller = "audio", action = "categories" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* audio archive list */
            routes.MapRoute(
                  null,
                  "audio/archivelist",
                  new { controller = "audio", action = "archivelist" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* audio taglist routes */
            routes.MapRoute(
                  null,
                  "audio/taglist",
                  new { controller = "audio", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "audio/taglist/{pagenumber}",
                  new { controller = "audio", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "audio/taglist/search/{term}",
                  new { controller = "audio", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "audio/taglist/search/{term}/{pagenumber}",
                  new { controller = "audio", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* search routes */
            routes.MapRoute(
                   null,
                   "audio/queryresult",
                   new { controller = "audio", action = "queryresult" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                  null,
                  "audio/search/filter/{filter}/{term}",
                  new { controller = "audio", action = "search" },
                  new[] { "JgnEnt.Controllers" }
              );

            routes.MapRoute(
                null,
                "audio/search/filter/{filter}/{term}/{pagenumber}",
                new { controller = "audio", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "audio/search/{term}",
                new { controller = "audio", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "audio/search/{term}/{pagenumber}",
                new { controller = "audio", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );


            routes.MapRoute(
                null,
                "audio/page/{pagenumber}",
                new { controller = "audio", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "audio/added/{filter}",
                new { controller = "audio", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                   null,
                   "audio/added/{filter}/{pagenumber}",
                   new { controller = "audio", action = "Index" },
                   new[] { "JgnEnt.Controllers" }
             );

            routes.MapRoute(
                 null,
                 "audio/{order}",
                 new { controller = "audio", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                 null,
                 "audio/{order}/{pagenumber}",
                 new { controller = "audio", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );


            #endregion

            #region Videos

            // video category processing routes
            routes.MapRoute(
                     null,
                     "videos/category/filter/{title}/{filter}",
                     new { controller = "videos", action = "category" },
                     new[] { "JgnEnt.Controllers" }
              );
            routes.MapRoute(
                   null,
                   "videos/category/filter/{title}/{filter}/{pagenumber}",
                   new { controller = "videos", action = "category" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                      null,
                      "videos/category/filter/{title}/{filter}/{order}",
                      new { controller = "videos", action = "category" },
                      new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                  null,
                  "videos/category/filter/{title}/{filter}/{order}/{pagenumber}",
                  new { controller = "videos", action = "category" },
                  new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                    null,
                    "videos/category/{title}/{order}",
                    new { controller = "videos", action = "category" },
                    new[] { "JgnEnt.Controllers" }
              );
              routes.MapRoute(
                    null,
                    "videos/category/{title}/{order}/{pagenumber}",
                    new { controller = "videos", action = "category" },
                    new[] { "JgnEnt.Controllers" }
              );
              
              routes.MapRoute(
                     null,
                     "videos/category/{title}",
                     new { controller = "videos", action = "category" },
                     new[] { "JgnEnt.Controllers" }
              );

              routes.MapRoute(
                   null,
                   "videos/category/{title}/{pagenumber}",
                   new { controller = "videos", action = "category" },
                   new[] { "JgnEnt.Controllers" }
              );

            // video tag processing routes
            routes.MapRoute(
                  null,
                  "videos/tag/filter/{title}/{filter}",
                  new { controller = "videos", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "videos/tag/filter/{title}/{filter}/{pagenumber}",
                  new { controller = "videos", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                 null,
                 "videos/tag/filter/{title}/{filter}/{order}",
                 new { controller = "videos", action = "tag" },
                 new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "videos/tag/filter/{title}/{filter}/{order}/{pagenumber}",
                  new { controller = "videos", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "videos/tag/{title}/{order}/{pagenumber}",
               new { controller = "videos", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "videos/tag/{title}/{order}",
               new { controller = "videos", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "videos/tag/{title}/{order}/{pagenumber}",
               new { controller = "videos", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "videos/tag/{title}",
               new { controller = "videos", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
               null,
               "videos/tag/{title}/{pagenumber}",
               new { controller = "videos", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );

            // video archive processing routes

            routes.MapRoute(
               null,
               "videos/archive/{month}/{year}/{order}",
               new { controller = "videos", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
               null,
               "videos/archive/{month}/{year}/{order}/{pagenumber}",
               new { controller = "videos", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
              null,
              "videos/archive/{month}/{year}",
              new { controller = "videos", action = "archive" },
              new[] { "JgnEnt.Controllers" }
           );

            routes.MapRoute(
               null,
               "videos/archive/{month}/{year}/{pagenumber}",
               new { controller = "videos", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "videos/searchoptions",
                new { controller = "videos", action = "searchoptions" },
                new[] { "JgnEnt.Controllers" }
            );
            /* video categories */
            routes.MapRoute(
                  null,
                  "videos/categories",
                  new { controller = "videos", action = "categories" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "videos/categories/{pagenumber}",
                  new { controller = "videos", action = "categories" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* video archive list */
            routes.MapRoute(
                  null,
                  "videos/archivelist",
                  new { controller = "videos", action = "archivelist" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* video taglist routes */
            routes.MapRoute(
                  null,
                  "videos/taglist",
                  new { controller = "videos", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "videos/taglist/{pagenumber}",
                  new { controller = "videos", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "videos/taglist/search/{term}",
                  new { controller = "videos", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "videos/taglist/search/{term}/{pagenumber}",
                  new { controller = "videos", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* search routes */
            routes.MapRoute(
                   null,
                   "videos/queryresult",
                   new { controller = "videos", action = "queryresult" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                  null,
                  "videos/search/filter/{filter}/{term}",
                  new { controller = "videos", action = "search" },
                  new[] { "JgnEnt.Controllers" }
              );

            routes.MapRoute(
                null,
                "videos/search/filter/{filter}/{term}/{pagenumber}",
                new { controller = "videos", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "videos/search/{term}",
                new { controller = "videos", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );
                       
            routes.MapRoute(
                null,
                "videos/search/{term}/{pagenumber}",
                new { controller = "videos", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );
           

            routes.MapRoute(
                null,
                "videos/page/{pagenumber}",
                new { controller = "videos", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "videos/added/{filter}",
                new { controller = "videos", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                   null,
                   "videos/added/{filter}/{pagenumber}",
                   new { controller = "videos", action = "Index" },
                   new[] { "JgnEnt.Controllers" }
             );

            routes.MapRoute(
                 null,
                 "videos/{order}",
                 new { controller = "videos", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );
            
            routes.MapRoute(
                 null,
                 "videos/{order}/{pagenumber}",
                 new { controller = "videos", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );


            /*routes.MapRoute(
                 null,
                 "videos/Index/{order}",
                 new { controller = "videos", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                null,
                "videos/Index/{order}/{id}",
                new { controller = "videos", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );
           
            routes.MapRoute(
                 null,
                 "videos/featured/{order}",
                 new { controller = "videos", action = "featured" },
                 new[] { "JgnEnt.Controllers" }
             );

            routes.MapRoute(
                 null,
                 "videos/today/{order}",
                 new { controller = "videos", action = "today" },
                 new[] { "JgnEnt.Controllers" }
             );

            routes.MapRoute(
               null,
               "videos/thisweek/{order}",
               new { controller = "videos", action = "thisweek" },
               new[] { "JgnEnt.Controllers" }
           );

            routes.MapRoute(
              null,
              "videos/thismonth/{order}",
              new { controller = "videos", action = "thismonth" },
              new[] { "JgnEnt.Controllers" }
          ); */
            #endregion

            #region Albums

            // albums feed routes

            routes.MapRoute(
                 null,
                 "albums/atom/{type}",
                 new { controller = "albums", action = "atom" },
                 new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                 null,
                 "albums/rss/{type}",
                 new { controller = "albums", action = "rss" },
                 new[] { "JgnEnt.Controllers" }
            );

            // albums category processing routes
            routes.MapRoute(
                     null,
                     "albums/{type}/category/filter/{title}/{filter}",
                     new { controller = "albums", action = "category" },
                     new[] { "JgnEnt.Controllers" }
              );
            routes.MapRoute(
                   null,
                   "albums/{type}/category/filter/{title}/{filter}/{pagenumber}",
                   new { controller = "albums", action = "category" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                      null,
                      "albums/{type}/category/filter/{title}/{filter}/{order}",
                      new { controller = "albums", action = "category" },
                      new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                  null,
                  "albums/{type}/category/filter/{title}/{filter}/{order}/{pagenumber}",
                  new { controller = "albums", action = "category" },
                  new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                    null,
                    "albums/{type}/category/{title}/{order}",
                    new { controller = "albums", action = "category" },
                    new[] { "JgnEnt.Controllers" }
              );
            routes.MapRoute(
                  null,
                  "albums/{type}/category/{title}/{order}/{pagenumber}",
                  new { controller = "albums", action = "category" },
                  new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                   null,
                   "albums/{type}/category/{title}",
                   new { controller = "albums", action = "category" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                 null,
                 "albums/{type}/category/{title}/{pagenumber}",
                 new { controller = "albums", action = "category" },
                 new[] { "JgnEnt.Controllers" }
            );

            // video tag processing routes
            routes.MapRoute(
                  null,
                  "albums/{type}/tag/filter/{title}/{filter}",
                  new { controller = "albums", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "albums/{type}/tag/filter/{title}/{filter}/{pagenumber}",
                  new { controller = "albums", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                 null,
                 "albums/{type}/tag/filter/{title}/{filter}/{order}",
                 new { controller = "albums", action = "tag" },
                 new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "albums/{type}/tag/filter/{title}/{filter}/{order}/{pagenumber}",
                  new { controller = "albums", action = "tag" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "albums/{type}/tag/{title}/{order}/{pagenumber}",
               new { controller = "albums", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "albums/{type}/tag/{title}/{order}",
               new { controller = "albums", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "albums/{type}/tag/{title}/{order}/{pagenumber}",
               new { controller = "albums", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
               null,
               "albums/{type}/tag/{title}",
               new { controller = "albums", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
               null,
               "albums/{type}/tag/{title}/{pagenumber}",
               new { controller = "albums", action = "tag" },
               new[] { "JgnEnt.Controllers" }
            );

            // video archive processing routes

            routes.MapRoute(
               null,
               "albums/{type}/archive/{month}/{year}/{order}",
               new { controller = "albums", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
               null,
               "albums/{type}/archive/{month}/{year}/{order}/{pagenumber}",
               new { controller = "albums", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
              null,
              "albums/{type}/archive/{month}/{year}",
              new { controller = "albums", action = "archive" },
              new[] { "JgnEnt.Controllers" }
           );

            routes.MapRoute(
               null,
               "albums/{type}/archive/{month}/{year}/{pagenumber}",
               new { controller = "albums", action = "archive" },
               new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "albums/{type}/searchoptions",
                new { controller = "albums", action = "searchoptions" },
                new[] { "JgnEnt.Controllers" }
            );
            /* video categories */
            routes.MapRoute(
                  null,
                  "albums/{type}/categories",
                  new { controller = "albums", action = "categories" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "albums/{type}/categories/{pagenumber}",
                  new { controller = "albums", action = "categories" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* video archive list */
            routes.MapRoute(
                  null,
                  "albums/{type}/archivelist",
                  new { controller = "albums", action = "archivelist" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* video taglist routes */
            routes.MapRoute(
                  null,
                  "albums/{type}/taglist",
                  new { controller = "albums", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "albums/{type}/taglist/{pagenumber}",
                  new { controller = "albums", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "albums/{type}/taglist/search/{term}",
                  new { controller = "albums", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                  null,
                  "albums/{type}/taglist/search/{term}/{pagenumber}",
                  new { controller = "albums", action = "taglist" },
                  new[] { "JgnEnt.Controllers" }
            );
            /* search routes */
            routes.MapRoute(
                   null,
                   "albums/{type}/queryresult",
                   new { controller = "albums", action = "queryresult" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                  null,
                  "albums/{type}/search/filter/{filter}/{term}",
                  new { controller = "albums", action = "search" },
                  new[] { "JgnEnt.Controllers" }
              );

            routes.MapRoute(
                null,
                "albums/{type}/search/filter/{filter}/{term}/{pagenumber}",
                new { controller = "albums", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "albums/{type}/search/{term}",
                new { controller = "albums", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "albums/{type}/search/{term}/{pagenumber}",
                new { controller = "albums", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );


            routes.MapRoute(
                null,
                "albums/{type}/page/{pagenumber}",
                new { controller = "albums", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "albums/{type}/added/{filter}",
                new { controller = "albums", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                   null,
                   "albums/{type}/added/{filter}/{pagenumber}",
                   new { controller = "albums", action = "Index" },
                   new[] { "JgnEnt.Controllers" }
             );

            routes.MapRoute(
                null,
                "albums/{type}",
                new { controller = "albums", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );
            routes.MapRoute(
                 null,
                 "albums/{type}/{order}",
                 new { controller = "albums", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                 null,
                 "albums/{type}/{order}/{pagenumber}",
                 new { controller = "albums", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );

           
            #endregion

            #region Channels
                       
            routes.MapRoute(
                null,
                "channels/searchoptions",
                new { controller = "channels", action = "searchoptions" },
                new[] { "JgnEnt.Controllers" }
            );
            
            /* search routes */
            routes.MapRoute(
                   null,
                   "channels/queryresult",
                   new { controller = "channels", action = "queryresult" },
                   new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                  null,
                  "channels/search/filter/{filter}/{term}",
                  new { controller = "channels", action = "search" },
                  new[] { "JgnEnt.Controllers" }
              );

            routes.MapRoute(
                null,
                "channels/search/filter/{filter}/{term}/{pagenumber}",
                new { controller = "channels", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "channels/search/{term}",
                new { controller = "channels", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "channels/search/{term}/{pagenumber}",
                new { controller = "channels", action = "search" },
                new[] { "JgnEnt.Controllers" }
            );


            routes.MapRoute(
                null,
                "channels/page/{pagenumber}",
                new { controller = "channels", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                null,
                "channels/added/{filter}",
                new { controller = "channels", action = "Index" },
                new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                   null,
                   "channels/added/{filter}/{pagenumber}",
                   new { controller = "channels", action = "Index" },
                   new[] { "JgnEnt.Controllers" }
             );

            routes.MapRoute(
                 null,
                 "channels/{order}",
                 new { controller = "channels", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );

            routes.MapRoute(
                 null,
                 "channels/{order}/{pagenumber}",
                 new { controller = "channels", action = "Index" },
                 new[] { "JgnEnt.Controllers" }
            );

            #endregion
                     

            #endregion

            #region User Profile
            routes.MapRoute(
                    null,
                    "user/profile/{username}",
                    new { controller = "user", action = "profile" },
                    new[] { "JgnEnt.Controllers" }
                );
            
           
            routes.MapRoute(
                 null,
                 "user/audio/{username}",
                 new { controller = "user", action = "audio" },
                 new[] { "JgnEnt.Controllers" }
             );
            routes.MapRoute(
                null,
                "user/audio/{username}/{id}",
                new { controller = "user", action = "audio" },
                new[] { "JgnEnt.Controllers" }
            );
           
            routes.MapRoute(
              null,
              "user/videos/{username}",
              new { controller = "user", action = "videos" },
              new[] { "JgnEnt.Controllers" }
          );
            routes.MapRoute(
                 null,
                 "user/videos/{username}/{id}",
                 new { controller = "user", action = "videos" },
                 new[] { "JgnEnt.Controllers" }
             );
            routes.MapRoute(
                null,
                "user/{username}",
                new { controller = "user", action = "Index" },
                new[] { "JgnEnt.Controllers" }
             );
            #endregion


            // Default
            routes.MapRoute(
                "Default",
                "{controller}/{action}/{id}",
                new { controller = "Home", action = "Index", id = UrlParameter.Optional },
                new[] { "JgnEnt.Controllers" }
            );
        }
    }
}
