﻿using System.Web.Mvc;
using Jugnoon.Utility;
using Microsoft.AspNet.Identity;
using System.IO;
using JgnEnt.Areas.account.models;


namespace JgnEnt.Areas.account.Controllers
{
    [MasterEventAuthorizationAttribute()]
    public class defaultController : Controller
    {
        // GET: account/default
        public ActionResult Index()
        {
            ViewBag.title= Resources.vsk.myaccount;

            var model = new AccountViewModel();
            model.AlertType = AlertTypes.Error;
            if (Request.Params["status"] != null)
            {
                switch (Request.Params["status"].ToString())
                {
                    case "success":
                        model.Message = Resources.vsk.message_myaccount_01; //Your account has been created
                        model.AlertType = AlertTypes.Success;
                        break;
                    case "activated":
                        model.Message = Resources.vsk.message_myaccount_02; //Your account has been activated
                        break;
                }
            }

            var username = HttpContext.User.Identity.GetUserName();

            model.TopMenuIndex = 6; 

            model.MainMenuIndex = 0;

            var angularAppPath = Server.MapPath(Request.ApplicationPath) + "//scripts//lib//myaccount//";
            model.isExist = Directory.Exists(angularAppPath);


            ViewBag.title = Resources.vsk.myaccount;

            return View(model);
        }
        
       
    }
}