﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.BLL;
using Jugnoon.Entity;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class adsController : Controller
    {
        // GET: api/ads/load
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<AdEntity>(json);
            ProcessAdsBLL();
            data.order = data.order + " " + data.direction;
            var _posts = AdsBLL.Load(data);
            var _records = 0;
            if (data.adid == 0)
                _records = AdsBLL.Count(data);
            
            return Json(new { posts = _posts, records = _records });
        }

        // GET: admin/ads/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<AdEntity>>(json);
            var _posts = AdsBLL.Load(data[0]);
            return Json(new { posts = _posts[0] });
        }

        // GET: admin/ads/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<AdEntity>(json);
            if (data.adid > 0)
            {
                // Update Operation
                AdsBLL.Update_Field_V3(data.adid, data.adscript.ToString(), "adscript");
            }
            else
            {
                // Add Operation
                AdsBLL.Add_Script(data.name, data.adscript, data.type);
            }
            return Json(new { status = "success", id = 0, message = "Record processed successfully" });
        }

        // GET: admin/categories/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<AdEntity>>(json);

            AdsBLL.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }

        private void ProcessAdsBLL()
        {
            if (!AdsBLL.Count_Script())
            {
                int adult = 1;
                int nonadult = 0;
                // add ads entry for first time
                AdsBLL.Add_Script("Horizontal - 728x90", "no script", nonadult);
                AdsBLL.Add_Script("Horizontal - 728x90", "no script", adult);
                AdsBLL.Add_Script("Horizontal - 468x60", "no script", nonadult);
                AdsBLL.Add_Script("Horizontal - 468x60", "no script", adult);
                AdsBLL.Add_Script("Horizontal - 234x60", "no script", nonadult);
                AdsBLL.Add_Script("Horizontal - 234x60", "no script", adult);
                AdsBLL.Add_Script("Vertical - 120x600", "no script", nonadult);
                AdsBLL.Add_Script("Vertical - 120x600", "no script", adult);
                AdsBLL.Add_Script("Vertical - 160x600", "no script", nonadult);
                AdsBLL.Add_Script("Vertical - 160x600", "no script", adult);
                AdsBLL.Add_Script("Vertical - 120x240", "no script", nonadult);
                AdsBLL.Add_Script("Vertical - 120x240", "no script", adult);
                AdsBLL.Add_Script("Square - 336x280", "no script", nonadult);
                AdsBLL.Add_Script("Square - 336x280", "no script", adult);
                AdsBLL.Add_Script("Square - 300x250", "no script", nonadult);
                AdsBLL.Add_Script("Square - 300x250", "no script", adult);
                AdsBLL.Add_Script("Square - 250x250", "no script", nonadult);
                AdsBLL.Add_Script("Square - 250x250", "no script", adult);
                AdsBLL.Add_Script("Square - 200x200", "no script", nonadult);
                AdsBLL.Add_Script("Square - 200x200", "no script", adult);
                AdsBLL.Add_Script("Square - 180x150", "no script", nonadult);
                AdsBLL.Add_Script("Square - 180x150", "no script", adult);
                AdsBLL.Add_Script("Square - 125x125", "no script", nonadult);
                AdsBLL.Add_Script("Square - 125x125", "no script", adult);
            }
        }

    }
}