﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.BLL;
using Jugnoon.Entity;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class dictionaryController : Controller
    {
        // GET: api/dictionary/load
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<DictionaryEntity>(json);
            if (!data.order.Contains("asc") && !data.order.Contains("desc"))
                data.order = data.order + " " + data.direction;
            
            var _posts = DictionaryBLL.Load(data);
            var _records = 0;
            if (data.id == 0)
                _records = DictionaryBLL.Count(data);
            return Json(new { posts = _posts, records = _records });
        }

        // GET: admin/dictionary/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<DictionaryEntity>>(json);
            var _posts = DictionaryBLL.Load(data[0]);
            return Json(new { posts = _posts[0] });
        }

        // GET: admin/dictionary/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<DictionaryEntity>(json);
            if (DictionaryBLL.CheckValue(data.value, data.type))
            {
                return Json(new { status = "error", message = "Value already exist" });
            }
            if (data.id > 0)
            {
                // Update Operation
                DictionaryBLL.Update(data);
            }
            else
            {
                // Add Operation
                data = DictionaryBLL.Add(data);
            }

            return Json(new { status = "success", record = data, message = "Record processed successfully" });
        }

        // GET: admin/dictionary/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<DictionaryEntity>>(json);

            DictionaryBLL.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
   
    }
}