﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.BLL;
using Jugnoon.Entity;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class ipController : Controller
    {
        // GET: api/blockip
        public ActionResult Index()
        {
            return Json(new { message = "Direct access forbidden" });
        }

        // GET: api/blockip/load
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<BlockIPEntity>(json);
            data.order = data.order + " " + data.direction;
            var _posts = BlockIPBLL.Load(data);
            var _records = 0;
            if (data.id == 0)
                _records = BlockIPBLL.Count(data);
            return Json(new { posts = _posts, records = _records });
        }

        // GET: api/blockip/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<BlockIPEntity>>(json);
            var _posts = BlockIPBLL.Load(data[0]);
            return Json(new { posts = _posts[0] });
        }

        // GET: admin/blockip/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var item = JsonConvert.DeserializeObject<BlockIPEntity>(json);

            if (item.id > 0)
            {
                // Update Operation
                BlockIPBLL.Update_Field_V3(item.id, item.ipaddress, "ipaddress");
            }
            else
            {
                // Add Operation
                item = BlockIPBLL.Add_IP(item);
            }

            return Json(new { status = "success", record = item, message = "Record processed successfully" });
        }

        // GET: admin/blockip/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<BlockIPEntity>>(json);

            BlockIPBLL.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
      
    }
}