﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.Entity;
using Jugnoon.BLL;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class languagesController : Controller
    {
        // GET: api/languages/load
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<LanguageEntity>(json);
            data.order = data.order + " " + data.direction;
            var _posts = LanguageBLLC.Load(data);
            var _records = 0;
            if (data.languageid == 0)
                _records = LanguageBLLC.Count(data);
            return Json(new { posts = _posts, records = _records });
        }

        // GET: admin/languages/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<LanguageEntity>>(json);
            var _posts = LanguageBLLC.Load(data[0]);
            return Json(new { posts = _posts[0] });
        }

        // GET: admin/languages/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<LanguageEntity>(json);

            data = LanguageBLLC.Process(data);

            return Json(new { status = "success", record = data, message = "Record processed successfully" });
        }

        // GET: admin/languages/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<LanguageEntity>>(json);

            LanguageBLLC.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
      
    }
}