﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.BLL;
using Jugnoon.Entity;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class logController : Controller
    {
        // GET: api/logs/load
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<LogEntity>(json);
            data.order = data.order + " " + data.direction;
            var _posts = ErrorLgBLL.Load(data);
            var _records = 0;
            if (data.id == 0)
                _records = ErrorLgBLL.Count(data);
            return Json(new { posts = _posts, records = _records });
        }

        // GET: admin/logs/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<LogEntity>>(json);
            var _posts = ErrorLgBLL.Load(data[0]);
            return Json(new { posts = _posts[0] });
        }

        // GET: admin/logs/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<LogEntity>(json);

            if (data.id > 0)
            {
                // Update Operation

            }
            else
            {
                // Add Operation
                ErrorLgBLL.Add(data.description,data.url, data.stack_trace);
            }

            return Json(new { status = "success", record = data, message = "Record processed successfully" });
        }

        // GET: admin/dictionary/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<LogEntity>>(json);

            ErrorLgBLL.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
        
    }
}