﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.Entity;
using Jugnoon.BLL;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class mailtemplatesController : Controller
    {
        public ActionResult Index()
        {
            var data = new MailTemplateEntity()
            {
                pagenumber = 1,
                type = "-1",
                pagesize = 20,
                order = "id desc"
            };
            var _posts = MailTemplateBLL.Load(data);
            return Json(new { posts = _posts, records = 434 }, JsonRequestBehavior.AllowGet);
            //return Json(new { message = "Direct access forbidden" });
        }

        // GET: admin/mailtemplates/load
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<MailTemplateEntity>(json);
            data.order = data.order + " " + data.direction;
            var _posts = MailTemplateBLL.Load(data);
            var _records = 0;
            if (data.id == 0)
                _records = MailTemplateBLL.Count(data);
            return Json(new { posts = _posts, records = _records });
        }

        // GET: admin/mailtemplates/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<MailTemplateEntity>>(json);
            var _posts = MailTemplateBLL.Load(data[0]);
            if (_posts.Count > 0)
                return Json(new { status = "success", posts = _posts[0] });
            else
                return Json(new { status = "error", message = "No record found" });
        }

        // GET: admin/mailtemplates/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<MailTemplateEntity>(json);

            if (data.id > 0)
            {
                // Update Operation
                MailTemplateBLL.Update_Record(data.id,data.subject,data.description, data.contents,data.tags,data.subjecttags);
            }
            else
            {
                // check whether template already exist
                if (MailTemplateBLL.CheckTemplate(data.templatekey))
                {
                    return Json(new { status = "error", message = "Template Key Already Exist" });
                }
                // Add Operation
                data = MailTemplateBLL.Add(data);
            }

            return Json(new { status = "success", record = data, message = "Record processed successfully" });
        }

        // GET: admin/mailtemplates/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<MailTemplateEntity>>(json);

            MailTemplateBLL.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
    


    }
}