﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.BLL;
using Jugnoon.Entity;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class roleController : Controller
    {
        // GET: api/role/load
        public ActionResult load()
        {
            //var json = new StreamReader(Request.InputStream).ReadToEnd();
            //var data = JsonConvert.DeserializeObject<RoleEntity>(json);
            //data.order = data.order + " " + data.direction;
            var entity = new RoleEntity()
            {
                order = "id desc",
                pagesize = 4000,
                pagenumber = 1
            };
            var _posts = RoleBLL.LoadItems(entity);
            var _records = 0;
            if (entity.id == 0)
                _records = RoleBLL.Count(entity);
            return Json(new { posts = _posts, records = _records });
        }

        // GET: admin/role/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<RoleEntity>(json);
            var _posts = RoleBLL.LoadItems(data);

            if (_posts.Count == 0)
            {
                return Json(new { status = "error", message = "No Record Found" });
            }

            foreach(var post in _posts)
            {
                post.permissions = RolePermission.LoadItems(new RoleDPermissionEntity()
                {
                    roleid = post.id,
                    order = "id desc",
                    pagesize = 5000,
                    pagenumber = 1
                });
            }
            return Json(new { status = "success", posts = _posts[0] });
        }

        // GET: api/role/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var item = JsonConvert.DeserializeObject<RoleDataEntity>(json);

            item = RoleBLL.Add(item);

            return Json(new { status = "success", record = item, message = "Record processed successfully" });
        }

        // GET: api/role/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<RoleEntity>>(json);

            RoleBLL.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
    }
}