﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.BLL;
using Jugnoon.Entity;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class rolepermissionController : Controller
    {
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<RoleDPermissionEntity>(json);
            data.order = data.order + " " + data.direction;
            var _posts = RolePermission.LoadItems(data);
            var _records = 0;
            if (data.id == 0)
                _records = RolePermission.Count(data);
            return Json(new { posts = _posts, records = _records });
        }

        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<RoleDPermissionEntity>>(json);
            var _posts = RolePermission.LoadItems(data[0]);
            return Json(new { posts = _posts[0] });
        }

        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var items = JsonConvert.DeserializeObject<List<RoleDataPermissionEntity>>(json);

            if (items.Count > 0)
            {
                // remove existing objects
                var roleid = items[0].roleid;
                RolePermission.DeleteRole((short)roleid);
                foreach (var permission in items)
                {
                    RolePermission.Add(permission);
                }
                
            }
            return Json(new { status = "success", message = "Record processed successfully" });
        }

        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<RoleDPermissionEntity>>(json);

            RolePermission.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
    }
}