﻿using System.Collections.Generic;
using System.Web.Mvc;
using Jugnoon.Entity;
using Jugnoon.Utility;
using Jugnoon.BLL;
using System.IO;
using Newtonsoft.Json;

namespace JgnEnt.Areas.api.Controllers
{
    public class tagsController : Controller
    {        
        // GET: api/tags/load
        public ActionResult load()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<TagEntity>(json);
            data.order = data.order + " " + data.direction;
            var _posts = TagsBLL.LoadItems(data);
            var _records = 0;
            if (data.tagid == 0)
                _records = TagsBLL.Count(data);
            return Json(new { posts = _posts, records = _records });
        }

        // GET: api/tags/getinfo
        public ActionResult getinfo()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<TagEntity>>(json);
            var _posts = TagsBLL.LoadItems(data[0]);
            return Json(new { post = _posts[0] });
        }

        // GET: api/tags/proc
        public ActionResult proc()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<TagsDataEntity>(json);
           
            if (data.tagname.Length < 3)
            {
                return Json(new { status = "error", message = "Title must be more than 3 chars" });
            }

            if (UtilityBLL.isLongWordExist(data.tagname) || UtilityBLL.isLongWordExist(data.tagname))
            {
                return Json(new { status = "error", message = "Long or bad word exist either in title or description, correct and post again" });
            }

            dynamic CategoryContentType = 1;
            // represent blog in categorycontent table
            if (data.tagid > 0)
            {
                // Update Operation
                TagsBLL.Update(data);

            }
            else
            {
                // Add Operation
                TagsBLL.Add(data.tagname, data.type, data.records, data.term);
            }

            return Json(new { status = "success", id = data.tagid, message = "Record processed successfully" });
        }

        // GET: admin/categories/action
        public ActionResult action()
        {
            var json = new StreamReader(Request.InputStream).ReadToEnd();
            var data = JsonConvert.DeserializeObject<List<TagEntity>>(json);
            /* if (!data[0].permission.canupdate)
            {
                return Json(new { status = "error", message = "You have no permission to perform this action" });
            } */
            TagsBLL.ProcessAction(data);

            return Json(new { status = "success", message = "Operation performed successfully" });
        }
             
    }
}