﻿using System;
using System.Web.Mvc;
using Jugnoon.models;
using Jugnoon.BLL;
using Jugnoon.Entity;
using Jugnoon.Settings;
using Microsoft.AspNet.Identity;
using Jugnoon.Utility;
using Jugnoon.Scripts;
using Jugnoon.Settings;
using JgnEnt.models.ViewModels.Album;
using JgnEnt.models.ViewModels.Shared;
using JgnEnt.models.ViewModels.videos.Player;

namespace JgnEnt.Controllers
{
    public class albumController : Controller
    {
        // GET: album
        public ActionResult Index(long? pid, long? mediaid, string title)
        {
            if (pid == null)
            {
                return Redirect(Config.GetUrl("albums"));
            }

            var model = new AlbumViewModel();
            model.isAllowed = true;

            var _list = GalleryBLLC.LoadItems(new AlbumEntity()
            {
                galleryid = (long)pid,
                nofilter = true,
                loadall = true
            });

            if (_list.Count == 0)
            {
                model.isAllowed = false;
                model.DetailMessage = Resources.vsk.norecordfound;
                return View(model);
            }

            model.Data = _list[0];

            long _currentid = 0;
            if (Request.Params["mid"] != null)
                _currentid = Convert.ToInt64(Request.Params["mid"]);

            model.PreviewUrl = AlbumUrlConfig.PrepareUrl(model.Data, _currentid);

            if (_list[0].isadult == 1)
            {
                // 1:-> adult content, 0:-> non adult content
                if (Session["adultmember"] == null)
                {

                   return Redirect(Config.GetUrl("home/validateadult?surl=" + Server.UrlEncode(model.PreviewUrl) + ""));
                }
            }

            if (_list[0].isapproved == 0)
            {
                model.Message = Resources.vsk.gallery_message_01;
            }
            if (_list[0].isdisabled == 0)
            {               
                model.DetailMessage = Resources.vsk.album_msg_01; // Album has been blocked. contact site administrator for more detail
                model.isAllowed = true;
                return View(model);
            }
            // Fetch Current Selected Image ID / and other information base on selected gallery.
            /*long current_imageid = 0;
            if (Request.Params["mid"] != null)
                current_imageid = Convert.ToInt64(Request.Params["mid"]);
            else
                current_imageid = PhotosBLLC.Fetch_First_Gallery_Photo_ID((long)pid);*/

            model.Action = new ActionViewModel()
            {
                ContentID = (long)pid,
                Liked = _list[0].liked,
                Disliked = _list[0].disliked,
                UserName = _list[0].username,
                isRating = _list[0].iscomments,
                Views = _list[0].views,
                Content_Type = Resources.vsk.album, // content type
                isFavorites = false, // show favorite link
                isEmbed = true, // show embed video link
                isPlaylist = false, // show playlist link
                isShare = true, // show share link
                isDownload = false, // show download link
                isViews = false, // show views stats
                isDetailViewStats = false, // show detail view stats button
                Ratingtype = 1, // 0: like / dislike, 1: rating
                Avg_Ratings = _list[0].avg_rating,
                Ratings = _list[0].ratings,
                TotalRatings = _list[0].total_rating,
                isAlbumEmbed = true,
                PhotoGalleryOptions = true, // enable custom photo gallery buttons on action module
                GalleryDefaultLink = model.PreviewUrl,
                Type = 9
            };
            if (Request.Params["org"] != null)
            {
                // original mode is on
                model.Action.ShowNormalButton = true;
                model.Action.ShowSlideShowButton = true;
            }
            else if (Request.Params["slidshow"] != null)
            {
                // slidshow mode is on
                model.Action.ShowOriginalButton = true;
                model.Action.ShowNormalButton = true;
            }
            else
            {
                // normal mode is on
                model.Action.ShowOriginalButton = true;
                model.Action.ShowSlideShowButton = true;
            }

            // switch type
           
            
            if(model.Data.type == 0)
            {
                // photos
                // photo functionality not available in this build
            }
            else
            {
                var _type = 0;
                if (mediaid == null && model.Data.total_photos > 0)
                {
                    if (model.Data.type == 2)
                    {
                        _type = 1;
                    }
                    mediaid = VideoBLL.Get_Album_Media((long)pid, _type);
                }
              
                model.VideoPreview = new models.ViewModels.Album.Preview.VideoAlbumPreview();
                if(mediaid == null || mediaid == 0)
                {
                    model.VideoPreview.isExist = false;
                }
                else
                {
                    model.VideoPreview.isExist = true;
                    model.VideoPreview.Data = VideoBLL.LoadItems(new VideoEntity()
                    {
                        videoid = (long)mediaid,
                        nofilter = true,
                        loadall = true
                    }); 
                    // video or audio player settings
                    string VideoPath = "";
                    string PictureName = "";
                    if (_type == 0)
                    {
                        // video settings
                        VideoPath = Config.Return_FLV_Video_Url(model.VideoPreview.Data[0].flv_url, model.Data.username) + "/" + model.VideoPreview.Data[0].videofilename;
                        if (model.VideoPreview.Data[0].thumb_url != "none")
                            PictureName = model.VideoPreview.Data[0].thumb_url;
                        else
                            PictureName = Config.Return_Video_Thumb_Url(model.VideoPreview.Data[0].thumb_url, model.Data.username) + "/" + model.VideoPreview.Data[0].thumbfilename;
                        string MP4Path = "";
                        if (VideoPath.EndsWith(".webm"))
                            MP4Path = VideoPath.Replace(".webm", ".mp4");
                    }
                    else
                    {
                        // audio settings
                        VideoPath = Config.Return_MP3_Audio_Url(model.VideoPreview.Data[0].flv_url, model.Data.username) + "/" + model.VideoPreview.Data[0].videofilename;

                        PictureName = Config.GetUrl() + "assets/img/default_profile.gif";
                    }


                    string _script = model.VideoPreview.Data[0].embed_script;

                    model.Player = new VideoJsModelView()
                    {
                        EmbedScript = "",
                        VideoID = model.VideoPreview.Data[0].videoid,
                        Type = _type
                    };

                    if (model.VideoPreview.Data[0].coverurl != "")
                        model.Player.PictureUrl = model.VideoPreview.Data[0].coverurl;
                    else
                        model.Player.PictureUrl = PictureName;

                    if (_type == 0)
                    {
                        // video player settings
                        // If cloud enabled
                        if (_script != "" || model.VideoPreview.Data[0].youtubeid != "")
                        {
                            // third party embed video script enabled
                            if (_script == "")
                            {
                                model.Player.EmbedScript = model.VideoPreview.Data[0].youtubeid;
                            }
                            else
                            {
                                model.Player.EmbedScript = _script;
                            }
                        }
                        else if (model.VideoPreview.Data[0].videofilename.EndsWith("mp4"))
                        {

                            if (TokenBLL.isTokenEnabled)
                            {
                                // Token Based Stream Authentication Enabled
                                // Recommended to stream on HTML5 Players
                                string maxParam = VideoBLL.GenerateBandwidthParam();
                                string Token = TokenBLL.Add();
                                model.Player.VideoUrl = "/stream/token.ashx?f=" + model.VideoPreview.Data[0].videofilename + "&u=" + _list[0].username + "&tk=" + Token + "" + maxParam;
                                if (model.VideoPreview.Data[0].originalvideofilename.EndsWith(".png"))
                                    model.Player.PictureUrl = "/contents/member/" + _list[0].username + "/thumbs/" + model.VideoPreview.Data[0].originalvideofilename;
                            }
                            else if (VideoBLL.EnableHttpStreaming)
                            {
                                // Http Streaming Enabled
                                // Recommended to stream on HTML5 Players
                                string maxParam = VideoBLL.GenerateBandwidthParam();
                                model.Player.VideoUrl = "/stream/stream.ashx?f=" + model.VideoPreview.Data[0].videofilename + "&u=" + _list[0].username + "" + maxParam;
                            }
                            else
                            {
                                // Direct Play
                                model.Player.VideoUrl = VideoPath;
                            }
                        }
                        else
                        {
                            // load and play videos normally
                            model.Player.VideoUrl = VideoPath;
                        }
                    }
                    else
                    {
                        // audio player settings
                        model.Player.VideoUrl = VideoPath;
                    }
                }
            }

            var _path = "photos/";
            if (_list[0].type == 1)
                _path = "videos/";
            else if (_list[0].type == 2)
                _path = "audio/";

            model.Info = new InfoViewModel()
            {
                ContentID = (long)pid,
                Description = _list[0].description,
                Added_Date = _list[0].created_at.Value,
                UserName = _list[0].username,
                CategoryName = string.Join(",", _list[0].categories),
                Tags = _list[0].tags,
                Liked = _list[0].liked,
                Disliked = _list[0].disliked,
                Path = _path
            };

            model.Comments = new CommentViewModel()
            {
                isComment = _list[0].iscomments
            };

            string _title = _list[0].title;

            string _desc = UtilityBLL.StripHTML(_list[0].description);
            if (_desc == "")
                _desc = _list[0].title;
            else if (_desc.Length > 160)
                _desc = _desc.Substring(0, 160);

            if (Request.Params["gt"] != null)
            {
                if (Request.Params["gt"].ToString().StartsWith("org-"))
                {
                    _title = _list[0].title+ " - Original Preview";
                    _desc = _list[0].description + " - Original Preview";
                }
            }
            if (Request.Params["mid"] != null)
            {
                _title = _title + " - PIC: " + Request.Params["mid"].ToString();
                _desc = _desc + " - PIC: " + Request.Params["mid"].ToString();
            }
            
            string meta_title = _title + " | " + Site_Settings.Page_Caption;
            string meta_description = _desc + ", date create: " + _list[0].created_at + ", GID: " + _list[0].galleryid;

            ViewBag.title= meta_title;
            ViewBag.MetaDescription = meta_description;

            return View(model);
        }
    }
}