﻿using System;
using System.Collections;
using System.Text;
using System.Web.Mvc;
using Jugnoon.BLL;
using Jugnoon.Settings;
using Jugnoon.Utility;
using Jugnoon.Entity;
using System.Net;
using System.IO;

namespace JgnEnt.Controllers
{
    public class handlerController : Controller
    {
        // GET: handler
        public ActionResult Index()
        {
            return View();
        }

        #region Flag Reporting
        public ActionResult flag()
        {
            var Type = 0; // 0: video, audio, 1: comment adv points, 2: photo rating , 3: blog rating
            long ContentID = 0;
            var username = "";
            var Message = "";
            var Mediatype = 0;
            var ClientID = ""; //element id where you wwant to display output
            var Contenttype = "";

            var _ctype = "text/plain";

            if (Request.Params["t"] != null)
                Type = Convert.ToInt32(Request.Params["t"]);
            if (Request.Params["id"] != null)
                ContentID = Convert.ToInt64(Request.Params["id"]);
            if (Request.Params["usr"] != null)
                username = Request.Params["usr"].ToString();
            if (Request.Params["aid"] != null)
                ClientID = Request.Params["aid"].ToString();
            if (Request.Params["mtp"] != null)
                Mediatype = Convert.ToInt32(Request.Params["mtp"]);

            if (Request.Params["ctp"] != null)
                Contenttype = Request.Params["ctp"].ToString();

            Message = Flag_Generate_Output(Contenttype, Type, ContentID, username);

            return this.Content(Message, _ctype);
        }

        private string Flag_Generate_Output(string ContentType, int Type, long ContentID, string UserName)
        {
            //**********************************************************
            // Generate Output Panel
            //**********************************************************
            var str = new StringBuilder();

            string content_type = Resources.vsk.video;
            if (ContentType != "")
                content_type = ContentType;
            else
            {
                // backward compatible
                switch (Type)
                {
                    case 2:
                        content_type = Resources.vsk.photo;
                        break;
                    case 3:
                        content_type = "blog post";
                        break;
                }
            }
            // show message
            string flag_submit_path = Config.GetUrl("handler/postabuse");
            string flag_submit_parameters = "t=" + Type + "&usr=" + UserName + "&ctp=answer&id=" + ContentID;
            
            str.AppendLine("<div class=\"m-b-5 text-center mb5_c\" id=\"flg_msg\"></div>");
            str.AppendLine("<p class=\"m-b-10\"><strong>Report This " + content_type + " as Inappropriate</strong></p>");
            str.AppendLine("<p class=\"m-b-5\">Please select the category that most closely reflects your concern about the " + content_type + ", so that we can review it and determine whether it violates our Community Guidelines or isn't appropriate for all viewers. Abusing this feature is also a violation of the Community Guidelines, so don't do it.</p>");
            str.AppendLine("<div class=\"m-b-5\">");
            str.AppendLine(Flag_Generate_Options());
            str.AppendLine("</div>");
            str.AppendLine("<div class=\"m-b-5\">");
            str.AppendLine("&nbsp;<a href=\"#\" class=\"btn btn-primary flag_sbt\" data-destination=\"action_box_" + ContentID + "\" data-path=\"" + flag_submit_path + "\" data-param=\"" + flag_submit_parameters + "\">Flag This " + content_type + "</a>");
            str.AppendLine("</div>");
            
            return Config.SetHiddenMessage_v2(str.ToString(), "", true, 4);
        }

        private string Flag_Generate_Options()
        {
            var str = new StringBuilder();
            var _array = new ArrayList();
            int type = 4; // load abuse types

            var List = CategoryBLL.LoadItems(new Jugnoon.Entity.CategoryEntity()
            {
                type = type,
                pagesize = 1000,
                status = 1
            });

            str.AppendLine("<select class=\"form-control\" name=\"flag_list\" id=\"abuse_list\">");
            str.AppendLine("<option value=\"\">" + Resources.vsk.selectareason + "</option>");
            foreach (var Item in List)
            {
                str.AppendLine("<option value=\"" + Item.title+ "\">" + Item.title+ "</option>");
            }
            str.AppendLine("</select>");
            return str.ToString();
        }

        public ActionResult postabuse()
        {
            int Type = 0; // 0: video, audio, 1: comment adv points, 2: photo rating , 3: blog rating
            long ContentID = 0;
            string username = "";
            string Message = "";
            string Value = "";
            int MediaType = 0; // 0: video, 1: audio file
            string ElementID = ""; // div element id where you want to load box with close link

            var _ctype = "text/plain";

            if (Request.Params["t"] != null)
                Type = Convert.ToInt32(Request.Params["t"]);
            if (Request.Params["id"] != null)
                ContentID = Convert.ToInt64(Request.Params["id"]);
            if (Request.Params["usr"] != null)
                username = Request.Params["usr"].ToString();
            if (Request.Params["val"] != null)
                Value = Request.Params["val"].ToString();
            if (Request.Params["mtp"] != null)
                MediaType = Convert.ToInt32(Request.Params["mtp"]);
            if (Request.Params["elid"] != null)
                ElementID = Request.Params["elid"].ToString();


            if (ContentID > 0 && username != "")
            {
                // data received properly
                // make type compatible to abuse types
                if (Type == 2)
                    Type = 5; // photos
                if (Type == 3)
                    Type = 7; // blog post

                // post abuse report
                string output_message = AbuseReport.Process_V2(username,ContentID,Value,Type,MediaType);
                Message = Config.SetHiddenMessage_v2(output_message, ElementID, true, 0);
            }

            return this.Content(Message, _ctype);
        }

       

        #endregion
     

        public ActionResult embedvideo()
        {
           long VideoID = 0;
           string ElementID = ""; // div element id where you want to load box with close linkou want to load box with close link

            var _ctype = "text/plain";
            if (Request.Params["cid"] != null)
                VideoID = Convert.ToInt64(Request.Params["cid"]);
            if (Request.Params["elid"] != null)
                ElementID = Request.Params["elid"].ToString();

            return this.Content(EmbedVideo_Generate_Output(VideoID, ElementID), _ctype);
        }

        private string EmbedVideo_Generate_Output(long VideoID, string ElementID)
        {
            var str = new StringBuilder();
            str.AppendLine("<div class=\"mb5\">");
            str.AppendLine("<textarea name=\"vd_bx_embed\" rows=\"3\" cols=\"40\" id=\"vd_bx_embed\" onclick=\"this.focus();this.select();\" style=\"height:70px;width:100%;\">");
            str.AppendLine("<iframe src=\"" + Config.GetUrl("videoframe/" + VideoID + "/video") + "\" name=\"frame_v" + VideoID + "\" scrolling=\"no\" frameborder=\"no\" align=\"center\" height=\"380px\" width=\"640px\"></iframe>");
            str.AppendLine("</textarea>");
            str.AppendLine("</div>");
            str.AppendLine("<div class=\"item\">After making your selection, copy and paste the embed code above. The code changes based on your selection.</div>");
            str.AppendLine("</div>");
            return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 4); // wrap output in round box
        }

        public ActionResult playlist()
        {
            long ContentID = 0;
            string username = ""; // User who added media in his / her favorite lis
            string Author_username = ""; // User who are actually owner of media
            string Message = "";
            int _Favorites = 0;
            int MediaType = 0; // 0: video, 1: audio
            string ElementID = ""; // div element id where you want to load box with close link
            
            var _ctype = "text/plain";
            if (Request.Params["id"] != null)
                ContentID = Convert.ToInt64(Request.Params["id"]);
            if (Request.Params["usr"] != null)
                username = Request.Params["usr"].ToString();
            if (Request.Params["ausr"] != null)
                Author_username = Request.Params["ausr"].ToString();
            if (Request.Params["mtp"] != null)
                MediaType = Convert.ToInt32(Request.Params["mtp"]);
           
            if (Request.Params["elid"] != null)
                ElementID = Request.Params["elid"].ToString();
            

            Message = Playlist_Generate_Output(MediaType, username, ElementID, Author_username, ContentID, _Favorites);

            return this.Content(Message, _ctype);
        }

        private string Playlist_Generate_Output(int MediaType, string UserName, string ElementID, string Author_UserName, long ContentID, int _Favorites)
        {
            //**********************************************************
            // Generate Output Panel
            //**********************************************************
            var str = new StringBuilder();
            string media = Resources.vsk.video;
            string _url = Config.GetUrl();
            string fav_url = _url + "account/videos/playlists";
            
            // check authentication
            if (UserName == "")
            {
                string sign_in = "<a href=\"" + Config.GetUrl() + "login?ReturnUrl=" + Config.Return_Current_Page() + "\" class=\"bold\">Sign In</a>";
                string sign_up = "<a href=\"" + Config.GetUrl() + "signup\" class=\"bold\">Sign Up</a>";
                str.AppendLine("" + sign_in + " or " + sign_up + " now!");
                return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 2);
            }

            // check your own video
            if (Author_UserName == UserName)
            {
                str.AppendLine("Can't add your own " + media + " to your <a href=\"" + fav_url + "\">" + Resources.vsk.playlists + "</a>.");
                return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 0);
            }

            // playlist feature currently under development
            str.AppendLine("Playlist functionality will be available soon.");

            // wrap output
            return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 1);

        }

        public ActionResult favorites()
        {
            int Favtype = 0; // 0: video, audio, 1: qa fav, 2: gallery or album
            long ContentID = 0;
            string username = ""; // User who added media in his / her favorite lis
            string Author_username = ""; // User who are actually owner of media
            string Message = "";
            int _Favorites = 0;
            int MediaType = 0; // 0: video, 1: audio
            string ElementID = ""; // div element id where you want to load box with close link


        var _ctype = "text/plain";
            if (Request.Params["id"] != null)
                ContentID = Convert.ToInt64(Request.Params["id"]);
            if (Request.Params["usr"] != null)
                username = Request.Params["usr"].ToString();
            if (Request.Params["ausr"] != null)
                Author_username = Request.Params["ausr"].ToString();
            if (Request.Params["mtp"] != null)
                MediaType = Convert.ToInt32(Request.Params["mtp"]);
            if (Request.Params["favt"] != null)
                _Favorites = Convert.ToInt32(Request.Params["favt"]);
            if (Request.Params["elid"] != null)
                ElementID = Request.Params["elid"].ToString();

            if (Request.Params["ftype"] != null)
                Favtype = Convert.ToInt32(Request.Params["ftype"]);


            Message = Favorites_Generate_Output(Favtype, MediaType, username, ElementID, Author_username, ContentID, _Favorites);

            return this.Content(Message, _ctype);
        }

        private string Favorites_Generate_Output(int FavType, int MediaType, string UserName, string ElementID, string Author_UserName, long ContentID, int _Favorites)
        {
            //**********************************************************
            // Generate Output Panel
            //**********************************************************
            var str = new StringBuilder();
            string media = Resources.vsk.video;
            string _url = Config.GetUrl();
            string fav_url = _url + "account/videos/favorites";
            if (FavType == 2)
            {
                media = "album";
                if (MediaType == 1)
                    fav_url = _url + "account/audio/favorites";
                else
                    fav_url = _url + "account/albums/favorites";
            }
            else if (MediaType == 1)
            {
                media = Resources.vsk.audio;
                fav_url = _url + "account/audio/favorites";
            }

            // check authentication
            if (UserName== "")
            {
                string sign_in = "<a href=\"" + Config.GetUrl() + "login?ReturnUrl=" + Config.Return_Current_Page() + "\" class=\"bold\">Sign In</a>";
                string sign_up = "<a href=\"" + Config.GetUrl() + "signup\" class=\"bold\">Sign Up</a>";
                str.AppendLine("" + sign_in + " or " + sign_up + " now!");
                return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 2);
            }

            // check your own video
            if (Author_UserName== UserName)
            {
                str.AppendLine("Can't add your own " + media + " to your <a href=\"" + fav_url + "\">" + Resources.vsk.favorites + "</a>.");
                return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 0);
            }

            if (Favorites.Check(UserName, ContentID, FavType))
            {
                str.AppendLine("You already add this " + media + " to your <a href=\"" + fav_url + "\">" + Resources.vsk.favorites + "</a>.");
                return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 0);
            }


            Favorites.Add(UserName, ContentID, MediaType, FavType);

            // increment favorite video state
            _Favorites++;
            VideoBLL.Update_Field_V3(ContentID, _Favorites, "favorites");
            str.AppendLine(media.ToUpper() + " has been <strong>added</strong> to your <a href=\"" + fav_url + "\">" + Resources.vsk.favorites + "</a>.");
            // wrap output
            return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 4);

        }

        public ActionResult share()
        {
            string Content_type = "";

            var _ctype = "text/plain";

            if (Request.Params["tp"] != null)
                Content_type = Request.Params["tp"].ToString();

            return this.Content(Share_Generate_Output(Content_type), _ctype);
        }

        private string Share_Generate_Output(string Content_Type)
        {
            //**********************************************************
            // Generate Output Panel
            //**********************************************************
            var str = new StringBuilder();
            str.AppendLine("<div class=\"mb10 mr10 ml10 mt10\">");
            str.AppendLine("<div class=\"mb5\"><strong>Share This " + Content_Type + "</strong></div>");
            str.AppendLine("<div class=\"row\">");
            str.AppendLine("<div class=\"col-md-12\">");
            str.AppendLine("<!-- AddThis Button BEGIN -->");
            str.AppendLine("<div class=\"addthis_toolbox addthis_default_style addthis_32x32_style\">");
            str.AppendLine("<a class=\"addthis_button_facebook\"></a>");
            str.AppendLine("<a class=\"addthis_button_twitter\"></a>");
            str.AppendLine("<a class=\"addthis_button_reddit\"></a>");
            str.AppendLine("<a class=\"addthis_button_digg\"></a>");
            str.AppendLine("<a class=\"addthis_button_delicious\"></a>");
            str.AppendLine("<a class=\"addthis_button_stumbleupon\"></a>");
            str.AppendLine("<a class=\"addthis_button_google\"></a>");
            str.AppendLine("<a class=\"addthis_button_compact\"></a>");
            str.AppendLine("<a class=\"addthis_counter addthis_bubble_style\"></a>");
            str.AppendLine("</a>");
            str.AppendLine("</div>");
            str.AppendLine("<script type=\"text/javascript\">        var addthis_config = { \"data_track_clickback\": true };</script>");
            str.AppendLine("<script type=\"text/javascript\" src=\"http://s7.addthis.com/js/250/addthis_widget.js#pubid=" + Social_Settings.Addthis_PubID + "\"></script>");
            str.AppendLine("<!-- AddThis Button END -->");
            str.AppendLine("</div>");
           
            str.AppendLine("</div>");

            str.AppendLine("</div>");
            return Config.SetHiddenMessage_v2(str.ToString(), "actionshare", true, 4);
        }

        public ActionResult like()
        {
            int type = 0; // 0: video, audio, 1: comment adv points, 2: photo rating , 3: blog rating
            int MediaType = 0; // 0: video, 1: audio
            long ContentID = 0;
            string username = "";
            int Liked = 0;
            int Disliked = 0;
            int Action = 0; // 0: Liked, 1: Disliked
            string Message = "";
            string ElementID = ""; // div id where to load content
            int Ratingtype = 0; // 0: like / dislike, 1: start rating
            double Avg_Ratings = 0;
            double Ratings = 0;
            int TotalRatings = 0;
            int Val = 0;
            var _ctype = "text/plain";
            if (Request.UrlReferrer == null)
            {
                Response.Write("p400"); // Authorization Failed"
            }
            else
            {
                if (Request.Params["t"] != null)
                    type = Convert.ToInt32(Request.Params["t"]);
                if (Request.Params["mtp"] != null)
                    MediaType = Convert.ToInt32(Request.Params["mtp"]);
                if (Request.Params["id"] != null)
                    ContentID = Convert.ToInt64(Request.Params["id"]);
                if (Request.Params["usr"] != null)
                    username = Request.Params["usr"].ToString();
                if (Request.Params["lk"] != null)
                    Liked = Convert.ToInt32(Request.Params["lk"]);
                if (Request.Params["dlk"] != null)
                    Disliked = Convert.ToInt32(Request.Params["dlk"]);
                if (Request.Params["act"] != null)
                    Action = Convert.ToInt32(Request.Params["act"]);
                if (Request.Params["elid"] != null)
                    ElementID = Request.Params["elid"].ToString();
                if (Request.Params["rtype"] != null)
                    Ratingtype = Convert.ToInt32(Request.Params["rtype"]);
                if (Request.Params["ratings"] != null)
                    Ratings = Convert.ToDouble(Request.Params["ratings"]);
                if (Request.Params["aratings"] != null)
                    Avg_Ratings = Convert.ToDouble(Request.Params["aratings"]);
                if (Request.Params["tratings"] != null)
                    TotalRatings = Convert.ToInt32(Request.Params["tratings"]);
                if (Request.Params["val"] != null)
                    Val = Convert.ToInt32(Request.Params["val"]);

                // if user already logged in
                if (username != "")
                {
                    // check whether he / she already post rating on same content
                    if (!User_Ratings.Check(username, ContentID, type))
                    {
                        // proceed user to post vote
                        if (Ratingtype == 0)
                        {
                            // like / dislike
                            Post_Vote(Action, Liked, Disliked, type, ContentID);
                        }
                        else
                        {
                            // normal ratings
                            Post_Rating(Action, Avg_Ratings, Liked, Disliked, type, ContentID, Ratings, TotalRatings, Val);
                        }

                        // add user statistics
                        User_Ratings.Add(username, ContentID, type, Val); //rating 0: liked, 1: disliked
                        if (Ratingtype == 0)
                            Message = Set_Liked_Message(Action, type, MediaType, Liked, Disliked, username, ElementID);
                        else
                            Message = Set_Rating_Message(type, MediaType, ElementID, Liked, Disliked, username, Avg_Ratings, TotalRatings);
                    }
                    else
                    {
                        // he already post their vote
                        if (Ratingtype == 0)
                            Message = Set_Liked_Message(Action, type, MediaType, Liked, Disliked, username, ElementID);
                        else
                            Message = Set_Rating_Message(type, MediaType, ElementID, Liked, Disliked, username, Avg_Ratings, TotalRatings);
                    }
                }
                else
                {
                    if (Site_Settings.Feature_Login_Rating == 0)
                    {
                        // directly post vote without storing user statistics
                        if (Ratingtype == 0)
                        {
                            Post_Vote(Action, Liked, Disliked, type, ContentID);
                            Message = Set_Liked_Message(Action, type, MediaType, Liked, Disliked, username, ElementID);
                        }
                        else
                        {
                            Post_Rating(Action, Avg_Ratings, Liked, Disliked, type, ContentID, Ratings, TotalRatings, Val);
                            Message = Set_Rating_Message(type, MediaType, ElementID, Liked, Disliked, username, Avg_Ratings, TotalRatings);
                        }
                    }
                }

               
            }
            return this.Content(Message, _ctype);
        }

        // like | dislike
        private void Post_Vote(int Action, int Liked, int Disliked, int Type, long ContentID)
        {
            if (Action == 0)
            {
                Liked = Liked + 1;
                switch (Type)
                {
                    case 0:
                        VideoBLL.Update_Field_V3(ContentID, Liked, "liked");
                        break;

                    case 9:
                        GalleryBLLC.Update_Field_V3(ContentID, Liked, "liked");
                        break;
                }
                Liked = Liked + 1;
            }
            else
            {
                Disliked = Disliked + 1;
                switch (Type)
                {
                    case 0:
                        VideoBLL.Update_Field_V3(ContentID, Disliked, "disliked");
                        break;
                    case 9:
                        GalleryBLLC.Update_Field_V3(ContentID, Disliked, "disliked");
                        break;
                }
                Disliked = Disliked + 1;
            }
        }

        // normal ratings
        private void Post_Rating(int Action, double Avg_Ratings, int Liked, int Disliked, int Type, long ContentID, double Ratings, int TotalRatings, int Val)
        {
            if (Action > 5)
                Action = 5;

            switch (Type)
            {
                case 0:
                    Avg_Ratings = VideoBLL.Post_Rating(ContentID, Val, TotalRatings, Ratings);
                    break;
               
                case 3:
                    // currently not supported in blogs
                    break;
                case 9:
                    Avg_Ratings = GalleryBLLC.Post_Rating(ContentID, Val, TotalRatings, Ratings);
                    break;
            }
            TotalRatings = TotalRatings + 1;
            Ratings = Ratings + 1;
        }

        // set liked | disliked Message
        private string Set_Liked_Message(int Action, int Type, int MediaType, int Liked, int Disliked, string UserName, string ElementID)
        {
            string action = "liked";
            if (Action != 0)
                action = "disliked";

            string content_type = "";
            string content_url = "";
            switch (Type)
            {
                case 0:
                    // video | audio
                    if (MediaType == 1)
                    {
                        // audio
                        content_url = "<a href=\"" + Config.GetUrl() + "account/audio/liked\">audio files you " + action + "</a>";
                        content_type = "audio file";
                    }
                    else
                    {
                        // video
                        content_url = "<a href=\"" + Config.GetUrl() + "account/videos/liked\">videos you " + action + "</a>";
                        content_type = Resources.vsk.video;
                    }
                    break;
                case 2:
                    content_url = "<a href=\"" + Config.GetUrl() + "account/photos/liked\">photos you " + action + "</a>";
                    content_type = Resources.vsk.photo;
                    break;
                case 3:
                    content_url = "<a href=\"" + Config.GetUrl() + "account/blogs/liked\">blogs you " + action + "</a>";
                    content_type = "blog post";
                    break;
                case 9:
                    // no gallery feature available - redirect user to photos
                    content_url = "<a href=\"" + Config.GetUrl() + "account/photos/liked\">photo galleries you " + action + "</a>";
                    content_type = "gallery";
                    break;

            }
            //**********************************************************
            // Generate Output Panel
            //**********************************************************
            int total_votes = Liked + Disliked;
            var str = new StringBuilder();
            str.AppendLine("<div class=\"mb10\">You " + action + " this " + content_type + ". Thanks for the feedback!");
            if (UserName != "") // if user logged in
                str.AppendLine(" See more " + content_url + ".");
            str.AppendLine("</div>");
            str.AppendLine("<div class=\"mb10\"><strong>Rating for this " + content_type + " </strong><span class=\"normal-text reverse\">(" + total_votes + " total)</span>");
            str.AppendLine("\n");
            // internal rating section
            str.AppendLine("<div class=\"mb5\" style=\"width:300px;\">");
            str.AppendLine(Generate_Rating_Bx(Liked, Disliked));
            str.AppendLine("</div>");
            str.AppendLine("</div>");

            return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 4);

        }

        // Generate Rating Message
        private string Set_Rating_Message(int Type, int MediaType, string ElementID, int Liked, int Disliked, string UserName, double Avg_Ratings, int TotalRatings)
        {
            string action = "rated";
            string content_type = "";
            string content_url = "";
            switch (Type)
            {
                case 0:
                    // video | audio
                    if (MediaType == 1)
                    {
                        // audio
                        content_url = "<a href=\"" + Config.GetUrl() + "account/audio/liked\">audio files you " + action + "</a>";
                        content_type = "audio file";
                    }
                    else
                    {
                        // video
                        content_url = "<a href=\"" + Config.GetUrl() + "account/videos/liked\">videos you " + action + "</a>";
                        content_type = Resources.vsk.video;
                    }
                    break;
                case 2:
                    content_url = "<a href=\"" + Config.GetUrl() + "account/photos/liked\">photos you " + action + "</a>";
                    content_type = Resources.vsk.photo;
                    break;
                case 3:
                    content_url = "<a href=\"" + Config.GetUrl() + "account/blogs/liked\">blogs you " + action + "</a>";
                    content_type = "blog post";
                    break;
                case 9:
                    // currently not supported
                    // no gallery feature available - redirect user to photos
                    content_url = "<a href=\"" + Config.GetUrl() + "account/photos/liked\">photo galleries you " + action + "</a>";
                    content_type = "gallery";
                    break;

            }
            //**********************************************************
            // Generate Output Panel
            //**********************************************************
            int total_votes = Liked + Disliked;
            var str = new StringBuilder();
            str.AppendLine("<div class=\"card\"><div class=\"card-body\"");
            str.AppendLine("<div class=\"m-b-10\">You " + action + " this " + content_type + ". Thanks for the rating feedback!");
            if (UserName != "") // if user logged in
                str.AppendLine(" See more " + content_url + ".");
            str.AppendLine("</div>");
            str.AppendLine("<div class=\"m-b-10\"><strong>Rating for this " + content_type + " </strong><span class=\"normal-text reverse\">(" + TotalRatings + " total, " + Avg_Ratings + " out of 5)</span>");
            str.AppendLine("\n");
            // internal rating section
            str.AppendLine("<div class=\"m-b-5\">");
            str.AppendLine("<ul class='star-rating'>");
            str.AppendLine("<li class='current-rating' style=\"width:" + Calculate_Ratings(Avg_Ratings) + "px;\">Currently " + Math.Round(Avg_Ratings, 2) + "/5 Stars.</li>");
            str.AppendLine("<li><a href='#' title='1 star out of 5' class='one-star'>1</a></li>");
            str.AppendLine("<li><a href='#' title='2 stars out of 5' class='two-stars'>2</a></li>");
            str.AppendLine("<li><a href='#' title='3 stars out of 5' class='three-stars'>3</a></li>");
            str.AppendLine("<li><a href='#' title='4 stars out of 5' class='four-stars'>4</a></li>");
            str.AppendLine("<li><a href='#' title='5 stars out of 5' class='five-stars'>5</a></li>");
            str.AppendLine("</ul>");
            str.AppendLine("</div>");
            str.AppendLine("</div>");
            str.AppendLine("</div></div>");
            return Config.SetHiddenMessage_v2(str.ToString(), ElementID, true, 4);

        }

        private string Generate_Rating_Bx(int Liked, int Disliked)
        {
            var str = new StringBuilder();
            int total_liked = Liked + Disliked;
            double liked_percentage = (double)(Liked * 100) / total_liked;
            double disliked_percentage = (double)(Disliked * 100) / total_liked;
            if (liked_percentage > 0 || disliked_percentage > 0)
            {
                if (liked_percentage > 98)
                {
                    str.AppendLine("<div id=\"like_rating\" style=\"width: 100%;\" class=\"bx_like\"></div>");
                }
                else if (disliked_percentage > 98)
                {
                    str.AppendLine("<div id=\"dislike_rating\" style=\"width: 100%;\" class=\"bx_dislike\"></div>");
                }
                else
                {
                    disliked_percentage = 100 - liked_percentage; // 7 for creating gap between two meters.
                                                                  // liked meter
                    str.AppendLine("<div class=\"mb5\">");
                    str.AppendLine("<div id=\"like_rating\" style=\"width: " + Convert.ToInt32(liked_percentage).ToString() + "%;\" class=\"bx_like\"></div>");
                    str.AppendLine("</div>");
                    str.AppendLine("<div class=\"mb5\">");
                    str.AppendLine("<div id=\"dislike_rating\" style=\"width: " + Convert.ToInt32(disliked_percentage).ToString() + "%;\" class=\"bx_dislike\"></div>");
                    str.AppendLine("</div>");
                    str.AppendLine("\n");

                }
            }
            else
            {
                // no liked or disliked yet
                // show full rating
                str.AppendLine("<div id=\"like_rating\" style=\"width: 100%;\" class=\"bx_like\"></div>");
            }

            return str.ToString();
        }

        private int Calculate_Ratings(double Avg_Ratings)
        {
            return (int)Avg_Ratings * 24; // 24x24 each rating size
        }

        /* resize remote images */
        public ActionResult resize()
        {
            string FileName = "";
            int width = 800;
            int height = 600;


            if (Request.Params["file"] != null)
            {
                FileName = Server.UrlDecode(Request.Params["file"].ToString());
            }

            if (Request.Params["size"] != null)
            {
                string[] arr = Request.Params["size"].ToString().Split(char.Parse("x"));
                if (arr.Length > 0)
                {
                    width = Convert.ToInt32(arr[0].Trim());
                    height = Convert.ToInt32(arr[1].Trim());
                }
            }

            var ht = new Hashtable();
            Byte[] arrImg = null;
            var ImageID = Guid.NewGuid().ToString().Substring(0, 6);
            // get original photo url
            string _fileName = FileName.Replace("thumbs/", "");
            // download and save image in memory stream
            var client = new WebClient();
            byte[] imageBytes = client.DownloadData(_fileName);
            byte[] bFile;
            bFile = Jugnoon.Utility.Image.Generate_Online_Thumbnail(new MemoryStream(imageBytes), width, height);
            ht.Add(ImageID, bFile);

            arrImg = (byte[])ht[ImageID];

            return base.File(arrImg, "image/jpeg");

        }
    }
}