﻿using System.Web.Mvc;
using Jugnoon.Utility;
using Jugnoon.Settings;
using Jugnoon.BLL;

namespace JgnEnt.Controllers
{
    public class searchController : Controller
    {      

        // GET: search
        public ActionResult result(string term)
        {
            ViewBag.title= Resources.vsk.searchresult + " | " + Site_Settings.Page_Caption;

            var model = new Jugnoon.models.SearchModelView();

            model.isSearch = false;
            var _term_url = term; // UtilityBLL.ReplaceSpaceWithHyphin_v2(term);

            // if search option not used in advance search
            if (term != null)
                term = UtilityBLL.CleanSearchTerm(Server.UrlDecode(term).Trim()); //UtilityBLL.ReplaceHyphinWithSpace(term.ToLower()).Trim();
            else
                return Redirect("/");

            model.isSearch = true;

            model.RawTerm = term;
            string search_term = UtilityBLL.CleanSearchTerm(model.RawTerm).Trim();
            model.SearchTerm = UtilityBLL.ReplaceHyphinWithSpace(search_term);

            //*********************************************
            // User Search Tracking Script
            //********************************************
            // User search term storing and tracking
            // Good for generating wide range of tags based on user searches.
            // Help to improve, present your website data to search engines.
            // Search Record Tracking, if user search term less than 25 characters
            if (Site_Settings.StoreSearches)
            {
                if (search_term.Length > 3 && search_term.Length < 25)
                {
                    // validate user friendly searches
                    if (DictionaryBLL.Validate_Search_Word(search_term.Trim()))
                    {
                        // If search term already exist then stop adding dubplicate tag
                        if (!search_term.Trim().Contains("@"))
                        {
                            var count = TagsBLL.Count(new Jugnoon.Entity.TagEntity()
                            {
                                type = 5, // generalize tag
                                tag_type = 1, // search based generated tag
                                status = 1 // enable tag directly
                            });
                            if (count == 0)
                            {
                                int type = 5; // generalize tag
                                int tag_type = 1; // search based generated tag
                                int status = 1; // enable tag directly
                                int records = 1; // show one record in start by selected tag
                                TagsBLL.Add(Request.Params["query"].ToString().Trim(), type, records, tag_type, status, search_term.Trim());
                            }
                        }

                    }
                }
            }
            return View(model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult query(JgnEnt.models.ViewModels.List.SearchListModel model)
        {
            return Redirect(Config.GetUrl("search/result/" + Server.UrlEncode(UtilityBLL.CleanSearchTerm(model.Query))));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult wiki(JgnEnt.models.ViewModels.List.SearchListModel model)
        {
            return Redirect(Config.GetUrl("glossary/term/" + Server.UrlEncode(model.Query)));
        }
    }
}