﻿using Jugnoon.BLL;
using System;
using System.Web.Mvc;
using Jugnoon.Entity;

namespace JgnEnt.Controllers
{
    public class sitemapsController : Controller
    {      

        public ActionResult albums()
        {
            string sXml = "";
            int responsetype = 0; // 0: google, 1: bing
            if (Request.Params["rt"] != null)
                responsetype = Convert.ToInt32(Request.Params["rt"]);
            int type = 0;
            if (Request.Params["type"] != null)
                type = Convert.ToInt32(Request.Params["type"]);
            switch (responsetype)
            {
                case 0:
                    sXml = GalleryBLLC.generateGoogleSitemap(new AlbumEntity()
                    {
                        type = type,
                        pagesize = 50000,
                        order = "galleryid desc"
                    }); 
                    break;
                case 1:
                    sXml = GalleryBLLC.GenerateBingSitemap(new AlbumEntity()
                    {
                        type = type,
                        pagesize = 50000,
                        order = "galleryid desc"
                    });
                    break;
            }

            return this.Content(sXml, "text/xml");
        }
      
        public ActionResult categories()
        {
            int type = 0;
            // Category Type:
            // ........... 0: Videos // Default
            // ........... 1: Groups
            // ........... 5: Photos
            // ........... 6: Blogs
            // ........... 7: Audio
            // ........... 8: Galleries
            // ........... 12 Forum
            if (Request.Params["type"] != null && Request.Params["type"] != "")
            {
                type = Convert.ToInt32(Request.Params["type"]);
            }
            string sXml = "";
            int responsetype = 0; // 0: google, 1: bing
            if (Request.Params["rt"] != null)
                responsetype = Convert.ToInt32(Request.Params["rt"]);
            switch (responsetype)
            {
                case 0:
                    sXml = XMLBLL.Google_CategorySitemap(new CategoryEntity()
                    {
                        type = type,
                        pagesize = 50000,
                        order= "categoryid desc"
                    });
                    break;
                case 1:
                    sXml = XMLBLL.Bing_CategorySitemap(new CategoryEntity()
                    {
                        type = type,
                        pagesize = 50000,
                        order = "categoryid desc"
                    });
                    break;
            }

            return this.Content(sXml, "text/xml");
        }

        public ActionResult tags()
        {
            int pagenumber = 1;

            int type = 0;
            // Tags Type:
            // ........... 0: Videos
            // ........... 1: Groups
            // ........... 2: Photos
            // ........... 3: Blogs
            // ........... 4: Audio Files
            // ........... 5: Generalize
            // ........... 6: Galleries
            // .......... 7: Forums
            if (Request.Params["type"] != null && Request.Params["type"] != "")
            {
                type = Convert.ToInt32(Request.Params["type"]);
            }
            if (Request.Params["page"] != null && Request.Params["page"] != "")
            {
                pagenumber = Convert.ToInt32(Request.Params["page"]);
            }
            string sXml = "";
            int responsetype = 0; // 0: google, 1: bing
            if (Request.Params["rt"] != null)
                responsetype = Convert.ToInt32(Request.Params["rt"]);
            switch (responsetype)
            {
                case 0:
                    sXml = XMLBLL.Google_TagySitemap(new TagEntity()
                    {
                        type  = type,
                        pagesize = 50000,
                        pagenumber = pagenumber,
                        order = "tagid desc"
                    });
                    break;
                case 1:
                    sXml = XMLBLL.Bing_TagSitemap(new TagEntity()
                    {
                        type = type,
                        pagesize = 50000,
                        pagenumber = pagenumber,
                        order = "tagid desc"
                    });
                    break;
            }

            return this.Content(sXml, "text/xml");
        }

        public ActionResult videos()
        {
            int type = 0;
            // Tags Type:
            // ........... 0: Most Viewed
            // ........... 1: Top Rated
            // ........... 2: Recently Added
            if (Request.Params["type"] != null && Request.Params["type"] != "")
            {
                type = Convert.ToInt32(Request.Params["type"]);
            }
            int pagenumber = 1;
            if (Request.Params["p"] != null)
                pagenumber = Convert.ToInt32(Request.Params["p"]);
            string sXml = "";
            int responsetype = 0; // 0: google, 1: bing
            if (Request.Params["rt"] != null)
                responsetype = Convert.ToInt32(Request.Params["rt"]);
            switch (responsetype)
            {
                case 0:
                    sXml = VideoBLL.generateGoogleSitemap(new VideoEntity()
                    {
                        type = type,
                        pagesize = 50000,
                        order = "videoid desc"
                    });
                    break;
                case 1:
                    sXml = VideoBLL.GenerateBingSitemap(new VideoEntity()
                    {
                        type = type,
                        pagesize = 50000,
                        order = "videoid desc"
                    });
                    break;
            }

            return this.Content(sXml, "text/xml");
        }

    }
}