using System;
using System.Text;
using System.Collections.Generic;
using System.Collections;
using Jugnoon.Entity;
using Jugnoon.Utility;
using Jugnoon.Settings;
using System.Web;
using System.Web.Caching;
using System.IO;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;
using System.Linq;

namespace Jugnoon.BLL
{

    public class CategoryBLL
    {
        //// Important Notes
        public enum Types
        {
            Videos = 0,
            Groups = 1,
            Channels = 2,
            General = 3,
            AbuseReport = 4,
            Photos = 5,
            Blogs = 6,
            Audio = 7,
            Galleries = 8,
            QA = 11,
            Forum = 12,
            Classified = 13,
            Directories = 14,
            Polls = 15,
            Movie = 20
        };

        public static int Process(CategoryDataEntity entity)
        {
            if(entity.picturename.Length > 5)
            {
                /* photo there */
                if(!entity.picturename.StartsWith("http"))
                {
                    /* newly photo there */
                    try
                    {
                        var _temp_name = entity.picturename;
                        entity.picturename = Jugnoon.Helper.Category.UploadPhoto(entity.picturename);
                        if (entity.picturename.Contains("http"))
                        {
                            /* remove files from current system */
                            string strPath = HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath) + "//contents//category//";
                            string _filePath = strPath + "/" + _temp_name;
                            string _tempPath = strPath + "/temp/" + _temp_name;
                            if (File.Exists(_filePath))
                                File.Delete(_filePath);
                            if (File.Exists(_tempPath))
                                File.Delete(_tempPath);
                        }
                    }
                    catch(Exception ex)
                    {
                        /* error occured in picturename */
                        entity.picturename = "";
                    }
                }
            }

            using (var dbCtx = new mvcportalEntities())
            {
                if (entity.id == 0)
                {
                    var userEntity = new category()
                    {
                        title = entity.title,
                        parentid = (short)entity.parentid,
                        description = UtilityBLL.processNull(entity.description,0),
                        type = Convert.ToByte(entity.type),
                        priority = entity.priority,
                        status = Convert.ToByte(entity.status),
                        mode = Convert.ToByte(entity.mode),
                        term = UtilityBLL.processNull(entity.term,0),
                        level = "",
                        picturename = UtilityBLL.processNull(entity.picturename,0),
                        // created_at = DateTime.Now,
                        icon = UtilityBLL.processNull(entity.icon,0)
                    };
                    dbCtx.Entry(userEntity).State = System.Data.Entity.EntityState.Added;
                    DataBLL.SaveChanges(dbCtx);
                    entity.id = userEntity.id;
                }
                else
                {
                    using (var ctx = new mvcportalEntities())
                    {
                        var item = ctx.categories
                            .Where(p => p.id == entity.id)
                            .FirstOrDefault<category>();

                        item.description = entity.description;
                        item.title= entity.title;
                        item.parentid = Convert.ToInt16(entity.parentid);
                        item.priority = entity.priority;

                        item.status = Convert.ToByte(entity.status);
                        item.mode = Convert.ToByte(entity.mode);
                        item.picturename = entity.picturename;
                        item.icon = entity.icon;
                        DataBLL.SaveChanges(ctx);
                    }
                }
            }

            levelArr.Clear();
            string level = prepareLevel((short)entity.id);
            Update_Field(entity.id, level, "level");

            return entity.id;
        }

        public static void Delete(short id)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new category { id = id };
                dbCtx.categories.Attach(entity);
                dbCtx.categories.Remove(entity);
                dbCtx.SaveChanges();
            }
            
        }

        /* Utility Functions */
        public static bool Update_Field(long ID, dynamic Value, string FieldName)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.categories
                      .Where(p => p.id == ID)
                      .FirstOrDefault<category>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == FieldName.ToLower())
                        {
                            prop.SetValue(item, Value);
                        }
                    }
                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
               
            }
            return true;
        }

        public static bool Update_Field(long ID, DateTime Value, string FieldName)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.categories
                      .Where(p => p.id == ID)
                      .FirstOrDefault<category>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == FieldName.ToLower())
                        {
                            prop.SetValue(item, Value);
                        }
                    }
                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
                
            }
            return true;
        }

        public static string Get_Field_Value(long ID, string FieldName)
        {
            string Value = "";
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.categories
                        .Where(p => p.id == ID)
                        .FirstOrDefault<category>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == FieldName.ToLower())
                        {
                            Value = prop.GetValue(item, null).ToString();
                        }
                    }
                }
            }

            return Value;
        }

        public static List<CategoryDataEntity> LoadItems(CategoryEntity entity)
        {
            if (!entity.iscache || Config.GetCacheDuration() == 0 || entity.pagenumber > 5)
            {
                return FetchItems(entity);
            }
            else
            {
                string key = GenerateKey("ld_category", entity);
                if (HttpContext.Current.Cache[key] == null)
                    HttpContext.Current.Cache.Add(key, FetchItems(entity), null, DateTime.Now.AddMinutes(Config.GetCacheDuration()), TimeSpan.Zero, CacheItemPriority.High, null);

                var _list = (List<CategoryDataEntity>)(HttpContext.Current.Cache[key]);
                return _list;
            }
        }

        private static List<CategoryDataEntity> FetchItems(CategoryEntity entity)
        {
            var _list = new List<CategoryDataEntity>();

            using (var ctx = new mvcportalEntities())
            {
                entity.iscount = false;
                IQueryable<category> Query = ctx.categories;
                Query = BuildQuery(Query, entity);
                
                if (entity.id > 0)
                {
                    entity.loadall = true;

                    _list = LoadCompleteList(Query);
                }
               
                if (entity.issummary)
                {
                    _list = LoadSummaryList(Query);
                }
                else if (entity.isdropdown)
                {
                    _list = LoadDropdownList(Query);
                }
                else
                {
                    _list = LoadCompleteList(Query);
                }
            }

            return _list;
        }
        public static int Count(CategoryEntity entity)
        {
            if (!entity.iscache || Site_Settings.Cache_Duration == 0 || entity.pagenumber > 5)
            {
                return CountRecords(entity);
            }
            else
            {
                string key = GenerateKey("cnt_category", entity);
                if (HttpContext.Current.Cache[key] == null)
                {
                    int total_records = CountRecords(entity);

                    HttpContext.Current.Cache.Add(key, total_records, null, DateTime.Now.AddMinutes(Site_Settings.Cache_Duration), TimeSpan.Zero, CacheItemPriority.High, null);
                }
                return Convert.ToInt32(HttpContext.Current.Cache[key]);
            }
        }

        private static int CountRecords(CategoryEntity entity)
        {
            int Records = 0;
            using (var entities = new mvcportalEntities())
            {
                IQueryable<category> Query = entities.categories;
                entity.iscount = true;
                entity.id = 0;
                Query = BuildQuery(Query, entity);
                Records = Query.Count();
            }
            return Records;
        }
        
        private static string GenerateKey(string key, CategoryEntity entity)
        {
            var str = new StringBuilder();
            return key + entity.status + "" + entity.filter + "" + UtilityBLL.ReplaceSpaceWithHyphin(entity.order.ToLower()) + "" + entity.pagenumber + "" + entity.term + "" + entity.type + "" + entity.parentid + "" + entity.pagesize;
        }

        private static IQueryable<category> BuildQuery(IQueryable<category> query, CategoryEntity entity)
        {
            query = Where(query, entity);
            if (entity.id == 0 && !entity.iscount)
            {
                query = OrderBy(query, entity);
                query = Skip(query, entity);
                query = Limit(query, entity);
            }
            return query;
        }

        public static List<CategoryDataEntity> LoadCompleteList(IQueryable<category> query)
        {
            return query.Select(p => new CategoryDataEntity
            {
                id = p.id,
                title = p.title,
                description = p.description,
                parentid = p.parentid,
                // created_at = (DateTime)p.created_at,
                type = p.type,
                priority = p.priority,
                status = p.status,
                mode = p.mode,
                term = p.term,
                picturename = p.picturename,
                records = p.records,
                level = p.level
            }).ToList();
        }
        public static List<CategoryDataEntity> LoadSummaryList(IQueryable<category> query)
        {
            return query.Select(p => new CategoryDataEntity
            {
                id = p.id,
                title = p.title,
                parentid = p.parentid,
                // created_at = (DateTime)p.created_at,
                type = p.type,
                priority = p.priority,
                status = p.status,
                mode = p.mode,
                term = p.term,
                picturename = p.picturename,
                records = p.records,
                level = p.level
            }).ToList();
        }
        public static List<CategoryDataEntity> LoadDropdownList(IQueryable<category> query)
        {
            return query.Select(p => new CategoryDataEntity
            {
                id = p.id,
                title = p.title,
                term = p.term,
                type = p.type,
                records = p.records,
                level = p.level
            }).ToList();
        }

        private static IQueryable<category> Where(IQueryable<category> query, CategoryEntity entity)
        {
            
            if (entity.id > 0)
                query = query.Where(p => p.id == entity.id);
            else
            {
                if (entity.excludedid > 0)
                    query = query.Where(p => p.id != entity.excludedid);
                if (entity.parentid > -1)
                    query = query.Where(p => p.parentid == entity.parentid);

                if (entity.status != 2)
                {
                    query = query.Where(p => p.status == entity.status);
                }

                if (entity.type != 100)
                    query = query.Where(p => p.type == entity.type);

                if (entity.mode > 0)
                    query = query.Where(p => p.mode == entity.mode);

                if (entity.term != "")
                    query = query.Where(p => p.title.Contains(entity.term) || p.description.Contains(entity.term));

            }

            return query;
        }
           
        private static IQueryable<category> OrderBy(IQueryable<category> query, CategoryEntity entity)
        {
            if (entity.order != "")
            {
                var orderlist = entity.order.Split(char.Parse(","));
                foreach (var order in orderlist)
                {
                    if (order.Contains("level"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.level);
                        else
                            query = query.OrderBy(p => p.level);
                    }
                    else if (order.Contains("title"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.title);
                        else
                            query = query.OrderBy(p => p.title);
                    }
                    else if (order.Contains("id"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.id);
                        else
                            query = query.OrderBy(p => p.id);
                    }
                }
            }

            return query;
        }

        private static IQueryable<category> Skip(IQueryable<category> query, CategoryEntity entity)
        {
            if (entity.pagenumber > 1)
                query = query.Skip(entity.pagesize * (entity.pagenumber - 1));

            return query;
        }

        private static IQueryable<category> Limit(IQueryable<category> query, CategoryEntity entity)
        {
            if (!entity.loadall)
                query = query.Take(entity.pagesize);

            return query;
        }
     
        public static string ProcessAction(List<CategoryEntity> list)
        {
            foreach (CategoryEntity entity in list)
            {
                if (entity.id > 0)
                {
                    switch (entity.actionstatus)
                    {
                        case "enable":
                            CategoryBLL.Update_Field(entity.id, (byte)1, "status");
                            break;

                        case "disable":
                            CategoryBLL.Update_Field(entity.id, (byte)0, "status");
                            break;

                        case "delete":
                            CategoryBLL.Delete((short)entity.id);
                            if (!string.IsNullOrEmpty(                                                                                                                                          entity.picturename))
                            {
                                string RootPath = HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath);
                                string dirPath = RootPath + "/contents/category/";
                                string thumbPath = dirPath + "temp/";
                                if (File.Exists(dirPath + entity.picturename))
                                {
                                    File.Delete(dirPath + entity.picturename);
                                }
                                if (File.Exists(thumbPath + entity.picturename))
                                {
                                    File.Delete(thumbPath + entity.picturename);
                                }
                            }
                            break;
                    }
                }
            }
            return "Operation performed successfully";
        }

        //*****************************************************************************
        // Utility Function
        //*****************************************************************************
        public static string return_hyphin(string level)
        {
            var str = new StringBuilder();
            foreach (char c in level)
            {
                if (c == '.')
                {
                    str.Append("- ");
                }
            }
            return str.ToString();
        }

        public static ArrayList levelArr = new ArrayList();
        public static string prepareLevel(short CategoryID)
        {
            levelArr.Add(CategoryID.ToString());
            GenerateLevel(CategoryID);
            levelArr.Reverse();

            StringBuilder Level = new StringBuilder();
            if (levelArr.Count > 0)
            {
                int counter = 0;
                for (int i = 0; i <= levelArr.Count - 1; i++)
                {
                    if (counter > 0)
                    {
                        Level.Append(".");
                    }
                    Level.Append(levelArr[i]);
                    counter += 1;
                }
            }
            return Level.ToString();
        }

        public static void GenerateLevel(short CategoryID)
        {
            short ParentID = 0;
            using (var dbCtx = new mvcportalEntities())
            {
                ParentID = dbCtx.categories.Where(u => u.id == CategoryID).Select(u => u.parentid).ToList()[0];
            }
            //short ParentID = Convert.ToInt16(Return_Field_Value("parentid", "id", CategoryID.ToString()));

            if (ParentID == CategoryID)
            {
                levelArr.Add(ParentID.ToString());
            }
            else if (ParentID > 0)
            {
                levelArr.Add(ParentID);

                if (Count(new CategoryEntity { parentid = ParentID }) > 0)
                {
                    GenerateLevel(ParentID);
                }
            }

        }

        public static List<CategoryEntity> Fetch_Category_Names(int type)
        {
            var list = new List<CategoryEntity>();
            using (var dbCtx = new mvcportalEntities())
            {
                var Query = dbCtx.categories
                  .Where(o => o.type == type);
                list = Query.Select(p => new CategoryEntity
                {
                    title = p.title,
                    term = p.term

                }).ToList();

            }
            return list;
           
        }

    }
}