﻿using System.Data;
using System.Web;
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;
using System.Collections.Generic;
using Jugnoon.Entity;

namespace Jugnoon.BLL
{
    public class ConfigurationBLL
    {
        // Important Terms
    
        public ConfigurationBLL()
        { }

        public static void Update_Value(int id, string value)
        {

            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.configurations
                     .Where(p => p.id == id)
                     .FirstOrDefault<configuration>();

                if(item != null)
                   item.value = value;
               
                DataBLL.SaveChanges(ctx);
            }

            // Refresh Application Stat Value
            string cache_key = "config_" + id;
            HttpContext.Current.Application[cache_key] = value;
        }

        public static string Return_Value(int id)
        {
            // Implement Cache Approach To Store Configuration Values
            string cache_key = "config";
            if (HttpContext.Current.Application[cache_key] == null)
            {
                HttpContext.Current.Application.Add(cache_key, Load(new ConfigEntity()
                {}));
            }
            var _configs = (List<ConfigDataEntity>)HttpContext.Current.Application[cache_key.ToString()];

            foreach (var item in _configs)
            {
                if(item.id == id)
                {
                    return item.value;
                }
            }   

            return "";

        }

        public static string FetchValue(int id)
        {
            // Implement Cache Approach To Store Configuration Values
            string cache_key = "config_db_" + id;
            if (HttpContext.Current.Application[cache_key] == null)
                HttpContext.Current.Application.Add(cache_key, Return_NoCache_Value(id));

            return HttpContext.Current.Application[cache_key.ToString()].ToString();

        }
        public static string Return_NoCache_Value(int id)
        {
            string Value = "";
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.configurations
                     .Where(p => p.id == id)
                     .FirstOrDefault<configuration>();

                if(item != null)
                   Value = item.value;

            }
            
            return Value;
        }

        // cache version
        public static List<ConfigDataEntity> LoadItmes(ConfigEntity entity)
        {
            // Implement Cache Approach To Store Configuration Values
            string cache_key = "config_ld_" + entity.type + "_" + entity.id;
            if (HttpContext.Current.Application[cache_key] == null)
                HttpContext.Current.Application.Add(cache_key, Load(entity));

            return (List<ConfigDataEntity>)HttpContext.Current.Application[cache_key.ToString()];

        }

        public static List<ConfigDataEntity> Load(ConfigEntity entity)
        {
            var _list = new List<ConfigDataEntity>();

            using (var ctx = new mvcportalEntities())
            {
                IQueryable<configuration> Query = ctx.configurations;
                Query = BuildQuery(Query, entity);

                if (entity.id > 0)
                {
                    entity.loadall = true;

                    _list = LoadCompleteList(Query);
                }

                _list = LoadCompleteList(Query);
            }

            return _list;
        }
               

        private static IQueryable<configuration> BuildQuery(IQueryable<configuration> query, ConfigEntity entity)
        {
            query = Where(query, entity);
            return query;
        }

        public static List<ConfigDataEntity> LoadCompleteList(IQueryable<configuration> query)
        {
            return query.Select(p => new ConfigDataEntity
            {
                id = (int)p.id,
                value = p.value
            }).ToList();
        }
      
        private static IQueryable<configuration> Where(IQueryable<configuration> query, ConfigEntity entity)
        {
            if (entity.id > 0)
                query = query.Where(p => p.id == entity.id);
            if (entity.type > 0)
                query = query.Where(p => p.type == entity.type);

            return query;
        }
      
    }
}