﻿using System.Web;
using System.Text.RegularExpressions;
using System.Text;
using System.Collections.Generic;
/* Site Own Namespaces */
using Jugnoon.Entity;
using Jugnoon.Utility;
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;

namespace Jugnoon.BLL
{
    public class DictionaryBLL
    {
        // Note: DictionaryBLL Important Terms
        // Type:
        // .............. 0 :-> Content Restricted Values
        // .............. 1 :-> UserName Restricted Values

        // isrestrict:
        // .............. 1:-> screen data and no restriction mean screen data and highlight it on control panel
        // .............. 2:-> screen data and restrict it e.g book -> b**k

        private static int isRestrict = Config.Get_ScreeningOption();
        public DictionaryBLL()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        public static DictionaryEntity Add(DictionaryEntity data)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new dictionary()
                {
                    value = data.value,
                    type = (byte)data.type
                };
                dbCtx.Entry(entity).State = System.Data.Entity.EntityState.Added;

                DataBLL.SaveChanges(dbCtx);
                data.id = entity.id;
            }
            
            HttpContext.Current.Application["ld_screen_" + data.type] = Fetch_Values(data.type); // Update values in application state
            Update_Values(); // Update values in application state

            return data;
        }

        public static void Update(DictionaryEntity entity)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.dictionaries
                    .Where(p => p.id == entity.id)
                    .FirstOrDefault<dictionary>();

                if(item != null)
                {
                    item.value = entity.value;
                    DataBLL.SaveChanges(ctx);
                }
               
            }
        }

        public static bool CheckValue(string value, int type)
        {
            var Flag = false;
            using (var dbCtx = new mvcportalEntities())
            {
                var count = dbCtx.dictionaries
                  .Where(o => o.value == value && o.type == type)
                  .Count();

                if (count > 0)
                    Flag = true;
                else
                    Flag = false;

            }
            return Flag;
            
        }

        public static bool Delete(int id)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new dictionary { id = id };
                dbCtx.dictionaries.Attach(entity);
                dbCtx.dictionaries.Remove(entity);
                dbCtx.SaveChanges();
            }
            
            return true;
        }
            
        // old compatibility function
        public static List<DictionaryEntity> Return_DictionaryValues()
        {
            return Return_Values(0); // type 0:-> dictionary value
        }

        // old compatibility function
        public static string Return_RestrictedUserNames()
        {
            List<DictionaryEntity> _lst = Return_Values(1);
            StringBuilder keywords = new StringBuilder();
            if (_lst.Count > 0)
            {
                int i = 0;
                for (i = 0; i <= _lst.Count - 1; i++)
                {
                    if (i == 0)
                        keywords.Append(_lst[i].value);
                    else
                        keywords.Append("," + _lst[i].value);
                }
                return keywords.ToString();
            }
            else
            {
                return "";
            }
        }

        public static void Update_Values()
        {
            int type = 0;
            HttpContext.Current.Application["ld_screen_" + type] = Fetch_Values(type);
            type = 1;
            HttpContext.Current.Application["ld_screen_" + type] = Fetch_Values(type);
        }

        public static List<DictionaryEntity> Return_Values(int type)
        {
            if (HttpContext.Current.Application["ld_screen_" + type] == null)
            {
                HttpContext.Current.Application["ld_screen_" + type] = Fetch_Values(type);
            }

            List<DictionaryEntity> _list = (List<DictionaryEntity>)(HttpContext.Current.Application["ld_screen_" + type]);
            return _list;
        }

        private static List<DictionaryEntity> Fetch_Values(int type)
        {
            var _items = new List<DictionaryEntity>();
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<dictionary> query = ctx.dictionaries
                     .Where(p => p.type == type);

                _items = query.Select(p => new DictionaryEntity
                {
                    value = p.value
                }).ToList();

            }

            return _items;
        }

        // Core function to process screening data
        public static string Process_Screening(string text)
        {
            if (text == null)
                return "";
                
            var _lst = Return_Values(0);
            if (_lst.Count == 0)
                return text;

            StringBuilder keywords = new StringBuilder();
            if (_lst.Count > 0)
            {
                int i = 0;
                // create output like (apple|banana|mango)
                for (i = 0; i <= _lst.Count - 1; i++)
                {
                    if (_lst.Count == 1)
                        keywords.Append("(" + @"\b" + _lst[i].value.Trim() + @"\b)");
                    else if (i == 0)
                        keywords.Append("(" + @"\b" + _lst[i].value.Trim() + @"\b");
                    else if (i == _lst.Count - 1)
                        keywords.Append("|" + @"\b" + _lst[i].value.Trim() + @"\b)");
                    else
                        keywords.Append("|" + @"\b" + _lst[i].value.Trim() + @"\b");
                }
                string key = keywords.ToString();
                //// Swap out the ,<space> for pipes and add the braces
                Regex r = new Regex(", ?");
                //string keyword = "(" + r.Replace(keywords.ToString(), "|") + ")";

                // Get ready to replace the keywords
                MatchEvaluator _match = null;
                if (isRestrict == 0)
                    _match = new MatchEvaluator(MatchEval);
                else
                    _match = new MatchEvaluator(RestrictMatchEval);

                r = new Regex(keywords.ToString(), RegexOptions.IgnoreCase);

                //// Do the replace
                return r.Replace(text, _match);
            }
            else
            {
                return "";
            }
        }

        public static string MatchEval(Match match)
        {
            if (match.Groups[1].Success)
            {
                return "<span class=\"label label-danger\">" + match.ToString() + "</span>";
            }
            else
            {
                // no match
                return "";
            }
        }

        public static string RestrictMatchEval(Match match)
        {
            if (match.Groups[1].Success)
            {
                return UtilityBLL.Restrict_Word(match.ToString());
            }
            else
            {
                // no match
                return "";
            }
        }

        // check for match content with provided keywords
        public static bool isMatch(string text, string keywords)
        {
            bool flg = false;
            var RestrictedWords = keywords.Split(char.Parse(","));
            foreach(var Word in RestrictedWords)
            {
                if (text.Contains(Word))
                    return true;
            }
            return flg;
        }

        // validate search terms with bad user searches
        public static bool Validate_Search_Word(string text)
        {
            bool flag = true; // valid word
            List<DictionaryEntity> _lst = Return_Values(0);
            if (_lst.Count > 0)
            {
                int i = 0;
                // create output like (apple|banana|mango)
                for (i = 0; i <= _lst.Count - 1; i++)
                {
                    if (flag)
                    {
                        if (text.Contains(_lst[i].value))
                            flag = false;
                    }
                }
            }

            return flag;
        }


        public static List<DictionaryEntity> Load(DictionaryEntity entity)
        {
            var _list = new List<DictionaryEntity>();

            using (var ctx = new mvcportalEntities())
            {
                IQueryable<dictionary> Query = ctx.dictionaries;
                Query = BuildQuery(Query, entity);
              
                if (entity.id > 0)
                {
                    entity.loadall = true;

                    _list = LoadCompleteList(Query);
                }
                if (entity.isdropdown)
                {
                    _list = LoadDropdownList(Query);
                }
                else
                {
                    _list = LoadCompleteList(Query);
                }
            }

            return _list;
        }

        

        public static int Count(DictionaryEntity entity)
        {
            int Records = 0;
            using (var entities = new mvcportalEntities())
            {
                IQueryable<dictionary> Query = entities.dictionaries;
                entity.iscount = true;
                entity.id = 0;
                Query = BuildQuery(Query, entity);
                Records = Query.Count();
            }
            return Records;
        }
        
        private static IQueryable<dictionary> BuildQuery(IQueryable<dictionary> query, DictionaryEntity entity)
        {
            query = Where(query, entity);
            if (entity.id == 0 && !entity.iscount)
            {
                query = OrderBy(query, entity);
                query = Skip(query, entity);
                query = Limit(query, entity);
            }
            return query;
        }

        public static List<DictionaryEntity> LoadCompleteList(IQueryable<dictionary> query)
        {
            return query.Select(p => new DictionaryEntity
            {
                id = (int)p.id,
                type = p.type,
                value = p.value
            }).ToList();
        }
        public static List<DictionaryEntity> LoadDropdownList(IQueryable<dictionary> query)
        {
            return query.Select(p => new DictionaryEntity
            {
                value = p.value
            }).ToList();
        }

        private static IQueryable<dictionary> Where(IQueryable<dictionary> query, DictionaryEntity entity)
        {
            if (entity.id > 0)
                query = query.Where(p => p.id == entity.id);
            if (entity.type > -1)
                query = query.Where(p => p.type == entity.type);
            if(entity.term != "")
                query = query.Where(p => p.value.Contains(entity.term));
            return query;
        }
        private static IQueryable<dictionary> OrderBy(IQueryable<dictionary> query, DictionaryEntity entity)
        {
            if (entity.order != "")
            {
                var orderlist = entity.order.Split(char.Parse(","));
                foreach (var order in orderlist)
                {
                    if (order.Contains("id"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.id);
                        else
                            query = query.OrderBy(p => p.id);
                    }
                    else if (order.Contains("value"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.value);
                        else
                            query = query.OrderBy(p => p.value);
                    }
                    else if (order.Contains("type"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.type);
                        else
                            query = query.OrderBy(p => p.type);
                    }
                }
            }

            return query;
        }
        private static IQueryable<dictionary> Skip(IQueryable<dictionary> query, DictionaryEntity entity)
        {
            if (entity.pagenumber > 1)
                query = query.Skip(entity.pagesize * (entity.pagenumber - 1));

            return query;
        }
        private static IQueryable<dictionary> Limit(IQueryable<dictionary> query, DictionaryEntity entity)
        {
            if (!entity.loadall)
                query = query.Take(entity.pagesize);

            return query;
        }

        public static string ProcessAction(List<DictionaryEntity> list)
        {
            foreach (DictionaryEntity entity in list)
            {
                if (entity.id > 0)
                {
                    switch (entity.actionstatus)
                    {
                        case "delete":
                            Delete(entity.id);

                            break;
                    }
                }
            }
            return "Operation performed successfully";
        }
    }
}