using System;
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;

namespace Jugnoon.BLL
{
    public class Favorites
    {
        // Note: Favorite Important Terms

        // Type
        // 0: Video or Audio
        // 1: QA
        // 2: Albums and Galleries

        // this class handle user favorite videos.

        public Favorites()
        {

        }

        public static bool Add(string username, long VideoID, int mediatype, int type)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                dbCtx.Entry(new favorite()
                {
                    videoid = VideoID,
                    username = username,
                    date_added = DateTime.Now,
                    type = (byte)type
                }).State = System.Data.Entity.EntityState.Added;

                DataBLL.SaveChanges(dbCtx);
            }

            Update_Fav_Stats(username, mediatype, type, 0);
            return true;
        }

        public static bool Delete(long contentid, string username, int mediatype, int type)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new favorite { videoid = contentid, username = username, type = (byte)type };
                dbCtx.favorites.Attach(entity);
                dbCtx.favorites.Remove(entity);
                dbCtx.SaveChanges();
            }
                      
            Update_Fav_Stats(username, mediatype, type, 1);
            return true;
        }

        private static void Update_Fav_Stats(string username, int mediatype, int type, int action)
        {
            if (type != 2)
            {
                // changes happend
                string _field = "stat_favorites";
                if (mediatype == 1)
                    _field = "stat_audiofavorites";
                else if (type == 1)
                    _field = "stat_qafavorites";

                int count = Convert.ToInt32(UserBLL.Return_Value(username, _field));
                if (action == 0)
                    count++;
                else
                    count--;
                if(type == 1)
                   UserBLL.Update_Field_V3(username, _field, (byte)count);
                else
                   UserBLL.Update_Field_V3(username, _field, (byte)count);
            }

        }

        public static bool Check(string username, long contentid, int type)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                if (ctx.favorites.Where(p => p.videoid == contentid && p.username == username && p.type == type).Count() > 0)
                    flag = true;
            }

            return flag;

        }
    }
}