﻿using System;
using System.Web;
using System.Collections.Generic;
using System.Web.Caching;
using System.Text;
/* Site Own Namespaces */
using Jugnoon.Entity;
using Jugnoon.Utility;
using Jugnoon.Settings;
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;
using System.IO;
using System.Data.Entity.SqlServer;

namespace Jugnoon.BLL
{

    public class GalleryBLLC
    {
        public GalleryBLLC()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        // Note: categories Important Terms

        // isdisabled:
        // ........... 0: Not Enabled.
        // ........... 1: Enabled
        // ........... 2: Both enabled, disabled

        // isadult:
        // ........... 0: Not Adult.
        // ........... 1: Adult

        // isapproved:
        // ........... 0: Not approved
        // ........... 1: Approved

        // isfeatured:
        // .......... 0: Normal
        // .......... 1: Featured
        // .......... 3: Premium
        // .......... 2: All

        // type:
        // .......... 0: Photo
        // .......... 1: Video
        // .......... 2: Audio

        // privacy 
        // .............. 0: public
        // .............. 1: private
        // .............. 2: Unlisted

        // AuthKey 
        // .............. [unique key] patch with gallery url in case of unlisted gallery

        // New Actions Avaialble in VSK 7.0 or later
        // contentid ---- 0 (default), id of content which have assign this record (e.g group, user profile etc)
        // content type --- 0 (default)
        // .............. 1: group
        // .............. 2: User profile
        public enum Types
        {
            Photos = 0,
            Videos = 1,
            Audio = 2
        };
        
        #region Action Script

        public static void Validation(AlbumDataEntity gal)
        {           
            if (gal.title != null &&  gal.title.Length > 150)
                gal.title= gal.title.Substring(0, 149);
            if (gal.description != null &&  gal.description.Length > 2000)
                gal.description = gal.description.Substring(0, 1999);
            if (gal.tags != null &&  gal.tags.Length > 300)
                gal.tags = gal.tags.Substring(0, 299);
        }

        public static AlbumDataEntity Add(AlbumDataEntity gal, bool isadmin)
        {
            if (Config.Get_ScreeningOption() == 1)
            {
                gal.title= DictionaryBLL.Process_Screening(gal.title);
                gal.description = DictionaryBLL.Process_Screening(gal.description);
                if (gal.tags != null)
                {
                    gal.tags = DictionaryBLL.Process_Screening(gal.tags);
                }
                else
                {
                    gal.tags = "";
                }
            }

            if (gal.privacy == 3)
                gal.privacy = 0;
           
            // assign current record with culture specific content (default english en)
            string culturename = "en";

            // validation 
            Validation(gal);

            long galleryid = 0;

            if (gal.authkey == null)
                gal.authkey = "";
            if (gal.categories == null)
                gal.categories = "";
            if (gal.artistid == null)
                gal.artistid = 0;
            if (gal.picturename.Length > 5)
            {
                /* photo there */
                if (gal.picturename != "")
                {
                    if (!gal.picturename.StartsWith("http"))
                    {
                        /* newly photo there */
                        try
                        {
                            var _temp_name = gal.picturename;
                            gal.picturename = Jugnoon.Helper.Album.UploadPostCover(gal.picturename, gal.username);
                            if (gal.picturename.Contains("http"))
                            {
                                /* remove files from current system */
                                string strPath = HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath) + "//contents//member//" + gal.username + "//photos//";
                                string _filePath = strPath + "/" + _temp_name;
                                string _tempPath = strPath + "/midthumbs/" + _temp_name;
                                string _thumbPath = strPath + "/thumbs/" + _temp_name;
                                if (File.Exists(_filePath))
                                    File.Delete(_filePath);
                                if (File.Exists(_tempPath))
                                    File.Delete(_tempPath);
                                if (File.Exists(_thumbPath))
                                    File.Delete(_thumbPath);
                            }
                        }
                        catch (Exception ex)
                        {
                            /* error occured in picturename */
                            // gal.picturename = "";
                        }
                    }
                }
            }

            using (var dbCtx = new mvcportalEntities())
            {
                var _entity = new gallery()
                {
                    categories = gal.categories,
                    username = gal.username,
                    title = gal.title,
                    description = gal.description,
                    tags = gal.tags,
                    isdisabled = (byte)gal.isdisabled,
                    isapproved = (byte)gal.isapproved,
                    added_date = DateTime.Now,
                    language = culturename,
                    type = (byte)gal.type,
                    mode = (byte)gal.mode,
                    privacy = (byte)gal.privacy,
                    authkey = gal.authkey,
                    picturename = gal.picturename,
                    artistid = (long)gal.artistid,
                    total_photos = gal.total_photos
                };
                dbCtx.Entry(_entity).State = System.Data.Entity.EntityState.Added;

                DataBLL.SaveChanges(dbCtx);

                gal.galleryid = _entity.galleryid;
            }
     
            // send notification mail to admin
            if (!isadmin)
            {
                string _ctype = "photo gallery";
                if (gal.type == 1)
                    _ctype = "video album";
                else if (gal.type == 2)
                    _ctype = "audio album";

                MailProcess.Admin_New_Content_Added(gal.username, _ctype, "");
            }
            return gal;
        }

        public static void Update(AlbumDataEntity entity, bool isadmin)
        {
            if (Config.Get_ScreeningOption() == 1)
            {
                entity.title= DictionaryBLL.Process_Screening(entity.title);
                entity.description = DictionaryBLL.Process_Screening(entity.description);
                if (entity.tags != null)
                {
                    entity.tags = DictionaryBLL.Process_Screening(entity.tags);
                }
                else
                {
                    entity.tags = "";
                }
            }
            // *********************************************************//
            // *********************************************************//

            // Validation
            Validation(entity);
            if (entity.artistid == null)
                entity.artistid = 0;

            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.galleries
                     .Where(p => p.galleryid == entity.galleryid)
                     .FirstOrDefault<gallery>();

                if (item != null)
                {
                    item.categories = string.Join(",", entity.categories);
                    item.title = UtilityBLL.processNull(entity.title, 0);
                    item.description = UtilityBLL.processNull(entity.description, 0);
                    item.tags = entity.tags;
                    item.isadult = (byte)entity.isadult;
                    item.iscomments = (byte)entity.iscomments;
                    item.privacy = (byte)entity.privacy;
                    item.artistid = (long)entity.artistid;
                    if (isadmin)
                    {
                        item.views = entity.views;
                        item.liked = entity.liked;
                        item.favorites = entity.favorites;
                        item.disliked = entity.disliked;
                        item.isfeatured = entity.isfeatured;
                        item.isdisabled = entity.isdisabled;
                        item.isapproved = entity.isapproved;
                    }

                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
            }
        }

        public static void Delete(long galleryid)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new gallery { galleryid = galleryid };
                dbCtx.galleries.Attach(entity);
                dbCtx.galleries.Remove(entity);
                dbCtx.SaveChanges();
            }
        }
        

        // Enable Disable Photos
        public static bool Validate_GalleryID(long galleryid)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                if (ctx.galleries.Where(p => p.galleryid == galleryid).Count() > 0)
                    flag = true;
            }

            return flag;

        }

        // Check ownership of gallery
        public static bool Check(long galleryid, string username)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                if (ctx.galleries.Where(p => p.galleryid == galleryid && p.username == username).Count() > 0)
                    flag = true;
            }

            return flag;
         
        }

        // Approve / Disapprove gallery
        public static bool Update_IsApproved(long PostID, int OldValue, int NewValue, string UserName, int type)
        {
            Update_Field_V3(PostID, (byte)NewValue, "isApproved");

            // approve all contents within gallery or album
            if (type == 0)
            {
                // photo gallery
                // photo functionality not exist in this build
            }
            else
            {
                // audio or video gallery
                VideoBLL.Update_isApproved_All(PostID, UserName, NewValue, type);
            }
            // send mail to user when admin update content status
            if (NewValue == 1)
            {
                string _path = "galleries/";
                string _contenttype = "photo galleries";
                if (type == 1)
                {
                    _path = "albums/";
                    _contenttype = "video albums";
                }
                else if (type == 2)
                {
                    _path = "audio/albums/";
                    _contenttype = "audio albums";
                }
                string url = "<a href=\"" + Config.GetUrl("myaccount/" + _path) + "\">Manage Galleries</a>";
                MailProcess.User_Mail_Content_Action(UserName, _contenttype, url, "approved");
            }
            return true;
        }

        // Enable / Disable gallery
        public static bool Update_IsEnabled(long PostID, int OldValue, int NewValue, string UserName, int type)
        {
            Update_Field_V3(PostID, (byte)NewValue, "isdisabled");

            // approve all contents within gallery or album
            if (type == 0)
            {
                // photo gallery
                // photo functionality not exist in this build
            }
            else
            {
                // audio or video gallery
                VideoBLL.Update_isEnabled_All(PostID, UserName, NewValue, type);
            }

            return true;
        }

        // update total photos statistics
        public static bool Update_Info(long GalleryID, int Total_Photos, string PictureName)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.galleries
                     .Where(p => p.galleryid == GalleryID)
                     .FirstOrDefault<gallery>();

                if(item != null)
                {
                    item.total_photos = (short)Total_Photos;
                    item.picturename = PictureName;

                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
               
            }
           
            return true;
        }

        public static bool Update_Field_V3(long ID, dynamic Value, string FieldName)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.galleries
                     .Where(p => p.galleryid == ID)
                     .FirstOrDefault<gallery>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == FieldName.ToLower())
                        {
                            prop.SetValue(item, Value);
                        }
                    }
                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
                
            }
            return true;
        }

      

        public static bool Update_Field_V3(long ID, DateTime Value, string FieldName)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.galleries
                     .Where(p => p.galleryid == ID)
                     .FirstOrDefault<gallery>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == FieldName.ToLower())
                        {
                            prop.SetValue(item, Value);
                        }
                    }
                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
                
            }
            return true;
        }
        public static double Post_Rating(long galleryid, int current_rating, int total_ratings, double ratings)
        {
            // increment 
            total_ratings = total_ratings + 1;
            ratings = ratings + current_rating;
            double average_rating = (double)Math.Round(ratings / total_ratings, 2);
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.galleries
                     .Where(p => p.galleryid == galleryid)
                     .FirstOrDefault<gallery>();

                if(item != null)
                {
                    item.ratings = (float)ratings;
                    item.total_rating = total_ratings;
                    item.avg_rating = (float)average_rating;

                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
                
            }
           
            return average_rating;
        }


        public static string Get_Field_Value(long ID, string FieldName)
        {
            string Value = "";
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.galleries
                     .Where(p => p.galleryid == ID)
                     .FirstOrDefault<gallery>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == FieldName.ToLower())
                        {
                            if (prop.GetValue(item, null) != null)
                                Value = prop.GetValue(item, null).ToString();
                        }
                    }

                }
                

            }

            return Value;
        }
           
        #endregion

        #region Core Loading Script

        public static List<AlbumDataEntity> LoadItems(AlbumEntity entity)
        {
            if (!entity.iscache || Config.GetCacheDuration() == 0 || entity.pagenumber > 5)
            {
                return FetchItems(entity);
            }
            else
            {
                string key = GenerateKey("lg_gallery_", entity);
                if (CloudSettings.EnableRedisCache)
                    return _Fetch_Redis_Cache(entity, key);
                else
                    return _Fetch_Normal_Cache(entity, key);
            }
        }


        private static List<AlbumDataEntity> FetchItems(AlbumEntity entity)
        {
            var _list = new List<AlbumDataEntity>();

            using (var ctx = new mvcportalEntities())
            {
                entity.iscount = false;
                if (entity.loadliked)
                {
                    // INNER JOIN WITH USER RATING TABLE
                    _list = LoadLikedItems(entity);
                }
                else if(entity.loadfavorites)
                {
                    // INNER JOIN WITH USER Favorited TABLE
                    _list = LoadFavorited(entity);
                }
                else
                {
                    // No INNER JOIN
                    var Query = GetLoadQuery(ctx, entity);
                    if (entity.galleryid > 0)
                    {
                        entity.loadall = true;
                        _list = LoadCompleteList(Query);
                    }
                    else if (entity.issummary)
                    {
                        _list = LoadSummaryList(Query);
                    }
                    else if (entity.isdropdown)
                    {
                        _list = LoadDropdownList(Query);
                    }
                    else
                    {
                        _list = LoadCompleteList(Query);
                    }
                }

            }

            return _list;
        }
        public static int Count(AlbumEntity entity)
        {
            if (!entity.iscache || Site_Settings.Cache_Duration == 0 || entity.pagenumber > 5)
            {
                return CountRecords(entity);
            }
            else
            {
                string key = GenerateKey("cnt_gallery_1", entity);
                if (CloudSettings.EnableRedisCache)
                    return _Count_Redis_Cache(entity, key);
                else
                    return _Count_Normal_Cache(entity, key);
            }
        }

        private static int CountRecords(AlbumEntity entity)
        {
            int Records = 0;
            using (var entities = new mvcportalEntities())
            {
                if (entity.loadliked)
                {
                    // INNER JOIN WITH USER RATING TABLE
                    Records = CountLikedItems(entity);
                }
                else if (entity.loadfavorites)
                {
                    // INNER JOIN WITH USER Favorited TABLE
                    Records = CountFavorited(entity);
                }
                else
                {
                    IQueryable<gallery> Query = entities.galleries;
                    entity.iscount = true;
                    entity.galleryid = 0;
                    Query = BuildQuery(Query, entity);
                    Records = Query.Count();
                }
               
            }
            return Records;
        }

        public static string GenerateKey(string key, AlbumEntity gal)
        {
            var str = new StringBuilder();
            str.AppendLine(key + "_" + gal.isfeatured + "" + gal.username.ToLower() + "" + gal.month + "" + gal.year + "" + gal.filter + "" + gal.isdisabled + "" + gal.isapproved + "" + gal.isadult + "" + gal.searchtype + "" + gal.datefilter + "" + gal.type + "" + gal.privacy + "" + gal.pagesize);
            if (gal.term != "")
                str.AppendLine(UtilityBLL.ReplaceSpaceWithHyphin(gal.term.ToLower()));
            if (gal.tags != "")
                str.AppendLine(UtilityBLL.ReplaceSpaceWithHyphin(gal.tags.ToLower()));
            if (gal.categories.Length > 0)
                str.AppendLine(UtilityBLL.ReplaceSpaceWithHyphin(string.Join("_", gal.categories)));

            return str.ToString();
        }

        /* customizable select version*/
        public static IQueryable<gallery> GetLoadQuery(mvcportalEntities ctx, AlbumEntity entity)
        {
            IQueryable<gallery> Query;
            Query = ctx.galleries;
            Query = BuildQuery(Query, entity);
            return Query;
        }
        private static IQueryable<gallery> BuildQuery(IQueryable<gallery> query, AlbumEntity entity)
        {
            query = Where(query, entity);
            if (entity.galleryid == 0 && !entity.iscount)
            {
                query = OrderBy(query, entity);
                query = Skip(query, entity);
                query = Limit(query, entity);
            }
            return query;
        }

        private static List<AlbumDataEntity> LoadLikedItems(AlbumEntity entity)
        {
            var _list = new List<AlbumDataEntity>();

            using (var ctx = new mvcportalEntities())
            {
                // Load Liked -> Who Rated Posts ( r.type=9 AND r.rating=0)
                var Query = ctx.galleries
                .Join(ctx.user_ratings,
                 gallery => gallery.galleryid,
                 rating => rating.itemid,
                 (gallery, rating) => new { gallery, rating });

                 Query = Query.Where(p => p.rating.type == 9 && p.rating.rating == 0 && p.gallery.isdisabled == 1 && p.gallery.isapproved == 1 && p.gallery.privacy == 0);

                if (entity.username != "")
                    Query = Query.Where(x => x.rating.username == entity.username);

                if (entity.order != "")
                {
                    var orderlist = entity.order.Split(char.Parse(","));
                    foreach (var order in orderlist)
                    {
                        if (order.Contains("galleryid"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.galleryid);
                            else
                                Query = Query.OrderBy(p => p.gallery.galleryid);
                        }
                        else if (order.Contains("title"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.title);
                            else
                                Query = Query.OrderBy(p => p.gallery.title);
                        }
                    }
                }
                if (entity.pagenumber > 1)
                    Query = Query.Skip(entity.pagesize * (entity.pagenumber - 1));

                if (!entity.loadall)
                    Query = Query.Take(entity.pagesize);

                _list = Query
                     .Select(p => new AlbumDataEntity
                     {
                         galleryid = p.gallery.galleryid,
                         username = p.gallery.username,
                         title = p.gallery.title,
                         tags = p.gallery.tags,
                         isadult = (byte)p.gallery.isadult,
                         created_at = (DateTime)p.gallery.added_date,
                         isdisabled = p.gallery.isdisabled,
                         views = p.gallery.views,
                         total_photos = p.gallery.total_photos,
                         picturename = p.gallery.picturename,
                         favorites = p.gallery.favorites,
                         isapproved = p.gallery.isapproved,
                         iscloud = p.gallery.iscloud,
                         privacy = p.gallery.privacy,
                         type = p.gallery.type,
                         isfeatured = p.gallery.isfeatured,
                         mode = p.gallery.mode,
                         customcover = p.gallery.customcover,
                         total_rating = p.gallery.total_rating,
                         ratings = p.gallery.ratings,
                         avg_rating = p.gallery.avg_rating
                     }).ToList();
            }

            return _list;
        }

        private static int CountLikedItems(AlbumEntity entity)
        {
            int Records = 0;

            using (var ctx = new mvcportalEntities())
            {
                // Load Liked -> Who Rated Posts ( r.type=9 AND r.rating=0)
                var Query = ctx.galleries
                .Join(ctx.user_ratings,
                 gallery => gallery.galleryid,
                 rating => rating.itemid,
                 (gallery, rating) => new { gallery, rating });

                Query = Query.Where(p => p.rating.type == 9 && p.rating.rating == 0 && p.gallery.isdisabled == 1 && p.gallery.isapproved == 1 && p.gallery.privacy == 0);

                if (entity.username != "")
                    Query = Query.Where(x => x.rating.username == entity.username);

                if (entity.order != "")
                {
                    var orderlist = entity.order.Split(char.Parse(","));
                    foreach (var order in orderlist)
                    {
                        if (order.Contains("galleryid"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.galleryid);
                            else
                                Query = Query.OrderBy(p => p.gallery.galleryid);
                        }
                        else if (order.Contains("title"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.title);
                            else
                                Query = Query.OrderBy(p => p.gallery.title);
                        }
                    }
                }
                if (entity.pagenumber > 1)
                    Query = Query.Skip(entity.pagesize * (entity.pagenumber - 1));

                if (!entity.loadall)
                    Query = Query.Take(entity.pagesize);

                Records = Query.Count();
            }

            return Records;
        }

        private static List<AlbumDataEntity> LoadFavorited(AlbumEntity entity)
        {
            var _list = new List<AlbumDataEntity>();

            using (var ctx = new mvcportalEntities())
            {
                // Load Favorited ->
                var Query = ctx.galleries
                .Join(ctx.favorites,
                 gallery => gallery.galleryid,
                 favorite => favorite.videoid,
                 (gallery, favorite) => new { gallery, favorite });

                Query = Query.Where(p => p.favorite.type == 2 && p.gallery.isdisabled == 1 && p.gallery.isapproved == 1 && p.gallery.privacy == 0);
                if (entity.username != "")
                    Query = Query.Where(x => x.favorite.username == entity.username);

                if (entity.order != "")
                {
                    var orderlist = entity.order.Split(char.Parse(","));
                    foreach (var order in orderlist)
                    {
                        if (order.Contains("galleryid"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.galleryid);
                            else
                                Query = Query.OrderBy(p => p.gallery.galleryid);
                        }
                        else if (order.Contains("title"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.title);
                            else
                                Query = Query.OrderBy(p => p.gallery.title);
                        }
                    }
                }
                if (entity.pagenumber > 1)
                    Query = Query.Skip(entity.pagesize * (entity.pagenumber - 1));

                if (!entity.loadall)
                    Query = Query.Take(entity.pagesize);

                _list = Query
                     .Select(p => new AlbumDataEntity
                     {
                         galleryid = p.gallery.galleryid,
                         username = p.gallery.username,
                         title = p.gallery.title,
                         tags = p.gallery.tags,
                         isadult = (byte)p.gallery.isadult,
                         created_at = (DateTime)p.gallery.added_date,
                         isdisabled = p.gallery.isdisabled,
                         views = p.gallery.views,
                         total_photos = p.gallery.total_photos,
                         picturename = p.gallery.picturename,
                         favorites = p.gallery.favorites,
                         isapproved = p.gallery.isapproved,
                         iscloud = p.gallery.iscloud,
                         privacy = p.gallery.privacy,
                         type = p.gallery.type,
                         isfeatured = p.gallery.isfeatured,
                         mode = p.gallery.mode,
                         customcover = p.gallery.customcover,
                         total_rating = p.gallery.total_rating,
                         ratings = p.gallery.ratings,
                         avg_rating = p.gallery.avg_rating
                     }).ToList();
            }

            return _list;
        }

        private static int CountFavorited(AlbumEntity entity)
        {
            int Records = 0;

            using (var ctx = new mvcportalEntities())
            {
                // Load Favorited ->
                var Query = ctx.galleries
                .Join(ctx.favorites,
                 gallery => gallery.galleryid,
                 favorite => favorite.videoid,
                 (gallery, favorite) => new { gallery, favorite });

                Query = Query.Where(p => p.favorite.type == 2 && p.gallery.isdisabled == 1 && p.gallery.isapproved == 1 && p.gallery.privacy == 0);
                if (entity.username != "")
                    Query = Query.Where(x => x.favorite.username == entity.username);

                if (entity.order != "")
                {
                    var orderlist = entity.order.Split(char.Parse(","));
                    foreach (var order in orderlist)
                    {
                        if (order.Contains("galleryid"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.galleryid);
                            else
                                Query = Query.OrderBy(p => p.gallery.galleryid);
                        }
                        else if (order.Contains("title"))
                        {
                            if (order.Contains("desc"))
                                Query = Query.OrderByDescending(p => p.gallery.title);
                            else
                                Query = Query.OrderBy(p => p.gallery.title);
                        }
                    }
                }
                if (entity.pagenumber > 1)
                    Query = Query.Skip(entity.pagesize * (entity.pagenumber - 1));

                if (!entity.loadall)
                    Query = Query.Take(entity.pagesize);

                Records = Query.Count();
            }

            return Records;
        }

        public static List<AlbumDataEntity> LoadCompleteList(IQueryable<gallery> query)
        {
            return query.Select(p => new AlbumDataEntity
            {
                galleryid = p.galleryid,
                username = p.username,
                title = p.title,
                description = p.description,
                tags = p.tags,
                categories = p.categories,
                isadult = (byte)p.isadult,
                created_at = (DateTime)p.added_date,
                isdisabled = p.isdisabled,
                views = p.views,
                comments = p.comments,
                total_photos = p.total_photos,
                picturename = p.picturename,
                favorites = p.favorites,
                iscomments = p.iscomments,
                isapproved = p.isapproved,
                liked = p.liked,
                disliked = p.disliked,
                iscloud = p.iscloud,
                privacy = p.privacy,
                type = p.type,
                isfeatured = p.isfeatured,
                mode = p.mode,
                customcover = p.customcover,
                total_rating = p.total_rating,
                ratings = p.ratings,
                avg_rating = p.avg_rating,
                artistid = p.artistid
            }).ToList();
        }

        public static List<AlbumDataEntity> LoadSummaryList(IQueryable<gallery> query)
        {
            return query.Select(p => new AlbumDataEntity
            {
                galleryid = p.galleryid,
                username = p.username,
                title = p.title,
                tags = p.tags,
                isadult = (byte)p.isadult,
                created_at = (DateTime)p.added_date,
                isdisabled = p.isdisabled,
                views = p.views,
                total_photos = p.total_photos,
                picturename = p.picturename,
                favorites = p.favorites,
                isapproved = p.isapproved,
                iscloud = p.iscloud,
                privacy = p.privacy,
                type = p.type,
                isfeatured = p.isfeatured,
                mode = p.mode,
                customcover = p.customcover,
                total_rating = p.total_rating,
                ratings = p.ratings,
                avg_rating = p.avg_rating,
                artistid = p.artistid
            }).ToList();
        }

        public static List<AlbumDataEntity> LoadDropdownList(IQueryable<gallery> query)
        {
            return query.Select(p => new AlbumDataEntity
            {
                galleryid = (int)p.galleryid,
                title = p.title
            }).ToList();
        }

        private static IQueryable<gallery> Where(IQueryable<gallery> query, AlbumEntity entity)
        {
            if (entity.excludedid > 0)
                query = query.Where(p => p.galleryid != entity.excludedid);
            if (entity.galleryid > 0)
                query = query.Where(p => p.galleryid == entity.galleryid);
           

            if (!entity.nofilter)
            {
                if (entity.type != 3)
                    query = query.Where(p => p.type == entity.type);

                if (entity.categories != null)
                {
                    foreach (string category in entity.categories)
                    {
                        if (category != "")
                        {
                            var _filter = category.Trim();
                            query = query.Where(p => p.categories.Contains(_filter));
                        }

                    }
                }
                if (entity.tags != "" && entity.tags != null)
                {
                    foreach (var tag in entity.tags.Split(char.Parse(",")))
                    {
                        if (tag != "")
                        {
                            var filter = tag.Trim();
                            query = query.Where(p => p.tags.Contains(filter));
                        }
                    }
                }
                if (entity.username != "" && entity.username != null)
                {
                    query = query.Where(p => p.username == entity.username);
                }

                if (entity.artistid > 0)
                    query = query.Where(p => p.artistid == entity.artistid);

                if (entity.mode > 0)
                    query = query.Where(p => p.mode == entity.mode);

                if (entity.isfeatured != 3)
                    query = query.Where(p => p.isfeatured == entity.isfeatured);

                if (entity.term != "" && entity.term != null)
                    query = query.Where(p => p.title.Contains(entity.term) || p.description.Contains(entity.term) || p.tags.Contains(entity.term));

                if (entity.month > 0 && entity.year > 0)
                    query = query.Where(p => p.added_date.Value.Month == entity.month && p.added_date.Value.Year == entity.year);
                else if (entity.year > 0)
                    query = query.Where(p => p.added_date.Value.Year == entity.year);
                else if (entity.month > 0)
                    query = query.Where(p => p.added_date.Value.Month == entity.month);

                if (entity.ispublic)
                {
                    query = query.Where(p => p.isdisabled == 1 && p.isapproved == 1 && p.privacy == 0 && p.total_photos > 0);
                }
                else
                {
                    if (entity.isdisabled != 2)
                        query = query.Where(p => p.isdisabled == entity.isdisabled);

                    if (entity.isapproved != 2)
                        query = query.Where(p => p.isapproved == entity.isapproved);

                    if (entity.privacy != 3)
                        query = query.Where(p => p.privacy == entity.privacy);
                }

                if (entity.datefilter > 0)
                {
                    switch (entity.datefilter)
                    {
                        case 1:
                            // today record
                            query = query.Where(at => SqlFunctions.DateDiff("DAY", at.added_date, DateTime.Now) == 0);
                            break;
                        case 2:
                            // this week record
                            query = query.Where(at => SqlFunctions.DateDiff("DAY", at.added_date, DateTime.Now) >= 0 && SqlFunctions.DateDiff("DAY", at.added_date, DateTime.Now) < 7);
                            break;
                        case 3:
                            // this month record
                            query = query.Where(at => SqlFunctions.DateDiff("DAY", at.added_date, DateTime.Now) >= 0 && SqlFunctions.DateDiff("DAY", at.added_date, DateTime.Now) < 31);
                            break;
                    }
                }

                if (entity.isadult != 2)
                    query = query.Where(p => p.isadult == entity.isadult);

                if (entity.iscomments != 2)
                    query = query.Where(p => p.iscomments == entity.iscomments);

            }
            

            return query;
        }

        private static IQueryable<gallery> OrderBy(IQueryable<gallery> query, AlbumEntity entity)
        {
            if (entity.order != "")
            {
                var orderlist = entity.order.Split(char.Parse(","));
                foreach (var order in orderlist)
                {
                    if (order.Contains("galleryid"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.galleryid);
                        else
                            query = query.OrderBy(p => p.galleryid);
                        return query;
                    }
                    else if (order.Contains("title"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.title).OrderBy(p => p.added_date);
                        else
                            query = query.OrderBy(p => new { p.title }).OrderByDescending(p => p.added_date);

                        return query;
                    }
                    else if (order.Contains("added_date"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.added_date);
                        else
                            query = query.OrderBy(p => p.added_date);
                        return query;
                    }
                    else if (order.Contains("views"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.views, p.added_date });
                        else
                            query = query.OrderBy(p => new { p.views, p.added_date });
                        return query;
                    }
                    else if (order.Contains("username"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.username).OrderBy(p => p.added_date);
                        else
                            query = query.OrderBy(p => p.username).OrderByDescending(p => p.added_date);
                        return query;
                    }
                    else if (order.Contains("liked"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.liked, p.views, p.added_date });
                        else
                            query = query.OrderBy(p => p.liked).OrderByDescending(p => p.added_date);
                        return query;
                    }
                    else if (order.Contains("isdisabled"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.isdisabled, p.views, p.added_date });
                        else
                            query = query.OrderBy(p => p.isdisabled).OrderByDescending(p => p.added_date);
                        return query;
                    }
                    else if (order.Contains("isapproved"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.isapproved, p.views, p.added_date });
                        else
                            query = query.OrderBy(p => p.isapproved).OrderByDescending(p => p.added_date);
                        return query;
                    }
                    else if (order.Contains("avg_rating"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.avg_rating, p.views, p.added_date });
                        else
                            query = query.OrderBy(p => p.avg_rating).OrderByDescending(p => p.added_date);
                        return query;
                    }
                    else if (order.Contains("total_ratings"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.total_rating, p.views, p.added_date });
                        else
                            query = query.OrderBy(p => p.total_rating).OrderByDescending(p => p.added_date);
                        return query;
                    }
                    else if (order.Contains("favorites"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.favorites, p.views, p.added_date });
                        else
                            query = query.OrderBy(p => p.favorites).OrderByDescending(p => p.added_date);
                        return query;
                    }
                }
            }

            return query;
        }

        private static IQueryable<gallery> Skip(IQueryable<gallery> query, AlbumEntity entity)
        {
            if (entity.pagenumber > 1 && entity.pagesize > 0)
                query = query.Skip(entity.pagesize * (entity.pagenumber - 1));

            return query;
        }

        private static IQueryable<gallery> Limit(IQueryable<gallery> query, AlbumEntity entity)
        {
            if (!entity.loadall && entity.pagesize > 0)
                query = query.Take(entity.pagesize);

            return query;
        }
        
        #endregion
       
      


        #region Fetch Record Script
        // Fetch Photos Data for Category Listing
  /*      public static List<AlbumEntity> Fetch_Gallery_Record_SM(long GalleryID)
        {

            List<AlbumEntity> _items = new List<AlbumEntity>();
            AlbumEntity _item;
            // generate sql query
            var str = new StringBuilder();
            str.AppendLine("SELECT title,description,views,username,comments,iscomments,picturename,total_photos,iscloud,privacy,authkey,categories,tags,type FROM galleries WHERE isdisabled=1 AND isApproved=1 AND GalleryID=@galleryid");
            // QUERY PROCESSING LOGIC
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();
                using (var cmd = new SqlCommand(str.ToString(), con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@galleryid", GalleryID));
                    using (var reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            _item = new AlbumEntity();
                            _item.title= reader["title"].ToString();
                            _item.total_photos = Convert.ToInt32(reader["total_photos"]);
                            _item.type = Convert.ToInt32(reader["type"]);
                           _item.views = (int)reader["views"];
                            _item.comments = (int)reader["comments"];
                            _item.iscomments = Convert.ToInt32(reader["iscomments"]);
                            _item.picturename = reader["picturename"].ToString();
                            _item.username = reader["username"].ToString();
                            _item.iscloud = Convert.ToInt32(reader["iscloud"]);
                           _item.description = reader["description"].ToString();
                            _item.privacy = Convert.ToInt32(reader["privacy"]);
                            _item.authkey = reader["authkey"].ToString();
                            if(reader["categories"].ToString() != "")
                            _item.categories = reader["categories"].ToString().Split(char.Parse(","));
                            _item.tags = reader["tags"].ToString();
                            _items.Add(_item);
                        }
                    }
                }
            }

            return _items;
        }

        // Fetch Gallery Record for My Account - Gallery Edit Section
        public static List<AlbumEntity> Fetch_Gallery_MyAccount(long GalleryID)
        {

            List<AlbumEntity> _items = new List<AlbumEntity>();
            AlbumEntity _item;
            // QUERY PROCESSING LOGIC
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();
                using (SqlCommand cmd = new SqlCommand("SELECT title,username,description,tags,categories,iscomments,isadult,privacy,iscloud,picturename FROM galleries WHERE GalleryID=@GalleryID", con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@GalleryID", GalleryID));
                    using (var reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            _item = new AlbumEntity();
                            _item.title= reader["title"].ToString();
                            _item.username = reader["username"].ToString();
                           _item.description = reader["description"].ToString();
                            _item.tags = reader["tags"].ToString();
                            if (reader["categories"].ToString() != "")
                                _item.categories = reader["categories"].ToString().Split(char.Parse(","));
                            _item.iscomments = Convert.ToInt32(reader["iscomments"]);
                            _item.iscloud = Convert.ToInt32(reader["iscloud"]);
                            _item.isadult = Convert.ToInt32(reader["isadult"]);
                            _item.privacy = Convert.ToInt32(reader["privacy"]);
                            _item.picturename = reader["picturename"].ToString();
                            _items.Add(_item);
                        }
                    }
                }
            }

            return _items;
        }

        // Fetch single record
        public static List<AlbumEntity> Fetch_Gallery_Record(long GalleryID)
        {
            List<AlbumEntity> _items = new List<AlbumEntity>();
            AlbumEntity _item;
            // generate sql query
            var str = new StringBuilder();

            string query = "SELECT galleryid,title,description,categoryid,isfeatured,categories,isadult,views,favorites,username,comments,tags,iscomments,picturename,liked,disliked,total_photos,added_date,isdisabled,isapproved,iscloud,type,total_rating,ratings,avg_rating FROM galleries WHERE GalleryID=@GID;";

            // QUERY PROCESSING LOGIC
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();
                using (SqlCommand cmd = new SqlCommand(query, con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@GID", GalleryID));
                    using (var reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            _item = new AlbumEntity();
                            _item.galleryid = (long)reader["galleryid"];
                            _item.title= reader["title"].ToString();
                           _item.description = reader["description"].ToString();
                            _item.tags = reader["tags"].ToString();
                            if (reader["categories"].ToString() != "")
                                _item.categories = reader["categories"].ToString().Split(char.Parse(","));
                            _item.total_photos = Convert.ToInt32(reader["total_photos"]);
                            _item.categoryid = Convert.ToInt32(reader["categoryid"]);
                            _item.isadult = Convert.ToInt32(reader["isadult"]);
                            _item.added_date = (DateTime)reader["added_date"];
                           _item.views = (int)reader["views"];
                            _item.comments = (int)reader["comments"];
                            _item.iscomments = Convert.ToInt32(reader["iscomments"]);
                            _item.liked = (int)reader["liked"];
                            _item.disliked = (int)reader["disliked"];
                            _item.isfeatured = Convert.ToInt32(reader["disliked"]);
                            _item.picturename = reader["picturename"].ToString();
                            _item.username = reader["username"].ToString();
                            _item.iscloud = Convert.ToInt32(reader["iscloud"]);
                            _item.isapproved = Convert.ToInt32(reader["isapproved"]);
                            _item.isdisabled = Convert.ToInt32(reader["isdisabled"]);
                            _item.favorites = Convert.ToInt32(reader["favorites"]);
                            _item.type = Convert.ToInt32(reader["type"]);
                            _item.total_ratings = Convert.ToInt32(reader["total_rating"]);
                            _item.ratings = Convert.ToInt32(reader["ratings"]);
                            _item.avg_rating = Convert.ToDouble(reader["avg_rating"]);

                            _items.Add(_item);
                        }
                    }
                }
            }

            return _items;
        }

        public static List<AlbumEntity> Get_SM_Info(long ID)
        {

            List<AlbumEntity> _items = new List<AlbumEntity>();
            AlbumEntity _item;
            // QUERY PROCESSING LOGIC
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();
                using (SqlCommand cmd = new SqlCommand("SELECT username, title,isdisabled FROM galleries WHERE galleryid=@GID", con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@GID", ID));
                    using (var reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            _item = new AlbumEntity();
                            _item.title= reader["Title"].ToString();
                            _item.username = reader["username"].ToString();
                            _item.isdisabled = Convert.ToInt32(reader["isDisabled"]);
                            _items.Add(_item);
                        }
                    }
                }
            }

            return _items;
        } */
        #endregion
        // fetch data to generate archive list of records
        public static List<ArchiveEntity> Load_Arch_List(int records, bool isall, int type)
        {
            // cache implementation
            int cache_duration = Config.GetCacheDuration();
            if (cache_duration == 0) // no cache
                return Fetch_Archive_List(records, isall, type);
            else
            {
                string cache_key = "ld_gal_arc_lst" + records + "" + isall + "" + type;
                if (HttpContext.Current.Cache[cache_key] == null)
                    HttpContext.Current.Cache.Add(cache_key, Fetch_Archive_List(records, isall, type), null, DateTime.Now.AddMinutes(cache_duration), TimeSpan.Zero, CacheItemPriority.High, null);

                List<ArchiveEntity> _list = (List<ArchiveEntity>)(HttpContext.Current.Cache[cache_key]);
                return _list;
            }
        }

        public static List<ArchiveEntity> Fetch_Archive_List(int records, bool isall, int type)
        {
            var context = new mvcportalEntities();
            var model = context.galleries
                .GroupBy(o => new
                {
                    Month = o.added_date.Value.Month,
                    Year = o.added_date.Value.Year
                })
                .Select(g => new ArchiveEntity
                {
                    Month = g.Key.Month,
                    Year = g.Key.Year,
                    Total = g.Count()
                })
                .OrderByDescending(a => a.Year)
                .ThenByDescending(a => a.Month)
                .ToList();

            return model;
        }
            
        #region Sitemaps


        public static string generateGoogleSitemap(AlbumEntity Entity)
        {
            var str = new StringBuilder();
            str.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            str.AppendLine("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\"");
            str.AppendLine(" xmlns:image=\"http://www.google.com/schemas/sitemap-image/1.1\"");
            str.AppendLine(" xmlns:video=\"http://www.google.com/schemas/sitemap-video/1.1\">");
            var _lst = LoadItems(Entity);
            foreach (var Item in _lst)
            {
             
                str.AppendLine("<url>");
                str.AppendLine("<loc>" + AlbumUrlConfig.PrepareUrl(Item, 0) + "</loc>");
                str.AppendLine("</url>");
            }
            str.AppendLine("</urlset>");

            return str.ToString();
        }

        public static string GenerateBingSitemap(AlbumEntity Entity)
        {
            var str = new StringBuilder();
            str.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            str.AppendLine("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">");
            var _lst = LoadItems(Entity);
            foreach (var Item in _lst)
            {
                str.AppendLine("<url>");
                str.AppendLine("<loc>" + AlbumUrlConfig.PrepareUrl(Item,0) + "</loc>");
                str.Append("</url>");
            }
            str.AppendLine("</urlset>");

            return str.ToString();
        }
        #endregion

        #region Feeds

        public static string generateRSS(AlbumEntity Entity)
        {
            string _url = "";
            switch(Entity.type)
            {
                case 0:
                    _url = Config.GetUrl() + "albums/photos/";
                    break;
                case 1:
                    _url = Config.GetUrl() + "albums/videos/";
                    break;
                case 2:
                    _url = Config.GetUrl() + "albums/audio/";
                    break;
            }
            var str = new StringBuilder();
            str.AppendLine("<rss version=\"2.0\">");
            str.AppendLine("<channel>");
            str.AppendLine("<title>" + Config.GetWebsiteTitle() + "</title>");
            str.AppendLine("<description>" + Config.GetWebsiteDescription() + "</description>");
            str.AppendLine("<link>" + Config.GetUrl() + "</link>");
            str.AppendLine("<guid>" + _url + "</guid>");
            var _lst = LoadItems(Entity);
            foreach (var Item in _lst)
            {
                string title_url = AlbumUrlConfig.PrepareUrl(Item, 0);
                string body = HttpContext.Current.Server.HtmlEncode(UtilityBLL.StripHTML_v2(Item.description));
                str.AppendLine("<item>");
                str.AppendLine("<title>" + UtilityBLL.CleanBlogHTML(UtilityBLL.StripHTML(Item.title)) + "</title>");
                str.AppendLine("<link>" + title_url + "</link>");
                str.AppendLine("<guid>" + title_url + "</guid>");
                str.AppendLine("<pubDate>" + String.Format("{0:R}", Item.created_at) + "</pubDate>");
                str.AppendLine("<description>" + body + "</description>");
                str.AppendLine("</item>");
            }
            str.AppendLine("</channel>");
            str.AppendLine("</rss>");

            return str.ToString();
        }

        public static string generateATOM(AlbumEntity Entity, string url)
        {
            string _url = "";
            switch (Entity.type)
            {
                case 0:
                    _url = Config.GetUrl() + "albums/photos/";
                    break;
                case 1:
                    _url = Config.GetUrl() + "albums/videos/";
                    break;
                case 2:
                    _url = Config.GetUrl() + "albums/audio/";
                    break;
            }
            var str = new StringBuilder();
            str.AppendLine("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n");
            str.AppendLine("<feed xmlns=\"http://www.w3.org/2005/Atom\">\n");
            str.AppendLine("<title type=\"text\">" + Site_Settings.Website_Title + "</title>\n");
            str.AppendLine("<subtitle type=\"html\">" + Site_Settings.Website_Description + "</subtitle>");
            str.AppendLine("<id>tag:" + Config.GetUrl() + "," + DateTime.Now.Year + ":3</id>");
            str.AppendLine("<link rel=\"alternate\" type=\"text/html\" hreflang=\"en\" href=\"" + _url + "\"/>");
            str.AppendLine("<link rel=\"self\" type=\"application/atom+xml\" href=\"" + url + "\"/>");
            str.AppendLine("<rights>" + Site_Settings.Website_Title + "</rights>");
            str.AppendLine("<generator uri=\"" + _url + "\" version=\"1.0\">");
            //str.AppendLine(Blog_Settings.Generator);
            str.AppendLine("</generator>");
            var _lst = LoadItems(Entity);
            foreach (var Item in _lst)
            {
                string title_url = AlbumUrlConfig.PrepareUrl(Item, 0);

                string body = HttpContext.Current.Server.HtmlEncode(UtilityBLL.StripHTML_v2(Item.description));

                str.AppendLine("<entry>");
                str.AppendLine("<title type=\"text\">" + Item.title+ "</title>");
                str.AppendLine("<link rel=\"alternate\" type=\"text/html\" href=\"" + title_url + "\"/>");
                str.AppendLine("<id>tag:" + Config.GetUrl() + "," + Item.created_at.Value.Year + ":3." + Item.title+ "</id>\n");
                str.AppendLine("<updated>" + String.Format("{0:R}", Item.created_at) + "</updated>\n");
                str.AppendLine("<published>" + String.Format("{0:R}", Item.created_at) + "</published>\n");
                str.AppendLine("<author>\n");
                str.AppendLine("<name>" + Item.username + "</name>\n");
                str.AppendLine("<uri>" + _url + "</uri>\n");
                str.AppendLine("</author>\n");
                str.AppendLine("<content type=\"html\">" + body + "</content>\n");
                str.AppendLine("</entry>\n");
            }
            str.AppendLine("</feed>");

            return str.ToString();
        }
        #endregion


        public static string ProcessAction(List<AlbumEntity> list)
        {
            foreach (var entity in list)
            {
                if (entity.galleryid > 0)
                {
                    switch (entity.actionstatus)
                    {
                        case "enable":
                            Update_Field_V3(entity.galleryid, (byte)1, "isdisabled");
                            break;
                        case "disable":
                            Update_Field_V3(entity.galleryid, (byte)0, "isdisabled");
                            break;
                        case "approve":
                            Update_Field_V3(entity.galleryid, (byte)1, "isapproved");
                            break;
                        case "featured":
                            Update_Field_V3(entity.galleryid, (byte)1, "isfeautred");
                            break;
                        case "premium":
                            Update_Field_V3(entity.galleryid, (byte)2, "isfeatured");
                            break;
                        case "normal":
                            Update_Field_V3(entity.galleryid, (byte)0, "isfeatured");
                            break;
                        case "adult":
                            Update_Field_V3(entity.galleryid, (byte)2, "isadult");
                            break;
                        case "nonadult":
                            Update_Field_V3(entity.galleryid, (byte)0, "isadult");
                            break;
                        case "private":
                            Update_Field_V3(entity.galleryid, (byte)1, "privacy");
                            break;
                        case "public":
                            Update_Field_V3(entity.galleryid, (byte)0, "privacy");
                            break;
                        case "delete":
                            Delete(entity.galleryid);
                            break;
                    }
                }
            }
            return "Operation performed successfully";
        }

        #region Cache
        private static List<AlbumDataEntity> _Fetch_Normal_Cache(AlbumEntity entity, string key)
        {
            /* ASP.NET Cache */
            if (HttpContext.Current.Cache[key] == null)
            {
                HttpContext.Current.Cache.Add(key, FetchItems(entity), null, DateTime.Now.AddMinutes(Site_Settings.Cache_Duration), TimeSpan.Zero, CacheItemPriority.High, null);
            }
            return (List<AlbumDataEntity>)(HttpContext.Current.Cache[key]);
        }

        private static List<AlbumDataEntity> _Fetch_Redis_Cache(AlbumEntity entity, string key)
        {
            var conn = RedisHelper.RedisConnection.GetDatabase();
            try
            {
                if (Convert.ToString(conn.StringGet(key)) == null)
                {

                    conn.StringSet(key, Newtonsoft.Json.JsonConvert.SerializeObject(FetchItems(entity)), TimeSpan.FromMinutes(Site_Settings.Cache_Duration));
                }
                return Newtonsoft.Json.JsonConvert.DeserializeObject<List<AlbumDataEntity>>(conn.StringGet(key));
            }
            catch (Exception ex)
            {
                return _Fetch_Normal_Cache(entity, key);
            }
        }
        private static int _Count_Normal_Cache(AlbumEntity entity, string key)
        {
            /* ASP.NET Cache */
            if (HttpContext.Current.Cache[key] == null)
            {
                int total_records = CountRecords(entity);
                HttpContext.Current.Cache.Add(key, total_records, null, DateTime.Now.AddMinutes(Site_Settings.Cache_Duration), TimeSpan.Zero, CacheItemPriority.High, null);
            }
            return Convert.ToInt32(HttpContext.Current.Cache[key]);
        }

        private static int _Count_Redis_Cache(AlbumEntity entity, string key)
        {
            var conn = RedisHelper.RedisConnection.GetDatabase();
            try
            {
                if (Convert.ToString(conn.StringGet(key)) == null)
                {
                    int total_records = CountRecords(entity);
                    conn.StringSet(key, Newtonsoft.Json.JsonConvert.SerializeObject(total_records), TimeSpan.FromMinutes(Site_Settings.Cache_Duration));
                }
                return Newtonsoft.Json.JsonConvert.DeserializeObject<int>(conn.StringGet(key));
            }
            catch (Exception ex)
            {
                return _Count_Normal_Cache(entity, key);
            }
        }
        #endregion
    }
}