﻿using System;
using System.Collections.Generic;
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;
using Jugnoon.Entity;
namespace Jugnoon.BLL
{
    public class RoleBLL
    {
        public static RoleDataEntity Add(RoleDataEntity entity)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var _entity = new vsk_roles()
                {
                    rolename = entity.rolename,
                    created_at = DateTime.Now
                };

                dbCtx.Entry(_entity).State = System.Data.Entity.EntityState.Added;
                entity.id = _entity.id;
                DataBLL.SaveChanges(dbCtx);

            }

            return entity;
        }

        public static bool Delete(short roleid)
        {
            RolePermission.DeleteRole(roleid);
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new vsk_roles { id = roleid };
                dbCtx.vsk_roles.Attach(entity);
                dbCtx.vsk_roles.Remove(entity);
                dbCtx.SaveChanges();
            }

            return true;
        }

        public static string ProcessAction(List<RoleEntity> list)
        {
            foreach (var entity in list)
            {
                if (entity.id > 0)
                {
                    switch (entity.actionstatus)
                    {                        
                        case "delete":
                            Delete((short)entity.id);
                            break;
                    }
                }
            }
            return "Operation performed successfully";
        }

        public static List<RoleDataEntity> LoadItems(RoleEntity entity)
        {
            var _list = new List<RoleDataEntity>();

            using (var ctx = new mvcportalEntities())
            {
                IQueryable<vsk_roles> Query = ctx.vsk_roles;
                Query = BuildQuery(Query, entity);

                _list = LoadCompleteList(Query);
            }

            return _list;
        }


        public static int Count(RoleEntity entity)
        {
            int Records = 0;
            using (var entities = new mvcportalEntities())
            {
                IQueryable<vsk_roles> Query = entities.vsk_roles;
                entity.iscount = true;
                entity.id = 0;
                Query = BuildQuery(Query, entity);
                Records = Query.Count();
            }
            return Records;
        }

        private static IQueryable<vsk_roles> BuildQuery(IQueryable<vsk_roles> query, RoleEntity entity)
        {
            query = Where(query, entity);
            if (entity.id == 0 && !entity.iscount)
            {
                query = OrderBy(query, entity);
                query = Skip(query, entity);
                query = Limit(query, entity);
            }
            return query;
        }

        public static List<RoleDataEntity> LoadCompleteList(IQueryable<vsk_roles> query)
        {
            return query.Select(p => new RoleDataEntity
            {
                id = p.id,
                rolename = p.rolename,
                created_at = p.created_at
            }).ToList();
        }

        private static IQueryable<vsk_roles> Where(IQueryable<vsk_roles> query, RoleEntity entity)
        {
            if (entity.id > 0)
                query = query.Where(p => p.id == entity.id);
            
            if (entity.term != "")
                query = query.Where(p => p.rolename.Contains(entity.term) || p.rolename.Contains(entity.term));

            return query;
        }

        private static IQueryable<vsk_roles> OrderBy(IQueryable<vsk_roles> query, RoleEntity entity)
        {
            if (entity.order != "")
            {
                var orderlist = entity.order.Split(char.Parse(","));
                foreach (var order in orderlist)
                {
                    if (order.Contains("id"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.id);
                        else
                            query = query.OrderBy(p => p.id);
                    }
                }
            }

            return query;
        }

        private static IQueryable<vsk_roles> Skip(IQueryable<vsk_roles> query, RoleEntity entity)
        {
            if (entity.pagenumber > 1)
                query = query.Skip(entity.pagesize * (entity.pagenumber - 1));

            return query;
        }

        private static IQueryable<vsk_roles> Limit(IQueryable<vsk_roles> query, RoleEntity entity)
        {
            if (!entity.loadall)
                query = query.Take(entity.pagesize);

            return query;
        }
    }
}