using System;
using System.Web;
using System.Collections.Generic;
using System.Text;
using System.Web.Caching;
/* Site Own Namespaces */
using Jugnoon.Entity;
using Jugnoon.Utility;
using Jugnoon.Settings;
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;
using System.IO;
using System.Data.Entity.SqlServer;

namespace Jugnoon.BLL
{
    public class UserBLL
    {
       
        // Note: Important Member Terms

        // Role | User Type

        // type:
        // ........... 0: Normal User
        // ........... 1: Administrator
        // ........... 2: Premium User

        // isEnabled:
        // ........... 0: Disabled Member
        // ........... 1: Enabled Member
        // ........... 3: Deleted Member

        // channel_iscomments
        // .......... 0: Member not allowed comments on his/her channel
        // .......... 1: Member allow comments on his/her channel

        // channel_isfriends
        // .......... 0: Member not show his/her friends on channel
        // .......... 1: Member show his/her friends on channel

        // channel_issubscribers
        // .......... 0: Subscribers will not show on member channel
        // .......... 1: Subscribers will show on member channel

        // channel_isgroups
        // .......... 0: Member not show his/her groups on channel
        // .......... 1: Member show his/her groups on channel

        // channel_name // customize name for channel, by default username will be the name of channel if its not defined.

        // channel_theme // current configured theme by user. // channel themes available on the following folder
        // themes/channel/black,red,blue,fire,forest,pink,princes,stealth,sunlight


        // Statistic related fields -/ keep track of user contents that is store in user table for scalability / performance measure.

        // stat_videos :-> no of videos uploaded by user
        // stat_friends :-> no of user friends
        // stat_subscribers :-> no of user subscribers
        // stat_favorites :-> no of user favorited videos
        // stat_comments :-> no of comments posted on user channel
        // stat_groups :-> no of user groups
        // stat_messages :-> no of user unread messages.

        // Mail Handling Related Fields -/ allow user to avoid un necessary emails by setting mail options from myaccount section
        // Note: Below mentioned fields target restriction on external mails. still user will receive internal messages. 
        // There may be chances that some restriction may not work. you can test and report us in order to fix and improve its performance.

        // isautomail :-> enable / disable receiving mails
        // mail_vcomment :-> enable / disable mail receive when user receive comment on his / her video.
        // mail_ccomment :-> enable / disable mail receive when user receive comment on his / her channel.
        // mail_pmessage :-> enable/ disable mail when user receive private message internally within site messaging board.
        // mail_finvite :-> enable / disable mail when user receive friend inviation
        // mail_subscribe :-> enable / disable mail when user subscribed their profile.

        // Privacy Option
        // privacy_fmessages :-> enable / disable allow only friends to send messages and share videos.

        // user credits, allocated space and allowed uploads
        // Credits: Credits available to purchase premium contents
       
        // ************************************************************************************************************************************
        // ************************************************************************************************************************************
        // Member Data Manipulation Section
        // ************************************************************************************************************************************
        // ************************************************************************************************************************************
        #region Data Manipulation

        public UserBLL()
        {
        }

        public static long Add(UserDataEntity entity, string val_key)
        {
            entity.paypal_email = "";
            
            long RecordID = 0;
            
            using (var dbCtx = new mvcportalEntities())
            {
                var _entity = new user()
                {
                    username = entity.username,
                    password = entity.password,
                    email = entity.email,
                    countryname = entity.countryname,
                    register_date = DateTime.Now,
                    isenabled = (byte)entity.isenabled,
                    accounttype = (byte)entity.accounttype,
                    last_login = DateTime.Now,
                    firstname = entity.firstname,
                    lastname = entity.lastname,
                    gender = entity.gender,
                    birthdate = entity.birthdate,
                    val_key = val_key,
                    type = (byte)entity.type,
                    credits = (byte)entity.credits,
                    roleid = (byte)entity.roleid,
                    issuer = entity.issuer,
                    paypal_email = entity.paypal_email,
                    picturename = entity.picturename
                };

                dbCtx.Entry(_entity).State = System.Data.Entity.EntityState.Added;

                DataBLL.SaveChanges(dbCtx);

                RecordID = _entity.userid;
            }
            // send notification mail to admin
            MailTemplateProcess(entity.username, entity.email);
            return RecordID;
        }

        public static bool Delete(string username)
        {

            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new user { username = username };
                dbCtx.users.Attach(entity);
                dbCtx.users.Remove(entity);
                dbCtx.SaveChanges();
            }
                     
            return true;
        }

        public static UserDataEntity Update_User_Profile(UserDataEntity entity)
        {            
            if (Config.Get_ScreeningOption() == 1)
            {
                entity.aboutme = DictionaryBLL.Process_Screening(entity.aboutme);
                //entity.occupations = DictionaryBLL.Process_Screening(entity.occupations);
               // entity.companies = DictionaryBLL.Process_Screening(entity.companies);
               // entity.schools = DictionaryBLL.Process_Screening(entity.schools);
                entity.interests = DictionaryBLL.Process_Screening(entity.interests);
                //entity.movies = DictionaryBLL.Process_Screening(entity.movies);
                //entity.musics = DictionaryBLL.Process_Screening(entity.musics);
                //entity.books = DictionaryBLL.Process_Screening(entity.books);
            }
            if (entity.picturename.Length > 5)
            {
                /* photo there */
                if (entity.picturename != "" && entity.picturename != "none")
                {
                    if (!entity.picturename.StartsWith("http"))
                    {
                        /* newly photo there */
                        try
                        {
                            var _temp_name = entity.picturename;
                            entity.picturename = Jugnoon.Helper.Member.UpdateProfileAvator_Ajax(entity.username, entity.picturename);
                            if (entity.picturename.Contains("http"))
                            {
                                /* remove files from current system */
                                string strPath = HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath) + "//contents//member//" + entity.username + "//photos//";
                                string _filePath = strPath + "/" + _temp_name;
                                string _tempPath = strPath + "/thumbs/" + _temp_name;
                                if (File.Exists(_filePath))
                                    File.Delete(_filePath);
                                if (File.Exists(_tempPath))
                                    File.Delete(_tempPath);
                            }
                        }
                        catch (Exception ex)
                        {
                            /* error occured in picturename */
                            entity.picturename = "none";
                        }
                    }
                }

            }
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.username == entity.username)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    item.firstname = UtilityBLL.processNull(entity.firstname, 0);
                    item.lastname = UtilityBLL.processNull(entity.lastname, 0);
                    item.countryname = UtilityBLL.processNull(entity.countryname, 0);
                    item.gender = UtilityBLL.processNull(entity.gender, 0);
                    item.relationshipstatus = UtilityBLL.processNull(entity.relationshipstatus, 0);
                    item.aboutme = UtilityBLL.processNull(entity.aboutme, 0);
                    item.website = UtilityBLL.processNull(entity.website, 0);
                    item.hometown = UtilityBLL.processNull(entity.hometown, 0);
                    item.currentcity = UtilityBLL.processNull(entity.currentcity, 0);
                    item.zipcode = UtilityBLL.processNull(entity.zipcode, 0);
                    item.picturename = entity.picturename;
                    // item.occupations = UtilityBLL.processNull(entity.occupations, 0);
                    //item.companies = UtilityBLL.processNull(entity.companies, 0);
                    //item.schools = UtilityBLL.processNull(entity.schools, 0);
                    item.interests = UtilityBLL.processNull(entity.interests, 0);
                    //  item.movies = UtilityBLL.processNull(entity.movies, 0);
                    //  item.musics = UtilityBLL.processNull(entity.musics, 0);
                    // item.books = UtilityBLL.processNull(entity.books, 0);
                    item.isallowbirthday = (byte)entity.isallowbirthday;

                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
               
            }
            return entity;
        }


        /*public static bool Update_UserName(string OlderUserName, string NewUserName)
        {
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();
                using (SqlCommand cmd = new SqlCommand("Update users set UserName=@NewUserName WHERE UserName=@OldUserName", con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@NewUserName", NewUserName));
                    cmd.Parameters.Add(new SqlParameter("@OldUserName", OlderUserName));
                    cmd.ExecuteNonQuery();
                }
            }
            return true;

        } */

        public static string Return_Value(string username, string fieldname)
        {
            string Value = "";
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.username == username)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == fieldname.ToLower())
                        {
                            if (prop.GetValue(item, null) != null)
                                Value = prop.GetValue(item, null).ToString();
                        }
                    }
                }
               

            }

            return Value;
        }

        public static string Return_Value(long userid, string fieldname)
        {
            string Value = "";
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.userid == userid)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == fieldname.ToLower())
                        {
                            Value = prop.GetValue(item, null).ToString();
                        }
                    }

                }

            }

            return Value;
        }

        public static bool Update_Field_V3(string username, string fieldname, DateTime value)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.username == username)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == fieldname.ToLower())
                        {
                            prop.SetValue(item, value);
                        }
                    }
                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);

                }
               
            }
            return true;
        }

        public static bool Update_Field_V3(string username, string fieldname, dynamic value)
        {
            if (username == null || username == "")
                return true;
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.username == username)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == fieldname.ToLower())
                        {
                            prop.SetValue(item, value);
                        }
                    }
                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
               
            }
            return true;
            
        }

        

        public static bool Update_Field_V3(long userid, string fieldname, dynamic value)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.userid == userid)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    foreach (var prop in item.GetType().GetProperties())
                    {
                        if (prop.Name.ToLower() == fieldname.ToLower())
                        {
                            prop.SetValue(item, value);
                        }
                    }
                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
              
            }
            return true;

        }
  
        public static bool Update_Favorite_Stat(string UserName, int stat_favorites, int type)
        {
            string field_name = "stat_favorites";
            if (type == 1) // audio
                field_name = "stat_audiofavorites";
            Update_Field_V3(UserName, field_name, stat_favorites);
            return true;
        }

        public static bool Update_UnRead_Messages_Stat(string UserName, int stat_messages)
        {
            Update_Field_V3(UserName, "stat_messages", stat_messages);
            // update user cache value too
            string _cache = "usr_msg_cnt_" + UserName;
            HttpContext.Current.Cache.Add(_cache, stat_messages, null, DateTime.Now.AddMinutes(Site_Settings.Cache_Duration), TimeSpan.Zero, CacheItemPriority.High, null);
            return true;
        }

        public static int Get_UnRead_Messages_Stat(string UserName)
        {
            // This functionality is temporary removed from solution, will add more scalable, lighter and feature rich notification and internal messaging system soon */

            return 0;
            // make it cacheable
           /* string _cache = "usr_msg_cnt_" + UserName;
            if (HttpContext.Current.Cache[_cache] == null)
            {
                using (var ctx = new mvcportalEntities())
                {
                    var item = ctx.users
                         .Where(p => p.username == UserName)
                         .FirstOrDefault<user>();

                    HttpContext.Current.Cache.Add(_cache, item.stat_messages, null, DateTime.Now.AddMinutes(Site_Settings.Cache_Duration), TimeSpan.Zero, CacheItemPriority.High, null);

                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
            }
            return Convert.ToInt32(HttpContext.Current.Cache[_cache]); */
        }


        #endregion
        
        #region Premium UserBLLhip Authorization Checks
        // 0: Normal Member
        // 1: Administrators
        // 2: Premium Users
        public static int Get_MemberType(string UserName)
        {
            string sessionid = "usr_mem_type" + UserName;
            if (HttpContext.Current.Session[sessionid] == null)
            {
                HttpContext.Current.Session.Add(sessionid, Get_MemberType_No_Session(UserName));
            }

            return Convert.ToInt32(HttpContext.Current.Session[sessionid].ToString());
        }

        public static int Get_MemberType_No_Session(string UserName)
        {
            byte Value = 0;
            using (var ctx = new mvcportalEntities())
            {
                Value = ctx.users.Where(p => p.username == UserName).Select(u => u.type).SingleOrDefault();
            }
            return Value;
        }

        // Check UserBLLhip status, true (UserBLLhip still active), false( UserBLLhip expired)
        public static bool Check_membership_Status(string UserName)
        {
            bool status = false;
            string sessionid = "usr_mem_status" + UserName;
            if (HttpContext.Current.Session[sessionid] == null)
            {

               var _items = new List<UserDataEntity>();
               using (var ctx = new mvcportalEntities())
               {
                    _items = ctx.users.Where(p => p.isenabled == 1 && p.username == UserName).Select(u => new UserDataEntity()
                    {
                        last_purchased = (DateTime)u.last_purchased,
                        membership_expiry = (DateTime)u.membership_expiry,
                        islifetimerenewal = u.islifetimerenewal
                    }).ToList();
               }
              
                if (_items.Count > 0)
                {
                    if (_items[0].islifetimerenewal == 1)
                    {
                        // life time renewal is active for selected user
                        status = true;
                    }
                    else
                    {
                        int daysleft = UtilityBLL.GetDateDiff(DateTime.Now, (DateTime)_items[0].membership_expiry);
                        if (daysleft > 0)
                        {
                            // still user account days left
                            status = true;
                        }
                    }
                }
                HttpContext.Current.Session.Add(sessionid, status);
            }

            return Convert.ToBoolean(HttpContext.Current.Session[sessionid].ToString());
        }

        // update user credits, upload and space settings
      /*  public static bool Update_User_Package_Info(string UserName, int credits, int remained_video, int remained_audio, int remained_gallery, int remained_photos, int remained_blogs, double space_video, double space_audio, double space_photos)
        {
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();
                var str = new StringBuilder();
                str.AppendLine("Update users set credits=@credits,remained_video=@remained_video,remained_audio=@remained_audio,remained_gallery=@remained_gallery");
                str.AppendLine(",remained_photos=@remained_photos,remained_blogs=@remained_blogs");
                str.AppendLine(" WHERE username=@username");
                using (var cmd = new SqlCommand(str.ToString(), con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@credits", credits));
                    cmd.Parameters.Add(new SqlParameter("@remained_video", remained_video));
                    cmd.Parameters.Add(new SqlParameter("@remained_audio", remained_audio));
                    cmd.Parameters.Add(new SqlParameter("@remained_gallery", remained_gallery));
                    cmd.Parameters.Add(new SqlParameter("@username", UserName));
                    cmd.Parameters.Add(new SqlParameter("@remained_photos", remained_photos));
                    cmd.Parameters.Add(new SqlParameter("@remained_blogs", remained_blogs));

                    cmd.ExecuteNonQuery();
                }
            }
            return true;
        } */

        // update user UserBLLhip subscription information
        public static bool Update_User_Package_Info(string UserName, DateTime last_purchased, DateTime membership_expiry, int islifetimerenewal)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.username == UserName)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    item.last_purchased = last_purchased;
                    item.membership_expiry = membership_expiry;
                    item.islifetimerenewal = (byte)islifetimerenewal;

                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
                
            }
            return true;
        }
        #endregion

        #region Data Action

        public bool Validate_Member(string UserName, string Password, bool isadmin)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> query = ctx.users.Where(p => (p.username == UserName  || p.email == UserName ) && p.password == Password && p.isenabled == 1);
                if (isadmin)
                    query = query.Where(p => p.type == 1);

                if (query.Count() > 0)
                    flag = true;
            }

            return flag;
            
        }

        public static bool Validate_Member(string UserName)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> query = ctx.users.Where(p => p.username == UserName && p.isenabled == 1);
                
                if (query.Count() > 0)
                    flag = true;
            }

            return flag;
           
        }

        public static bool Validate_Member_Email(string Email, string Password)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> query = ctx.users.Where(p => p.email == Email && p.password == Password);
               
                if (query.Count() > 0)
                    flag = true;
            }

            return flag;
        }

        public bool Check_UserName(string UserName)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> query = ctx.users.Where(p => p.username == UserName || p.email == UserName);

                if (query.Count() > 0)
                    flag = true;
            }

            return flag;
        }

        public bool Check_Email(string Email)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> query = ctx.users.Where(p => p.email == Email);

                if (query.Count() > 0)
                    flag = true;
            }

            return flag;
        }

        public bool Check_Key(string UserName, string val_key)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> query = ctx.users.Where(p => p.username == UserName && p.val_key == val_key);

                if (query.Count() > 0)
                    flag = true;
            }

            return flag;

        }


        public static string Get_Picture(string UserName)
        {
            // store user picture in session in order to fetch directly.
            string sessionid = "vkit_usr_" + UserName;
            if (HttpContext.Current.Session[sessionid] == null)
            {
                string Value = "";               
                using (var ctx = new mvcportalEntities())
                {
                    Value = ctx.users.Where(p => p.username == UserName).Select(u => u.picturename).SingleOrDefault();
                }
                HttpContext.Current.Session.Add(sessionid, Value);
            }

            return HttpContext.Current.Session[sessionid].ToString();
        }

        public static int Increment_Views(string username, int views)
        {
            int current_views = views + 1;
            Update_Field_V3(username, "views", current_views);
            return current_views;
        }

        public bool Update_IsEnabled(string username, int value)
        {
            Update_Field_V3(username, "isenabled", (byte)value);
            
            return true;
        }

        public int Get_Isenabled(string username)
        {
            return Convert.ToInt32(Return_Value(username, "isenabled"));
        }
        #endregion

        #region Core Loading Script

        public static List<UserDataEntity> LoadItems(MemberEntity entity)
        {
            if (!entity.iscache || Config.GetCacheDuration() == 0 || entity.pagenumber > 5)
            {
                return FetchItems(entity);
            }
            else
            {
                string key = GenerateKey("lg_channel_", entity);
                if (HttpContext.Current.Cache[key] == null)
                    HttpContext.Current.Cache.Add(key, FetchItems(entity), null, DateTime.Now.AddMinutes(Config.GetCacheDuration()), TimeSpan.Zero, CacheItemPriority.High, null);

                return (List<UserDataEntity>)(HttpContext.Current.Cache[key]);
            }
        }


        private static List<UserDataEntity> FetchItems(MemberEntity entity)
        {
            var _list = new List<UserDataEntity>();

            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> Query = ctx.users;
                // No INNER JOIN
                entity.iscount = false;
                Query = BuildQuery(Query, entity);
                if (entity.userid > 0 || entity.username != "")
                {
                    entity.loadall = true;
                    _list = LoadCompleteList(Query);
                }
                else if (entity.issummary)
                {
                    _list = LoadSummaryList(Query);
                }
                else if (entity.isdropdown)
                {
                    _list = LoadDropdownList(Query);
                }
                else
                {
                    _list = LoadCompleteList(Query);
                }

            }

            return _list;
        }
        public static int Count(MemberEntity entity)
        {
            if (!entity.iscache || Site_Settings.Cache_Duration == 0 || entity.pagenumber > 5)
            {
                return CountRecords(entity);
            }
            else
            {
                string key = GenerateKey("cnt_members", entity);
                if (HttpContext.Current.Cache[key] == null)
                {
                    int total_records = CountRecords(entity);

                    HttpContext.Current.Cache.Add(key, total_records, null, DateTime.Now.AddMinutes(Site_Settings.Cache_Duration), TimeSpan.Zero, CacheItemPriority.High, null);
                }
                return Convert.ToInt32(HttpContext.Current.Cache[key]);
            }
        }

        private static int CountRecords(MemberEntity entity)
        {
            int Records = 0;
            using (var entities = new mvcportalEntities())
            {
                IQueryable<user> Query = entities.users;
                entity.iscount = true;
                entity.userid = 0;
                Query = BuildQuery(Query, entity);
                Records = Query.Count();
            }
            return Records;
        }

        public static string GenerateKey(string key, MemberEntity entity)
        {
            var str = new StringBuilder();
            return key + entity.accounttype + entity.datefilter + entity.filter + "" + UtilityBLL.ReplaceSpaceWithHyphin(entity.order.ToLower()) + "" + entity.pagenumber + "" + entity.term + "" + entity.character + "" + entity.gender + "" + entity.countryname + "" + entity.havephoto + "" + entity.advancelist + "" + entity.pagesize;

        }
        private static IQueryable<user> BuildQuery(IQueryable<user> query, MemberEntity entity)
        {
            query = Where(query, entity);
            if (entity.userid == 0 && !entity.iscount)
            {
                query = OrderBy(query, entity);
                query = Skip(query, entity);
                query = Limit(query, entity);
            }
            return query;
        }
        
        public static List<UserDataEntity> LoadCompleteList(IQueryable<user> query)
        {
            return query.Select(p => new UserDataEntity
            {
                userid = p.userid,
                email = p.email,
                username = p.username,
                countryname = p.countryname,
                firstname = p.firstname,
                lastname = p.lastname,
                gender = p.gender,
                birthdate = (DateTime)p.birthdate,
                created_at = (DateTime)p.register_date,
                accounttype = (short)p.accounttype,
                views = p.views,
                picturename = p.picturename,
                isenabled = (byte)p.isenabled,
                issendmessages = p.issendmessages,
                isallowbirthday = p.isallowbirthday,
                last_login = (DateTime)p.last_login,
                relationshipstatus = p.relationshipstatus,
                aboutme = p.aboutme,
                website = p.website,
                hometown = p.hometown,
                currentcity = p.currentcity,
                zipcode = p.zipcode,
                occupations = p.occupations,
                companies = p.companies,
                schools = p.schools,
                interests = p.interests,
                movies = p.movies,
                musics = p.musics,
                books = p.books,
                isautomail = (byte)p.isautomail,
                channel_isaudios = (byte)p.channel_isaudios,
                channel_isfriends = p.channel_isfriends,
                channel_isgroups = p.channel_isgroups,
                channel_isblogs = p.channel_isblogs,
                stat_videos = p.stat_videos,
                stat_audios = p.stat_audios,
                stat_audiofavorites = p.stat_audiofavorites,
                stat_blogs = p.stat_blogs,
                stat_forum_points = p.stat_forum_points,
                stat_friends = p.stat_friends,
                stat_groups = p.stat_groups,
                stat_photos = p.stat_photos,
                type = p.type,
                @readonly = p.@readonly,
                credits = p.credits,
                roleid = p.roleid,
                last_purchased = (DateTime)p.last_purchased,
                membership_expiry = (DateTime)p.membership_expiry,
                islifetimerenewal = p.islifetimerenewal,
                paypal_subscriber = p.paypal_subscriber,
                paypal_email = p.paypal_email,
                stat_qa =p.stat_qa,
                stat_qanswers = p.stat_qanswers,
                stat_qafavorites = p.stat_qafavorites,
                issuer = p.issuer
            }).ToList();
        }
        public static List<UserDataEntity> LoadSummaryList(IQueryable<user> query)
        {
            return query.Select(p => new UserDataEntity
            {
                userid = p.userid,
                views = p.views,
                username = p.username,
                picturename = p.picturename,
                countryname = p.countryname,
                created_at = (DateTime)p.register_date,
                isenabled = p.isenabled,
                firstname = p.firstname,
                lastname =  p.lastname,
                gender = p.gender,
                relationshipstatus = p.relationshipstatus,
                hometown = p.hometown,
                currentcity = p.currentcity,
                zipcode = p.zipcode
            }).ToList();
        }
        public static List<UserDataEntity> LoadDropdownList(IQueryable<user> query)
        {
            return query.Select(p => new UserDataEntity
            {
                userid = (int)p.userid,
                username = p.username,
                firstname = p.firstname,
                lastname = p.lastname
            }).ToList();
        }

        private static IQueryable<user> Where(IQueryable<user> query, MemberEntity entity)
        {
            // isenabled (3 :-> deleted items)
            query = query.Where(p => p.isenabled != 3);
            if (entity.excludedid > 0)
                query = query.Where(p => p.userid != entity.excludedid);
            if (entity.userid > 0)
                query = query.Where(p => p.userid == entity.userid);

            if (entity.username != "" && entity.username != null)
                query = query.Where(p => p.username == entity.username);

            if (!entity.nofilter)
            {
                if (entity.term != "" && entity.term != null)
                    query = query.Where(p => p.firstname.Contains(entity.term) || p.lastname.Contains(entity.term) || p.countryname.Contains(entity.term) || p.username.Contains(entity.term));

                if (entity.month > 0 && entity.year > 0)
                    query = query.Where(p => p.register_date.Value.Month == entity.month && p.register_date.Value.Year == entity.year);
                else if (entity.year > 0)
                    query = query.Where(p => p.register_date.Value.Year == entity.year);
                else if (entity.month > 0)
                    query = query.Where(p => p.register_date.Value.Month == entity.month);

                if (entity.isenabled != 2)
                    query = query.Where(p => p.isenabled == entity.isenabled);

                if (entity.havephoto)
                    query = query.Where(p => p.picturename != "none");

                if (entity.gender != "" && entity.gender != null)
                    query = query.Where(p => p.gender == entity.gender);

                if (entity.relationshipstatus != "" && entity.relationshipstatus != null)
                    query = query.Where(p => p.relationshipstatus == entity.relationshipstatus);

                if (entity.countryname != "" && entity.countryname != null)
                    query = query.Where(p => p.countryname == entity.countryname);

                if (entity.character != "" && entity.character != null)
                    query = query.Where(p => p.username.StartsWith(entity.character));

                if (entity.type != 3)
                    query = query.Where(p => p.type == entity.type);

                if (entity.isreadonly != 2)
                    query = query.Where(p => p.@readonly == entity.isreadonly);

                if (entity.accounttype > 0)
                    query = query.Where(p => p.accounttype == entity.accounttype);

                if (entity.datefilter > 0)
                {
                    switch (entity.datefilter)
                    {
                        case 1:
                            // today record
                            query = query.Where(at => SqlFunctions.DateDiff("DAY", at.register_date, DateTime.Now) == 0);
                            break;
                        case 2:
                            // this week record
                            query = query.Where(at => SqlFunctions.DateDiff("DAY", at.register_date, DateTime.Now) >= 0 && SqlFunctions.DateDiff("DAY", at.register_date, DateTime.Now) < 7);
                            break;
                        case 3:
                            // this month record
                            query = query.Where(at => SqlFunctions.DateDiff("DAY", at.register_date, DateTime.Now) >= 0 && SqlFunctions.DateDiff("DAY", at.register_date, DateTime.Now) < 31);
                            break;
                    }
                }
            }
            
                    
            return query;
        }

        private static IQueryable<user> OrderBy(IQueryable<user> query, MemberEntity entity)
        {
            if (entity.order != "")
            {
                var orderlist = entity.order.Split(char.Parse(","));
                foreach (var order in orderlist)
                {
                    if (order.Contains("userid"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.userid);
                        else
                            query = query.OrderBy(p => p.userid);
                        return query;
                    }
                    else if (order.Contains("views"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.views, p.register_date });
                        else
                            query = query.OrderBy(p => new { p.views, p.register_date });
                        return query;
                    }
                    else if (order.Contains("firstname"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.firstname, p.register_date });
                        else
                            query = query.OrderBy(p => p.firstname).OrderByDescending(p => p.register_date);
                        return query;
                    }
                    else if (order.Contains("register_date"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => p.register_date);
                        else
                            query = query.OrderBy(p => p.register_date);
                        return query;
                    }
                    else if (order.Contains("username"))
                    {
                        if (order.Contains("desc"))
                            query = query.OrderByDescending(p => new { p.username, p.register_date });
                        else
                            query = query.OrderBy(p => p.username).OrderByDescending(p => p.register_date);
                        return query;
                    }
                }
            }

            return query;
        }
        private static IQueryable<user> Skip(IQueryable<user> query, MemberEntity entity)
        {
            if (entity.pagenumber > 1)
                query = query.Skip(entity.pagesize * (entity.pagenumber - 1));

            return query;
        }
        private static IQueryable<user> Limit(IQueryable<user> query, MemberEntity entity)
        {
            if (!entity.loadall)
                query = query.Take(entity.pagesize);

            return query;
        }

        #endregion

        public static bool Update_User_Role(string UserName, int roleid)
        {
            using (var ctx = new mvcportalEntities())
            {
                var item = ctx.users
                     .Where(p => p.username == UserName)
                     .FirstOrDefault<user>();

                if(item != null)
                {
                    item.roleid = roleid;

                    ctx.Entry(item).State = System.Data.Entity.EntityState.Modified;
                    DataBLL.SaveChanges(ctx);
                }
                
            }
            
            return true;
        }
      

        // Get Encrypted Password For Encoding Purpose
        public static List<UserDataEntity> Get_Hash_Password(string username)
        {
            var _items = new List<UserDataEntity>();
            using (var ctx = new mvcportalEntities())
            {
                _items = ctx.users
                        .Where(p => p.username == username || p.email == username)
                        .Select(p => new UserDataEntity()
                        {
                            userid = p.userid,
                            username = p.username,
                            password = p.password,
                            type = p.type,
                            @readonly = p.@readonly,
                            isenabled = p.isenabled,
                            email = p.email
                        }).ToList();
            }

            return _items;
        }

        public static List<UserDataEntity> Get_Hash_Password(string username, bool isadmin)
        {

            var _items = new List<UserDataEntity>();
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> Query = ctx.users.Where(p => p.username == username);
                if (isadmin)
                    Query = Query.Where(p => p.type == 1);

                _items = Query.Select(p => new UserDataEntity()
                        {
                            userid = p.userid,
                            username = p.username,
                            password = p.password,
                            type = p.type,
                            @readonly = p.@readonly,
                            isenabled = p.isenabled,
                            email = p.email
                        }).ToList();
            }

            return _items;

        }
      
        // Send Mail To Admin When User Complete Registration
        public static void MailTemplateProcess(string username, string email)
        {
            //if sending mail option enabled
            if (Config.isEmailEnabled())
            {
                List<MailTemplateEntity> lst = MailTemplateBLL.Get_Record("USRREGADM");
                if (lst.Count > 0)
                {
                    string subject = MailProcess.Process2(lst[0].subject, "\\[username\\]", username);
                    string contents = MailProcess.Process2(lst[0].contents, "\\[username\\]", username);
                    contents = MailProcess.Process2(contents, "\\[email\\]", email);

                    string emailaddress = Site_Settings.Admin_Mail;
                    MailProcess.Send_Mail(emailaddress, subject, contents);
                }
            }
        }


        // load all user users info for sending email
        public static List<MemberEntity> Fetch_User_UserNames()
        {
            var _items = new List<MemberEntity>();
            using (var ctx = new mvcportalEntities())
            {
                IQueryable<user> Query = ctx.users;

                _items = Query.Select(p => new MemberEntity()
                {
                    userid = p.userid,
                    username = p.username,
                    isautomail = (byte)p.isautomail,
                    email = p.email
                }).ToList();
            }
            return _items;
        }

        public static string ProcessAction(List<MemberEntity> list)
        {
            foreach (var entity in list)
            {
                if (entity.userid > 0)
                {
                    switch (entity.actionstatus)
                    {
                        case "enable":
                            Update_Field_V3(entity.userid, "isenabled", (byte)1);
                            break;
                        case "disable":
                            Update_Field_V3(entity.userid, "isenabled", (byte)0);
                            break;
                        case "admin":
                            Update_Field_V3(entity.userid, "type", (byte)1);
                            break;
                        case "paid":
                            Update_Field_V3(entity.userid, "type", (byte)2);
                            break;
                        case "normal":
                            Update_Field_V3(entity.userid, "type", (byte)0);
                            break;
                        case "delete":
                            /* better to block user account instead of deleting completely */
                            Update_Field_V3(entity.userid, "isenabled", (byte)3);
                            break;
                    }
                }
            }
            return "Operation performed successfully";
        }

    }
}