﻿
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;

namespace Jugnoon.BLL
{
    public class User_Ratings
    {

        //**********************************************************************************************************************************
        //**********************************************************************************************************************************
        // Store User Ratings in Database.
        //**********************************************************************************************************************************
        //**********************************************************************************************************************************

        // Note: Rating Important Terms

        // Type:
        // ............ 0:- Video Rating
        // ............ 1:- Video Comment Advice Rating
        // ............ 2:- Photo Rating
        // ............ 3:- Blog Rating
        // ............ 9:- Photo Galleries
        // ............ 10:- Group Posts
        // ............ 11: - Group Po
        // ............ 12: - QA Votes
        // ............ 13: - QA Answer Votes
        // ............ 14: - User Activities

        // Rating:
        // ........... video | audio,  0: liked, 1: disliked
        public User_Ratings()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        public static bool Add(string username, long itemid, int type, int rating)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var _entity = new user_ratings()
                {
                    username = username,
                    itemid = itemid,
                    type = (byte)type,
                    rating = (byte)rating
                };

                dbCtx.Entry(_entity).State = System.Data.Entity.EntityState.Added;

                DataBLL.SaveChanges(dbCtx);
                
            }
            
            return true;
        }

        public static bool Delete(long itemid, int type)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new user_ratings { itemid = itemid, type = (byte)type };
                dbCtx.user_ratings.Attach(entity);
                dbCtx.user_ratings.Remove(entity);
                dbCtx.SaveChanges();
            }

            return true;
        }

        public static bool Delete(string username)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new user_ratings { username = username };
                dbCtx.user_ratings.Attach(entity);
                dbCtx.user_ratings.Remove(entity);
                dbCtx.SaveChanges();
            }
            return true;
        }

        public static bool Delete(string username, long itemid, int type)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new user_ratings { username = username, itemid = itemid, type = (byte)type };
                dbCtx.user_ratings.Attach(entity);
                dbCtx.user_ratings.Remove(entity);
                dbCtx.SaveChanges();
            }
            return true;
            
        }
        public static bool Check(string username, long itemid, int type)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                if (ctx.user_ratings.Where(p => p.itemid == itemid && p.username == username && p.type == (byte)type).Count() > 0)
                    flag = true;
            }

            return flag;
        }
    }
}