﻿
namespace Jugnoon.BLL
{
    /*************************************************************************************
     *  This script is no longer supported in Linq Version
     *  *********************************************************************************/

    public class ViewStatsBLL
    {
        public ViewStatsBLL()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        // Note: Important View Stat Terms

        // Table Used:
        // i: view_stat_today // handles today viewed contents
        // ii: view_stat_thisweek // handles thisweek viewed contents
        // iii: view_stat_thismonth // handles this month viewed contents

        // itemtype:
        // ........... 1: Videos | Audio Files
        // ........... 2: Photos
        // ........... 3: Blogs
        // ........... 4: Galleries
        // ........... 5: Forum
        // ........... 6: Groups
        /// <summary>
        /// Handles view statistic of contents
        /// </summary>
    /*    public static void Process_View_Stats(long contentid, int itemtype, int views)
        {
            //*******************************************************
            // Comment advance view statistic section if you not want advance view statistic
            // By commenting this section today, thisweek, this month section will not load data
            // Advance View Statistic Section
            //************************************************************
            // Clear old statistics :-> Scalable approach is to call this function from admin section in daily basis manually
            Clear_Old_Stats();

            // increment views
            views = views + 1;
            // increment today views
            Increment_Views_Today(contentid, itemtype);
            // increment thisweek views
            Increment_Views_ThisWeek(contentid, itemtype);
            // increment thismonth views
            Increment_Views_ThisMonth(contentid, itemtype);

            //*****************************************************
            // Close Advance View Statistic Section
            //*****************************************************
            switch (itemtype)
            {
                case 1:
                    // increment alltime video views
                    Increment_Video_Views_AllTime(contentid, views);
                    break;
                case 2:
                    // increment alltime photo views
                    Increment_Photo_Views_AllTime(contentid, views);
                    break;
                case 3:
                    // increment alltime blog views
                    Increment_Blog_Views_AllTime(contentid, views);
                    break;
            }
        }

        /// <summary>
        /// Delete all older stats
        /// </summary>
        public static void Clear_Old_Stats()
        {
            if (HttpContext.Current.Cache["view_stat_clear_data"] == null)
            {
                // Today :-> clear all records from view_stat_today which is older than today
                string query = "Delete from view_stat_today where";
                //query = query + " DateDiff(added_date,CURDATE())<=-1"; // mysql version
                query = query + " DateDiff(DAY,added_date,getdate())>=1"; // sql server
                ProcessQuery(query);

                // This Week :-> clear all records from view_stat_thisweek which isolder than this week
                query = "Delete from view_stat_thisweek where";
                //query = query + " DateDiff(added_date,CURDATE())<=-7"; // mysql version
                query = query + " DateDiff(DAY,added_date,getdate())>=7"; //sql server
                ProcessQuery(query);
                // This Month :-> clear all records from view_stat_thismonth which is older than this month
                query = "Delete from view_stat_thismonth where";
                //query = query + " DateDiff(added_date,CURDATE())<=-31"; // mysql version
                query = query + " DateDiff(DAY,added_date,getdate())>=31"; // sql server
                ProcessQuery(query);
                // populate cache
                HttpContext.Current.Cache.Add("view_stat_clear_data", "ClearOK", null, DateTime.Now.AddMinutes(20), TimeSpan.Zero, CacheItemPriority.High, null);
            }
        }

        private static void ProcessQuery(string query)
        {
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();

                using (SqlCommand cmd = new SqlCommand(query, con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.ExecuteNonQuery();
                }
            }
        }

        private static void Increment_Views_Today(long contentid, int itemtype)
        {
            if (!Check_Today(contentid, itemtype))
            {
                // Add record
                Add_Views(contentid, itemtype, "view_stat_today");
            }
            else
            {
                // Increment record
                // retrieve view stats for selected record
                int views = Get_Views(contentid, itemtype, "view_stat_today");
                views = views + 1;
                // update view stats
                Update_Views(contentid, itemtype, views, "view_stat_today");
            }
        }

        private static void Increment_Views_ThisWeek(long contentid, int itemtype)
        {
            if (!Check_ThisWeek(contentid, itemtype))
            {
                // Add record
                Add_Views(contentid, itemtype, "view_stat_thisweek");
            }
            else
            {
                // Increment record
                // retrieve view stats for selected record
                int views = Get_Views(contentid, itemtype, "view_stat_thisweek");
                views = views + 1;
                // update view stats
                Update_Views(contentid, itemtype, views, "view_stat_thisweek");
            }
        }

        private static void Increment_Views_ThisMonth(long contentid, int itemtype)
        {
            if (!Check_ThisMonth(contentid, itemtype))
            {
                // Add record
                Add_Views(contentid, itemtype, "view_stat_thismonth");
            }
            else
            {
                // Increment record
                // retrieve view stats for selected record
                int views = Get_Views(contentid, itemtype, "view_stat_thismonth");
                views = views + 1;
                // update view stats
                Update_Views(contentid, itemtype, views, "view_stat_thismonth");
            }
        }


        private static void Increment_Video_Views_AllTime(long contentid, int views)
        {
            IncrementRecord(contentid, views, "videos", "VideoID");
        }

        private static void Increment_Photo_Views_AllTime(long contentid, int views)
        {
            IncrementRecord(contentid, views, "photos", "ImageID");
        }

        private static void Increment_Blog_Views_AllTime(long contentid, int views)
        {
            IncrementRecord(contentid, views, "blogs", "postid");
        }

        private static void IncrementRecord(long contentid, int views, string tableName, string FieldName)
        {
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();
                string query = "Update " + tableName + " set views=@views where " + FieldName + "=@id";
                using (SqlCommand cmd = new SqlCommand(query, con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@id", contentid));
                    cmd.Parameters.Add(new SqlParameter("@views", views));
                    cmd.ExecuteNonQuery();
                }
            }
        }

        // Check contents
        private static bool Check_Today(long contentid, int itemtype)
        {
            return CheckRrecord(contentid, itemtype, "view_stat_today");
        }

        private static bool Check_ThisWeek(long contentid, int itemtype)
        {
            return CheckRrecord(contentid, itemtype, "view_stat_thisweek");
        }

        private static bool Check_ThisMonth(long contentid, int itemtype)
        {
            return CheckRrecord(contentid, itemtype, "view_stat_thismonth");
        }

        public static bool CheckRrecord(long contentid, int itemtype, string tableName)
        {
            bool flag = false;
            StringBuilder query = new StringBuilder();
            query.Append("SELECT Count(contentid) from " + tableName + " WHERE ContentID=@id AND  itemtype=@itemtype");

            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();

                using (SqlCommand cmd = new SqlCommand(query.ToString(), con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@id", contentid));
                    cmd.Parameters.Add(new SqlParameter("@itemtype", itemtype));
                    if (Convert.ToInt32(cmd.ExecuteScalar()) > 0)
                        flag = true;
                }
            }

            return flag;
        }

        // Add Views
        private static void Add_Views(long contentid, int itemtype, string tablename)
        {
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();

                using (SqlCommand cmd = new SqlCommand("Insert into " + tablename + "(contentid,itemtype,added_date)values(@contentid,@itemtype,@added_date)", con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@contentid", contentid));
                    cmd.Parameters.Add(new SqlParameter("@itemtype", itemtype));
                    cmd.Parameters.Add(new SqlParameter("@added_date", DateTime.Now));
                    cmd.ExecuteNonQuery();
                }
            }
        }
        // Get Views
        private static int Get_Views(long contentid, int itemtype, string tablename)
        {
            int Views = 0;
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();

                string query = "SELECT views FROM " + tablename + " WHERE ContentID=@id AND itemtype=@itemtype";
                using (SqlCommand cmd = new SqlCommand(query.ToString(), con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@id", contentid));
                    cmd.Parameters.Add(new SqlParameter("@itemtype", itemtype));
                    Views = Convert.ToInt32(cmd.ExecuteScalar());
                }
            }
            return Views;
        }
        // Update Views
        private static void Update_Views(long contentid, int itemtype, int views, string tablename)
        {
            using (var con = new SqlConnection(Config.ConnectionString))
            {
                con.Open();

                using (SqlCommand cmd = new SqlCommand("Update " + tablename + " set views=@views WHERE ContentID=@contentid AND itemtype=@itemtype", con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.Add(new SqlParameter("@contentid", contentid));
                    cmd.Parameters.Add(new SqlParameter("@itemtype", itemtype));
                    cmd.Parameters.Add(new SqlParameter("@views", views));
                    cmd.ExecuteNonQuery();
                }
            }
        }

        // Get Content Views
        public static int Get_Views_Today(long contentid, int itemtype)
        {
            return Get_Views(contentid, itemtype, "view_stat_today");
        }

        public static int Get_Views_ThisWeek(long contentid, int itemtype)
        {
            return Get_Views(contentid, itemtype, "view_stat_thisweek");
        }

        public static int Get_Views_ThisMonth(long contentid, int itemtype)
        {
            return Get_Views(contentid, itemtype, "view_stat_thismonth");
        } */

    }
}