﻿using System.Text;
using Jugnoon.Utility;
using Jugnoon.Entity;

namespace Jugnoon.BLL
{
    public class XMLBLL
    {
        private static UtilityBLL _utility = new UtilityBLL();
                        
        // Category Sitemaps
        public static string Google_CategorySitemap(CategoryEntity Entity)
        {
            var str = new StringBuilder();
            str.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            str.AppendLine("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\"");
            str.AppendLine(" xmlns:image=\"http://www.google.com/schemas/sitemap-image/1.1\"");
            str.AppendLine(" xmlns:video=\"http://www.google.com/schemas/sitemap-video/1.1\">");

            string path = "videos/";
            switch(Entity.type)
            {
                case (int)CategoryBLL.Types.Photos:
                    path = "photos/";
                    break;
                case (int)CategoryBLL.Types.Blogs:
                    path = "blogs/";
                    break;
                case (int)CategoryBLL.Types.Polls:
                    path = "polls/";
                    break;
                case (int)CategoryBLL.Types.Forum:
                    path = "forums/";
                    break;
                case (int)CategoryBLL.Types.QA:
                    path = "qa/";
                    break;
            }
            var _lst = CategoryBLL.LoadItems(Entity);
            foreach (var Item in _lst)
            {
                str.AppendLine("<url>");
                str.AppendLine("<loc>" + CategoryUrlConfig.PrepareUrl(Item, path) + "</loc>");
                str.AppendLine("</url>");
            }
            str.AppendLine("</urlset>");

            return str.ToString();
        }

        public static string Bing_CategorySitemap(CategoryEntity Entity)
        {
            var str = new StringBuilder();
            str.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            str.AppendLine("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">");
            var _lst = CategoryBLL.LoadItems(Entity);
            string path = "videos/";
            switch (Entity.type)
            {
                case (int)CategoryBLL.Types.Photos:
                    path = "photos/";
                    break;
                case (int)CategoryBLL.Types.Blogs:
                    path = "blogs/";
                    break;
                case (int)CategoryBLL.Types.Polls:
                    path = "polls/";
                    break;
                case (int)CategoryBLL.Types.Forum:
                    path = "forums/";
                    break;
                case (int)CategoryBLL.Types.QA:
                    path = "qa/";
                    break;
            }
            foreach (var Item in _lst)
            {
                str.AppendLine("<url>");
                str.AppendLine("<loc>" + CategoryUrlConfig.PrepareUrl(Item, path) + "</loc>");
                str.Append("</url>");
            }
            str.AppendLine("</urlset>");

            return str.ToString();
        }

        // Tags Sitemaps
        public static string Google_TagySitemap(TagEntity Entity)
        {
            var str = new StringBuilder();
            str.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            str.AppendLine("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\"");
            str.AppendLine(" xmlns:image=\"http://www.google.com/schemas/sitemap-image/1.1\"");
            str.AppendLine(" xmlns:video=\"http://www.google.com/schemas/sitemap-video/1.1\">");
            string path = "videos/";
            switch (Entity.type)
            {
                case (int)TagsBLL.Types.Photos:
                    path = "photos/";
                    break;
                case (int)TagsBLL.Types.Blogs:
                    path = "blogs/";
                    break;
                case (int)TagsBLL.Types.QA:
                    path = "qa/";
                    break;
            }
            var _lst = TagsBLL.LoadItems(Entity);
            foreach (var Item in _lst)
            {
                str.AppendLine("<url>");
                str.AppendLine("<loc>" + TagUrlConfig.PrepareUrl(Item, path) + "</loc>");
                str.AppendLine("</url>");
            }
            str.AppendLine("</urlset>");

            return str.ToString();
        }

        public static string Bing_TagSitemap(TagEntity Entity)
        {
            var str = new StringBuilder();
            str.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            str.AppendLine("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">");
            var _lst = TagsBLL.LoadItems(Entity);
            string path = "videos/";
            switch (Entity.type)
            {
                case (int)TagsBLL.Types.Photos:
                    path = "photos/";
                    break;
                case (int)TagsBLL.Types.Blogs:
                    path = "blogs/";
                    break;
                case (int)TagsBLL.Types.QA:
                    path = "qa/";
                    break;
            }
            foreach (var Item in _lst)
            {
                str.AppendLine("<url>");
                str.AppendLine("<loc>" + TagUrlConfig.PrepareUrl(Item, path) + "</loc>");
                str.Append("</url>");
            }
            str.AppendLine("</urlset>");

            return str.ToString();
        }
                

    }
}