﻿using Jugnoon.Settings;
using System.Web;

namespace Jugnoon.videos
{
    public class EncoderSettings
    {
        public EncoderSettings()
        {
            //
            // TODO: Add constructor logic here
            //
        }
     
                                                // itag value is used to point which encoder setting is currently required.
                                                // FLV Video Encoding
                                                // 0: FLV 240p
                                                // 1: FLV 360p
                                                // 2: FLV 480p
                                                // 3: FLV 720p
                                                // MP4 Video Encoding
                                                // 4: MP4 240p
                                                // 5: MP4 360p
                                                // 6: MP4 480p
                                                // 7: MP4 720p
                                                // 8: MP4 1080p
                                                // WebM Video Encoding
                                                // 9: WebM 240p
                                                // 10: WebM 360p
                                                // 11: WebM 480P
                                                // 12: WebM 720p
                                                // 13: WebM 1080p
                                                // MP3 Encoding
                                                // 14: mp3 audio

        public static MediaHandler ReturnMediaSettings(int itag)
        {
            var media = new MediaHandler();
            string RootPath = HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath);
            switch (itag)
            {               
                case 4: // 240p mp4 video encoding
                    media.OutputExtension = ".mp4";
                    media.Parameters = Site_Settings.MP4_240p_Settings;
                    break;
                case 5: // 360p mp4 video encoding
                    media.OutputExtension = ".mp4";
                    media.Parameters = "-s 640x380 -c:v libx264 -preset medium -crf 22 -b:v 500k -b:a 128k -profile:v baseline -level 3.1"; // Site_Settings.MP4_360p_Settings;
                    break;
                case 6: // 480p mp4 video encoding
                    media.OutputExtension = ".mp4";
                    media.Parameters = Site_Settings.MP4_480p_Settings;
                    break;
                case 7: // 720p mp4 video encoding
                    media.OutputExtension = ".mp4";
                    media.Parameters = Site_Settings.MP4_720p_Settings;
                    break;
                case 8: // 1080p mp4 video encoding
                    media.OutputExtension = ".mp4";
                   media.Parameters = Site_Settings.MP4_1080p_Settings;
                    break;
                case 14: // mp3 audio encoding
                    media.DisableVideo = true;
                    media.Channel = 2;
                    media.Audio_SamplingRate = 4800;
                    media.Audio_Bitrate = 192;
                    media.OutputExtension = ".mp3";
                    break;
            }
            return media;
        }


        public static string Return_Output_Extension(int itag)
        {
            string extension = "";
            switch (itag)
            {
                case 0:
                    extension = "flv";
                    break;
                case 1:
                    extension = "flv";
                    break;
                case 2:
                    extension = "flv";
                    break;
                case 3:
                    extension = "flv";
                    break;
                case 4:
                    extension = "mp4";
                    break;
                case 5:
                    extension = "mp4";
                    break;
                case 6:
                    extension = "mp4";
                    break;
                case 7:
                    extension = "mp4";
                    break;
                case 8:
                    extension = "mp4";
                    break;
                case 9:
                    extension = "webm";
                    break;
                case 10:
                    extension = "webm";
                    break;
                case 11:
                    extension = "webm";
                    break;
                case 12:
                    extension = "webm";
                    break;
                case 13:
                    extension = "webm";
                    break;
                case 14:
                    extension = "mp3";
                    break;
            }
            return extension;
        }
    }
}