﻿
namespace Jugnoon.videos
{
   /* public class MHPEncoder
    {
        public MHPEncoder()
        {
            //
            // TODO: Add constructor logic here
            //
        }


        // PROPERTIES
        public string FfmpegPath = "";
        public string FlvToolPath = "";
        public string Mp4BoxPath = "";
        public string SourcePath = "";
        public string SourceFileName = "";
        public string PublishedFileName = "";
        public string PublishedPath = "";
        public string ThumbsDirectory = "";
        public string WatermarkPath = "";
        public string WatermarkImagePath = "";

        public bool GrabThumbs = true; // Grab thumbs from source video
        public bool EnablePublishVideos = true; // Allow script to published videos, if disabled, script will skip to generate only thumbs
        public bool GrabSingleThumb = false; // Grab single or multiple thumbs
        public int TotalThumbs = 15; // Grab 15 thumbs if multiple thumbs allowed.

        public bool BackgroundProcessing = false;

        public bool AllowRollback = true; // rollback all processes if error occurs in any case.

        public bool DeleteSource = true; // Delete source video once all processing completed.

        public bool SameFormatEncoding = true; // Allow program to publish same format videos except audio files.

        public bool EnableCloudStorage = false; // Store videos and other contents in cloud storage

        public ArrayList PublishedFiles = null; // list of published files

        public ArrayList iTags = null; // "5,14"; // list of encoding options for publishing videos, for detail visit encodersettings.cs or .vb file

        public Video_Information Process()
        {
                       
            var info = new Video_Information();
            VideoInfo vd = null;
            VideoInfo defaultinfo = null; // store first published video info in this object
            string OutputFileName = "";
            string ThumbFileName = "";

            if (CloudSettings.MediaType == 1)
            {
                
                return info;
            }
            else
            {
                MediaHandler med = null;
                // Validation of paths
                if (!File.Exists(FfmpegPath))
                {
                    info.ErrorCode = 1000;
                    info.ErrorDescription = "FFMPEG Path Incorrect";
                    if (AllowRollback)
                        RollbackEncoding();
                    return info;
                }

                if (!File.Exists(Mp4BoxPath))
                {
                    info.ErrorCode = 1002;
                    info.ErrorDescription = "MP4Box Path Incorrect";
                    if (AllowRollback)
                        RollbackEncoding();
                    return info;
                }
                if (!File.Exists(SourcePath + "\\" + SourceFileName))
                {
                    info.ErrorCode = 1003;
                    info.ErrorDescription = "Source Video Path Incorrect";
                    if (AllowRollback)
                        RollbackEncoding();
                    return info;
                }
                if (!Directory.Exists(PublishedPath))
                {
                    info.ErrorCode = 1004;
                    info.ErrorDescription = "Published Directory Path Invalid";
                    if (AllowRollback)
                        RollbackEncoding();
                    return info;
                }
                if (!Directory.Exists(ThumbsDirectory) && GrabThumbs)
                {
                    info.ErrorCode = 1005;
                    info.ErrorDescription = "Thumbs Directory Path Invalid";
                    if (AllowRollback)
                        RollbackEncoding();
                    return info;
                }
             
                //*************************************************
                // publishing video and audio script
                //*************************************************
                try
                {
                    PublishedFiles = new ArrayList();
                    OutputFileName = this.SourceFileName.Remove(this.SourceFileName.LastIndexOf("."));

                    int PresetValue = 0;
                    
                    if (EnablePublishVideos)
                    {
                        if (iTags.Count > 0)
                        {
                            int i = 0;
                            for (i = 0; i <= iTags.Count - 1; i++)
                            {
                                PresetValue = Convert.ToInt32(iTags[i]);
                                med = EncoderSettings.ReturnMediaSettings(PresetValue);
                                med.FFMPEGPath = this.FfmpegPath;
                                med.FLVToolPath = this.FlvToolPath;
                                med.InputPath = this.SourcePath;
                                med.OutputPath = this.PublishedPath;
                                med.FileName = this.SourceFileName;
                                if(Site_Settings.PublishVideoLength > 0)
                                {
                                    med.Duration = Site_Settings.PublishVideoLength.ToString();
                                }
                                if (this.BackgroundProcessing)
                                    med.BackgroundProcessing = true;

                                if (med.OutputExtension == ".mp4")
                                {
                                    if (this.PublishedFileName != "")
                                    {
                                        med.OutputFileName = this.PublishedFileName.Remove(this.PublishedFileName.LastIndexOf(".")); // filename witout extension
                                        med.OutputExtension = this.PublishedFileName.Remove(0, this.PublishedFileName.LastIndexOf(".")); // only extension
                                    }
                                    else
                                    {
                                        // i: publish mp4 video as temp
                                        med.OutputFileName = OutputFileName;
                                    }
                                }
                                else
                                {
                                    if (this.PublishedFileName != "")
                                    {
                                        med.OutputFileName = this.PublishedFileName.Remove(this.PublishedFileName.LastIndexOf(".")) + "_" + iTags[i].ToString(); // filename witout extension
                                        med.OutputExtension = this.PublishedFileName.Remove(0, this.PublishedFileName.LastIndexOf(".")); // only extension
                                    }
                                    else
                                    {
                                        med.OutputFileName = OutputFileName + "_" + iTags[i].ToString();
                                    }
                                }
                                vd = med.Process();
                                if (vd.ErrorCode > 0)
                                {
                                    info.ErrorCode = vd.ErrorCode;
                                    switch (vd.ErrorCode)
                                    {
                                        case 100:
                                            vd.ErrorMessage = "100 --> ffmpeg.exe path is incorrect or not found, please make sure that you download and put complete folder of ffmpeg on root of your web application.";
                                            break;
                                        case 101:
                                            vd.ErrorMessage = "101 --> Source video path is incorrect or not found.";
                                            break;
                                        case 102:
                                            vd.ErrorMessage = "102 --> Destination directory path is incorrect or not found.";
                                            break;
                                        case 104:
                                            vd.ErrorMessage = "104 -->Unknown options or video -> Main Reasons -> Unknown format, Unsupported codec, Unknown encoder";
                                            break;
                                        case 105:
                                            vd.ErrorMessage = "105 --> No such file or directory found.";
                                            break;
                                        case 106:
                                            vd.ErrorMessage = "106 --> Error occured while opening codecs.";
                                            break;
                                        case 107:
                                            vd.ErrorMessage = "107 --> Video processing failed, main reason Unknown Encoder";
                                            break;
                                        case 108:
                                            vd.ErrorMessage = "108 --> Watermark image not found. in case of posting watermark on video.";
                                            break;
                                        case 109:
                                            vd.ErrorMessage = "109 --> Source video extension not found. the variable sending through filename must have a valid video extension. e.g FileName = sample.mpg, not sample.";
                                            break;
                                        case 110:
                                            vd.ErrorMessage = "110 --> Can't process current request.";
                                            break;
                                        case 111:
                                            vd.ErrorMessage = "111 --> Invalid video format - format not supported";
                                            break;
                                        case 113:
                                            vd.ErrorMessage = "113 --> Flvtool2.exe not found";
                                            break;
                                        case 118:
                                            vd.ErrorMessage = "118 --> Video codec is not compatible with encoded video format.";
                                            break;
                                        case 119:
                                            vd.ErrorMessage = "119 --> Error while retrieving audio information from video. It arises while parsing audio data returned from video.";
                                            break;
                                        case 127:
                                            vd.ErrorMessage = "127 - > Video encoded successfully but failed to add meta information.";
                                            break;
                                        case 128:
                                            vd.ErrorMessage = "128 - > Error while opening output stream. Maybe incorrect parameters such as bit_rate, rate, width or height.";
                                            break;
                                        case 130:
                                            vd.ErrorMessage = "130 - > Incorrect Parameters (when some parameters provided invalide with media type).";
                                            break;
                                        case 131:
                                            vd.ErrorMessage = "131 - > Unknown video format.";
                                            break;
                                        case 132:
                                            vd.ErrorMessage = "132 - > Unknown video encoder.";
                                            break;
                                        case 133:
                                            vd.ErrorMessage = "133 - > Unknown codec.";
                                            break;
                                        case 134:
                                            vd.ErrorMessage = "134 - > incorrect parameters";
                                            break;
                                        case 144:
                                            vd.ErrorMessage = "144 - > preset file: ffpreset file not found";
                                            break;
                                    }
                                    info.ErrorDescription = vd.ErrorMessage + ", itag no: " + iTags[i].ToString();
                                    if (AllowRollback)
                                    {
                                        RollbackEncoding(PublishedFiles);
                                    }
                                    return info;
                                }
                                // Validation of published file
                                int plength = 0;
                                string path = this.PublishedPath + "\\" + vd.FileName;
                                if (File.Exists(path))
                                {
                                    FileInfo flv_info = new FileInfo(path);
                                    plength = (int)flv_info.Length;
                                }

                                if (plength == 0)
                                {
                                    // 0 byte video generated - encoding failed - rollback process
                                    if (AllowRollback)
                                    {
                                        RollbackEncoding(PublishedFiles);
                                    }
                                    info.ErrorCode = vd.ErrorCode;
                                    info.ErrorDescription = vd.ErrorMessage + ", itag no: " + iTags[i].ToString();
                                    return info;
                                }
                                if (med.OutputExtension == ".mp4")
                                {
                                    // ii: add meta information to mp4 video
                                    med.MP4BoxPath = this.Mp4BoxPath;
                                    string _mp4_temp_path = "\"" + this.PublishedPath + "\\" + med.OutputFileName + ".mp4\"";
                                    med.Parameters = "-isma -hint -add " + _mp4_temp_path + "";
                                    med.FileName = med.OutputFileName + "_" + iTags[i].ToString() + ".mp4";
                                    med.InputPath = this.PublishedPath;
                                    med.Set_MP4_Buffering();

                                    // check whether file created
                                    if (File.Exists(this.PublishedPath + "\\" + med.FileName))
                                    {
                                        // remove temp mp4 file
                                        if (File.Exists(this.PublishedPath + "\\" + med.OutputFileName + ".mp4"))
                                            File.Delete(this.PublishedPath + "\\" + med.OutputFileName + ".mp4");
                                    }
                                    else
                                    {
                                        // file not created by mp4box
                                        // rename published mp4 as _5.mp4
                                        File.Move(this.PublishedPath + "\\" + med.OutputFileName + ".mp4", this.PublishedPath + "\\" + med.FileName);
                                    }

                                    vd.FileName = med.FileName;

                                    ThumbFileName = med.OutputFileName;
                                }
                                PublishedFiles.Add(vd.FileName);
                                if (i == 0)
                                {
                                    defaultinfo = vd;
                                }
                            }
                            
                        }
                    }
                    //*******************************************************
                    // Add Support for Preview Video
                    //*******************************************************
                    string PreviewVideoUrl = "";
                    if (Site_Settings.EnablePreviewUrl)
                    {
                        var previewinfo = GeneratePreviewVideo(PresetValue);
                        if (previewinfo.ErrorCode > 0)
                        {
                            
                        }
                        else
                        {
                            PreviewVideoUrl = previewinfo.FileName;
                        }
                    }
                   
                    // Thumb Grabbing Script
                    if (this.GrabThumbs)
                    {
                        med = new MediaHandler();
                        med.FFMPEGPath = this.FfmpegPath;
                        med.InputPath = this.SourcePath;
                        med.OutputPath = this.ThumbsDirectory;
                        med.FileName = this.SourceFileName;
                        string thumb_start_index = ThumbFileName + "_";
                        med.Image_Format = "jpg";
                        med.VCodec = "image2"; //optional
                        med.ACodec = "";
                        med.ImageName = thumb_start_index;
                        med.Multiple_Thumbs = true;
                        med.ThumbMode = 0;
                        med.No_Of_Thumbs = this.TotalThumbs;
                        med.Thumb_Start_Position = 5; // start grabbing thumbs from 5th second
                        if (this.BackgroundProcessing)
                            med.BackgroundProcessing = true;
                        int width = Site_Settings.Thumb_Width;
                        if (width > 0)
                            med.Width = width;
                        int height = Site_Settings.Thumb_Height;
                        if (height > 0)
                            med.Height = height;
                        VideoInfo tinfo = med.Grab_Thumb();
                        if (tinfo.ErrorCode > 0)
                        {
                            // Error occured in grabbing thumbs - Rollback process
                            info.ErrorCode = 1006;
                            info.ErrorDescription = "Grabbing thumbs from video failed";
                            if (AllowRollback)
                            {
                                RollbackEncoding(PublishedFiles, thumb_start_index);
                            }
                            return info;
                        }

                        // Validate Thumbs
                        info.isEnabled = 1;
                        string path = this.ThumbsDirectory + "\\" + ThumbFileName;
                        if (!File.Exists(path + "_004.jpg") || !File.Exists(path + "_008.jpg") || !File.Exists(path + "_011.jpg"))
                        {
                            // thumb failed try again grabbing thumbs from published video
                            med.InputPath = this.SourcePath;
                            med.FileName = defaultinfo.FileName; // grab thumb from encoded video
                            tinfo = med.Grab_Thumb();
                            if (tinfo.ErrorCode > 0)
                            {
                                // Error occured in grabbing thumbs - Rollback process
                                info.ErrorCode = 1006;
                                info.ErrorDescription = "Grabbing thumbs from video failed";
                                if (AllowRollback)
                                {
                                    RollbackEncoding(PublishedFiles, thumb_start_index);
                                }
                                return info;
                            }
                            // Disable Video
                            if (!File.Exists(path + "_004.jpg") || !File.Exists(path + "_008.jpg") || !File.Exists(path + "_011.jpg"))
                            {
                                info.isEnabled = 0; // disable video - thumbs not grabbed properly.
                            }
                        }
                        info.ThumbFileName = ThumbFileName + "" + "_008.jpg";
                        info.ThumbStartIndex = ThumbFileName;

                    }

                    // Final Cleaning
                    if (this.DeleteSource)
                    {
                        if (File.Exists(this.SourcePath + "\\" + this.SourceFileName))
                            File.Delete(this.SourcePath + "\\" + this.SourceFileName);
                    }

                    // **************************************************************
                    // CLOUD STORAGE SCRIPT
                    // **************************************************************
                    if (CloudSettings.EnableCloudStorage)
                    {
                        if (CloudSettings.AccessKeyID != "" && CloudSettings.SecreteKey != "" && CloudSettings.VideoBucketName != "" && CloudSettings.ThumbsBucketName != "")
                        {

                            string status = CloudStorage.UploadMediaFiles(this.SourcePath, this.SourceFileName, this.PublishedPath, this.PublishedFiles, this.ThumbsDirectory, ThumbFileName, this.TotalThumbs, PreviewVideoUrl);
                            if (status == "PubFailed" || status == "ThumbFailed")
                            {
                                info.ErrorCode = 1009;
                                info.ErrorDescription = "Storing content on cloud failed";
                                if (AllowRollback)
                                {
                                    RollbackEncoding(PublishedFiles, ThumbFileName + "_");
                                }
                                return info;
                            }
                        }
                        else
                        {
                            info.ErrorCode = 1008;
                            info.ErrorDescription = "Cloud Storage Enabled But No Cloud Storage Settings Available";
                            if (AllowRollback)
                            {
                                RollbackEncoding(PublishedFiles, ThumbFileName + "_");
                            }
                            return info;
                        }
                    }

                    info.Duration = UtilityBLL.Customize_Duration(defaultinfo.Duration);
                    info.Duration_Sec = defaultinfo.Duration_Sec;
                    info.FLVVideoName = defaultinfo.FileName;
                    info.OriginalVideoName = this.SourceFileName;
                    info.PreviewVideoName = PreviewVideoUrl;
                    return info;
                }
                catch (Exception ex)
                {
                    info.ErrorCode = 1007;
                    info.ErrorDescription = ex.Message;
                    if (AllowRollback)
                        RollbackEncoding(this.PublishedFiles, ThumbFileName);
                    return info;
                }
            }
            

        }

        private VideoInfo GeneratePreviewVideo(int preset)
        {
            preset = 5; // for testing purpose
            var OutputFileName = this.SourceFileName.Remove(this.SourceFileName.LastIndexOf(".")) + "_preview";

            var med = EncoderSettings.ReturnMediaSettings(preset);
            med.FFMPEGPath = this.FfmpegPath;
            med.FLVToolPath = this.FlvToolPath;
            med.InputPath = this.SourcePath;
            med.OutputPath = this.PublishedPath;
            med.FileName = this.SourceFileName;

            if (Site_Settings.PreviewUrlType == 0)
            {
                // clip view
                if(Site_Settings.ClipLength > 0)
                {
                    med.Duration = Site_Settings.ClipLength.ToString();
                }
            }
            else
            {
                // custom preview view
                med.Parameters = Site_Settings.MP4_240p_Settings; // Site_Settings.PreviewPreset;
            }
            
            if (this.BackgroundProcessing)
                med.BackgroundProcessing = true;

            if (med.OutputExtension == ".mp4")
            {
                if (this.PublishedFileName != "")
                {
                    med.OutputFileName = this.PublishedFileName.Remove(this.PublishedFileName.LastIndexOf(".")) + "_preview"; // filename witout extension
                    med.OutputExtension = this.PublishedFileName.Remove(0, this.PublishedFileName.LastIndexOf(".")); // only extension
                }
                else
                {
                    // i: publish mp4 video as temp
                    med.OutputFileName = OutputFileName;
                }
            }
            else
            {
                if (this.PublishedFileName != "")
                {
                    med.OutputFileName = this.PublishedFileName.Remove(this.PublishedFileName.LastIndexOf(".")) + "_preview_" + preset.ToString(); // filename witout extension
                    med.OutputExtension = this.PublishedFileName.Remove(0, this.PublishedFileName.LastIndexOf(".")); // only extension
                }
                else
                {
                    med.OutputFileName = OutputFileName + "_" + preset.ToString();
                }
            }
            var vd = med.Process();
            if (vd.ErrorCode > 0)
            {
                return vd;
            }
            // Validation of published file
            int plength = 0;
            string path = this.PublishedPath + "\\" + vd.FileName;
            if (File.Exists(path))
            {
                var flv_info = new FileInfo(path);
                plength = (int)flv_info.Length;
            }

            if (plength == 0)
            {
                // 0 byte video generated - encoding failed - rollback process
                vd.ErrorCode = 1000;
                return vd;
            }

            if (med.OutputExtension == ".mp4")
            {
                // ii: add meta information to mp4 video
                med.MP4BoxPath = this.Mp4BoxPath;
                string _mp4_temp_path = "\"" + this.PublishedPath + "\\" + med.OutputFileName + ".mp4\"";
                med.Parameters = "-isma -hint -add " + _mp4_temp_path + "";
                med.FileName = med.OutputFileName + "_" + preset.ToString() + ".mp4";
                med.InputPath = this.PublishedPath;
                med.Set_MP4_Buffering();

                // check whether file created
                if (File.Exists(this.PublishedPath + "\\" + med.FileName))
                {
                    // remove temp mp4 file
                    if (File.Exists(this.PublishedPath + "\\" + med.OutputFileName + ".mp4"))
                        File.Delete(this.PublishedPath + "\\" + med.OutputFileName + ".mp4");
                }
                else
                {
                    // file not created by mp4box
                    // rename published mp4 as _5.mp4
                    File.Move(this.PublishedPath + "\\" + med.OutputFileName + ".mp4", this.PublishedPath + "\\" + med.FileName);
                }

                vd.FileName = med.FileName;
            }
            return vd;
        }
    
        private void RollbackEncoding()
        {
            if (File.Exists(this.SourcePath + "\\" + this.SourceFileName))
                File.Delete(this.SourcePath + "\\" + this.SourceFileName);
        }

        private void RollbackEncoding(ArrayList PublishedFiles)
        {
            if (PublishedFiles.Count > 0)
            {
                int i = 0;
                for (i = 0; i <= PublishedFiles.Count - 1; i++)
                {
                    if (File.Exists(this.PublishedPath + "\\" + PublishedFiles[i].ToString()))
                        File.Delete(this.PublishedPath + "\\" + PublishedFiles[i].ToString());
                }
            }
        }

        private void RollbackEncoding(ArrayList PublishedFiles, string Thumb_Start_Index)
        {
            int i = 0;
            if (PublishedFiles.Count > 0)
            {
                for (i = 0; i <= PublishedFiles.Count - 1; i++)
                {
                    if (File.Exists(this.PublishedPath + "\\" + PublishedFiles[i].ToString()))
                        File.Delete(this.PublishedPath + "\\" + PublishedFiles[i].ToString());
                }
            }

            int counter = 1;
            for (i = 0; i <= this.TotalThumbs; i++)
            {
                string thumbname = "";
                if (counter < 9)
                    thumbname = Thumb_Start_Index + "_0" + counter + ".jpg";
                else
                    thumbname = Thumb_Start_Index + "_00" + counter + ".jpg";

                counter++;

                if (File.Exists(this.ThumbsDirectory + "\\" + thumbname))
                    File.Delete(this.ThumbsDirectory + "\\" + thumbname);

            }
        }
    }*/
}