﻿using System;
using System.Configuration;
using Jugnoon.BLL;
using Jugnoon.Utility;

namespace Jugnoon.Settings
{
    public class Site_Settings
    {
        public Site_Settings()
        {
        }

        //****************************************************************************
        
        //****************************************************************************
        public static string Website_Title { get { return ConfigurationBLL.Return_Value(1); } }
        public static string Website_Description { get { return ConfigurationBLL.Return_Value(2); } }
        public static string Page_Caption { get {
                if (ConfigurationManager.AppSettings["Page_Caption"] != null)
                    return ConfigurationManager.AppSettings["Page_Caption"].ToString();
                else 
                    return ConfigurationBLL.Return_Value(3);
        } }
        public static string Website_Phone { get { return ConfigurationBLL.Return_Value(247); } }

        public static string Admin_Mail { get { return ConfigurationBLL.Return_Value(4); } }
        public static string Admin_Mail_DisplayName { get { return ConfigurationBLL.Return_Value(5); } }
        public static int Pagination_Links { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(6)); } }
        public static int Pagination_Type { get { return Config.Load_DB_Type; } }
        public static int Screen_Content { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(8)); } }
        public static int Content_Approval { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(9)); } }
        public static int Spam_Count { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(10)); } }
        public static int Cache_Duration { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(11)); } }
        public static bool Store_IPAddress { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(12)); } }
        public static bool Filter_Related_Search { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(13)); } }
        public static bool StoreSearches { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(25)); } }

        public static int QA_Page_Size = 20;
        public static int Video_Page_Size { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(14)); } }
        public static int Photo_Page_Size { get { return  20; } }
        public static int Galleries_Page_Size { get { return 20; } }
        public static int Channel_Page_Size { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(17)); } }
        public static int Group_Page_Size { get { return 0; } }
        public static int Forum_Page_Size = 20;
        public static int Forum_Topic_Page_Size = 10;
        public static bool isMainCategoryProfile { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(19)); } }
        public static bool isMainTagProfile { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(20)); } }
        public static bool isMainArchiveProfile { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(188)); } }

        public static bool AllowMultipleCategoryListing { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(21)); } }

        public static int Channel_Item_Priority_Show { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(22)); } }
        public static int Channel_Views { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(23)); } }
        public static bool Channel_Custom_Theme { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(24)); } }

        public static int Maxiumum_Dynamic_Url_Length { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(26)); } }
                                                                                                                                          //****************************************************************************

            // 0: ffmpeg, 1: youtube, 2: direct
        public static int VideoUploader_Type { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(27)); } }
        public static int Media_Play { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(28)); } }
        public static int Media_SameFormat_Encoding { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(29)); } }
        // Video Settings
        public static int Video_Upload_Option { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(30)); } } // 0: Site Videos, 1: Embed Videos, 2: Both site and embed videos
        public static int Video_Output_Type { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(31)); } } // 0: Flash FLV, 1: H264 mp4, 2: Silverlight WMV, 3: (HTML5: mp4 + webm) - Choose final encoding video option
        public static int Video_Publishing_Type { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(32)); } } // 0: Sheduled Publishing, 1: Direct Publishing - Choose whether video should be published after uploading or in sequence of pending videos

        //public static string Video_Allowed_Formats { get { return ConfigurationBLL.Return_Value(33); } } // comma separated list of video extensions; (Simple Upload.ascx)
        public static string Video_Allowed_Formats_UP { get { return ConfigurationBLL.Return_Value(34); } } // comma separated list of video extensions; (Advance Upload.ascx requirements)
        public static string Video_Allowed_Formats_Display { get { return ConfigurationBLL.Return_Value(35); } } // appear in browser display; (Advance Upload.ascx requirements)

        public static int Video_Max_Size { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(36)); } }  // in MB - maximum allowed video size
        public static bool Video_Delete_Original { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(37)); } } // 1: Yes, 0: No (Delete original video after publishing completion)
                                                                                                                       //public static int Video_Width { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(38)); } } // width of published video
                                                                                                                       //public static int Video_Height { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(39)); } } // height of published video
                                                                                                                       //public static int Video_ABitrate { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(40)); } } // audio bitrate of published video
                                                                                                                       //public static int Video_VBitrate { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(41)); } } // video bitrate of published video
                                                                                                                       //public static int Video_SamplingRate { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(42)); } } // audio sampling rate of published video.
                                                                                                                       //public static string Video_Parameters { get { return ConfigurationBLL.Return_Value(43); } }  // Additional parameters if you want to send for further refine processings e.g "-acodec [audiocodec] -vcodec [videocodec]" etc. 
                                                                                                                       // Audio Settings
                                                                                                                       //public static string Audio_Allowed_Formats { get { return ConfigurationBLL.Return_Value(44); } } // comma separated list of audio extensions;
        public static string Audio_Allowed_Formats_UP { get { return ConfigurationBLL.Return_Value(45); } }
        public static string Audio_Allowed_Formats_Display { get { return ConfigurationBLL.Return_Value(46); } } // comma separated list of audio extensions;
        public static int Audio_Max_Size { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(47)); } } // in MB - maximum allowed audio file size
                                                                                                                //public static int Audio_Delete_Original { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(48)); } } // 1: Yes, 0: No
                                                                                                                //public static int Audio_ABitrate { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(49)); } } // audio bitrate for final output
                                                                                                                //public static int Audio_SamplingRate { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(50)); } } // audio sampling rate for final output
                                                                                                                //public static string Audio_Parameters { get { return ConfigurationBLL.Return_Value(51); } } // Additional parameters for further processings e.g "-acodec [audiocodec] ...
                                                                                                                //public static int Audio_Output_Type { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(52)); } } // 0: mp3 files - no other audio format yet supported
                                                                                                                //public static int Audio_Publishing_Type { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(53)); } } // 0: Sheduled Publishing, 1: Direct Publishing
                                                                                                                //// Thumb Settings (note thumb width and height must be multiple of two.
        public static int Thumb_Width { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(54)); } }
        public static int Thumb_Height { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(55)); } }
        // alternative thumb width
        public static int Alt_Thumb_Width { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(279)); } }
        public static int Alt_Thumb_Height { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(280)); } }

        public static int Thumb_Preview_Type { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(56)); } } // 0: multiple, 1: single, (set thumb preview on video listings)
        public static string Photo_Allowed_Formats { get { return ConfigurationBLL.Return_Value(57); } } // comma separated list of video extensions; (Advance Upload.ascx requirements)
        public static string Photo_Allowed_Formats_UP { get { return ConfigurationBLL.Return_Value(58); } } // comma separated list of video extensions; (Advance Upload.ascx requirements)
        public static string Photo_Allowed_Formats_Display { get { return ConfigurationBLL.Return_Value(59); } } // appear in browser display; (Advance Upload.ascx requirements)

        public static int MediumThumbWidth { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(175)); } } // used to generate medium thumb for preview photo in blog / photo preview pages.
        public static int MediumThumbHeight { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(246)); } } // used to generate medium thumb for preview photo in blog / photo preview pages.
        // alernative mid thumb width / height (for small sliders)
        public static int Alt_MediumThumbWidth { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(277)); } } // used to generate medium thumb for preview photo in blog / photo preview pages.
        public static int Alt_MediumThumbHeight { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(278)); } } // used to generate medium thumb for preview photo in blog / photo preview pages.


        public static int ThumbQuality { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(176)); } } // % from 0 - 100, increasing quality will result in increasing filesize
        public static int MediumThumbQuality { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(177)); } } // % from 0 - 100, increasing quality will result in increasing filesize
        public static int MimiumPhotoWidth { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(178)); } } // Minimum width for photo to upload, if 0 then no restriction.
        public static int Photo_Max_Size { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(185)); } } // in MB - maximum allowed video size

        //**************************************************************************
        // Feature Settings
        //**************************************************************************
        // Enable or Disable Features
        public static int Feature_Videos { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(70)); } } // 1: on, 0: off
        public static int Feature_Audio { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(71)); } } // 1: on, 0: off
        public static int Feature_Photos { get { return 0; } }  // 1: on, 0: off
        public static int Feature_Galleries { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(184)); } }  // 1: on, 0: off
        public static int Feature_Groups { get { return 0; } }  // 1: on, 0: off
        public static int Feature_Channels { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(74)); } }  // 1: on, 0: off
        public static int Feature_Blogs { get { return 0; } }  // 1: on, 0: off
        public static int Feature_QA { get { return 0; } }  // 1: on, 0: off
        public static int Feature_Forums { get { return 0; } }  // 1: on, 0: off
        public static int Feature_Friends { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(78)); } }  // 1: on, 0: off
        public static int Feature_Subscription { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(79)); } } // 1: on, 0: off
        public static int Feature_Messaging { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(80)); } }  // 1: on, 0: off
        public static int Feature_Uploads { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(81)); } }  // 1: on, 0: off (Allow normal users to upload content)
        public static int Feature_Glossary { get { return 0; } }  // 1: on, 0: off
        public static int Feature_Poll { get { return 0; } }  // Convert.ToInt32(ConfigurationBLL.Return_Value(248)) 1: on, 0: off

        // Section settings
        public static int Feature_Categories { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(143)); } }  // 1: on, 0: off
        public static int Feature_Archives { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(82)); } }  // 1: on, 0: off
        public static int Feature_Tags { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(83)); } }  // 1: on, 0: off
        public static int Feature_Comments { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(84)); } } // 1: on, 0: off
        public static int Feature_Video_Responses { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(85)); } }  // 1: on, 0: off
        public static int Feature_Video_Statistics { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(86)); } }  // 1: on, 0: off
        public static int Feature_Playlist { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(87)); } }  // 1: on, 0: off
        public static int Feature_Filter { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(88)); } }  // 1: on, 0: off ( Today, This Week, This Month Options) - this will also effect advance view statistics e.g viewed today, this month, all time
        public static int Feature_Related { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(89)); } }  // 1: on, 0: off
        public static int Feature_Advertisement { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(90)); } }  // 1: on, 0: off
        public static int Feature_Email { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(91)); } }  // 1: on, 0: off (Send auto email)
        public static int Feature_Email_Verification { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(92)); } }  // 1: on, 0: off // Enable to verify user after registration via email.
        public static int Feature_Video_Watermark { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(93)); } }  // 1: on, 0: off - Post watermark on videos, not recommended.
        public static int Feature_Adult_Verification { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(94)); } }  // 1: on, 0: off
        public static int Feature_Views { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(95)); } } //  // 1: on, 0: off (display media views with each item
        public static int Feature_Date { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(96)); } }  // 1: on, 0: off (display date with each item) e.g 2 days ago
        public static int Feature_MemberRegistration { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(97)); } } // 1: on, 0: off  Member registration available
        public static int Feature_UserName { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(99)); } }  // 1: on, 0: off - (display username with each item)
        public static int Feature_Rating { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(100)); } } // 1: on, 0: off
        public static int Feature_LikeBox { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(150)); } }  // 1: on, 0: off
        public static int Feature_SocialFBBox { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(187)); } }  // 1: on, 0: off
        public static int Feature_Packages { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(189)); } }  // 1: on, 0: off
        public static int Feature_LanguageSpecificContent { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(194)); } }  // 1: on, 0: off
        public static int Feature_Downloads { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(195)); } } // 1: on, 0: off
                                                                                                                    // login settings for posting / actions

        public static int Feature_Login_Rating { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(101)); } } // 1: on, 0: off - Login required to post like / dislike
        public static int Feature_Login_Comment { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(102)); } }  // 1: on, 0: off - Login required to post comment
        public static int Feature_Login_Advice { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(103)); } }  // 1: on, 0: off - Login required to like / dislike comment post

     
        //**************************************************************************
        // Youtube SDK
        //**************************************************************************

        public static string Yt_Developer_Key { get { return ConfigurationBLL.Return_Value(104); } }
        public static string Yt_UserName { get { return ConfigurationBLL.Return_Value(106); } } // Account UserID: User Account where all these videos assigned to. if there is no user account, then u must give admin user id.

        //********************************
        // Site Contents
        //********************************

        public static string Site_Analytics { get { return ConfigurationBLL.Return_Value(183); } }
        public static string Site_PrivacyPolicy { get { return ConfigurationBLL.Return_Value(107); } }
        public static string Site_Terms { get { return ConfigurationBLL.Return_Value(108); } }

        //**************************************
        // Globalization / Language Settings
        //**************************************
        public static int Feature_Languages { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(191)); } } // 0: off, 1: on
        public static string Default_CultureInfo { get { return ConfigurationBLL.Return_Value(192); } }

        //**************************************
        // Encoding Settings
        //**************************************
        public static string MP4_240p_Settings { get { return ConfigurationBLL.Return_Value(198); } }
        public static string MP4_360p_Settings { get { return ConfigurationBLL.Return_Value(199); } }
        public static string MP4_480p_Settings { get { return ConfigurationBLL.Return_Value(200); } }
        public static string MP4_720p_Settings { get { return ConfigurationBLL.Return_Value(201); } }
        public static string MP4_1080p_Settings { get { return ConfigurationBLL.Return_Value(202); } }
        public static int EncodingOptions { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(209)); } }
        //**************************************
        // Azure Media Services
        //**************************************
        public static string MediaServices_StorageName { get { return ConfigurationBLL.Return_Value(203); } }
        public static string MediaServices_PrimaryKey { get { return ConfigurationBLL.Return_Value(204); } }
        public static string MediaServices_SecondaryKey { get { return ConfigurationBLL.Return_Value(205); } }
        //**************************************
        // Disqus Shortname
        //**************************************
        public static string Disqus_ShortName { get { return ConfigurationBLL.Return_Value(206); } }

        public static int Feature_Gamify { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(207)); } }

      

        public static string Logo_Path { get { return ConfigurationBLL.Return_Value(208); } }

        public static string Audio_Path { get { return ConfigurationBLL.Return_Value(210); } }

        public static string UserThumb_Path { get { return ConfigurationBLL.Return_Value(211); } }

        /* 10.1.5 */
        public static int MemberLoginType { get { return 0;  } } // 0: username, 1: email address

        //***********************************************/
        // 11.0.1
        // public static bool EnableVideoThumbRotator { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(261)); } }

        public static bool EnablePreviewUrl { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(250)); } } // restrict original video for streaming

        public static int PreviewUrlType { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(251));  } } // 0: clip view, 1: low qulity video view

        public static int ClipLength { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(252));  } } // generate 20 second length video

        public static string PreviewPreset {  get { return ConfigurationBLL.Return_Value(253); } }

        public static int PublishVideoLength { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(254)); } } // length of main video

        public static bool Feature_Artist { get { return false; } }

        public static int Artist_Thumb_Width { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(256)); } }

        public static int Artist_Thumb_Height { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(257)); } }

        public static bool Enable_Movies { get { return Convert.ToBoolean(ConfigurationBLL.Return_Value(258)); } }

        public static int Movie_Thumb_Width { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(259)); } }

        public static int Movie_Thumb_Height { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(260)); } }

        // Movie Storage
        public static int MovieUploadType { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(262)); } } // 0: amazon aws, 1: azure, 2: local or custom

        public static string MovieBucketName { get { return ConfigurationBLL.Return_Value(263); } }

        public static string MovieDownloadFolderPath { get { return ConfigurationBLL.Return_Value(264); } }

        public static string MovieClipFolderPath { get { return ConfigurationBLL.Return_Value(265); } }

        public static string MovieCoverFolderPath { get { return ConfigurationBLL.Return_Value(266); } }

        public static string Movie_PublicUrl { get { return ConfigurationBLL.Return_Value(267); } }

        public static string Movie_PrivateUrl { get { return ConfigurationBLL.Return_Value(268); } }


        /* contact information */
        public static string Contact_Information { get { return ConfigurationBLL.Return_Value(269); } }
        public static string Contact_Address { get { return ConfigurationBLL.Return_Value(270); } }
        public static string Contact_Tel1 { get { return ConfigurationBLL.Return_Value(271); } }
        public static string Contact_Tel2 { get { return ConfigurationBLL.Return_Value(272); } }
        public static string Contact_Fax { get { return ConfigurationBLL.Return_Value(273); } }
        public static string Contact_Email { get { return ConfigurationBLL.Return_Value(274); } }

        /* category thumbnail width * height settings */
        public static int Category_Thumbnail_Width { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(287)); } }
        public static int Category_Thumbnail_Height { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(288)); } }

        // 0: No Rotator, 1: Thumbs Rotator, 2: Video Preview Rotator
        public static int VideoThumbnailRotatorOption { get { return Convert.ToInt32(ConfigurationBLL.Return_Value(289)); } }
    }
}