﻿
using Jugnoon.Entity;
using Jugnoon.Utility;
using Jugnoon.models;

namespace JgnEnt.models.ViewModels.User
{
    public class ExternalLoginListViewModel
    {
        public string ReturnUrl { get; set; }
    }

    public class ExternalAuthModelView
    {
        public string UserName { get; set; }
        public string NameIdentifier { get; set; }
        public string GivenName { get; set; }
        public string SurName { get; set; }
        public string Name { get; set; }
        public string EmailAddress { get; set; }
        public string Issuer { get; set; }
        public string AccessToken { get; set; }
        public string PictureUrl { get; set; }
        public string Gender { get; set; }
        
        // internal use
        public string Picture { get; set; }

        public string Message { get; set; }
        public AlertTypes AlertType { get; set; }

    }

    public class UserModelView
    {
        public string UserName { get; set; }

        public UserDataEntity user { get; set; }  // for general user data loading

        public UserDataEntity profile { get; set; } // for user profile loading

        public NavModelView Nav { get; set; }

        public string Message { get; set; }

        public AlertTypes AlertType { get; set; }

        public bool UserExist { get; set; }

        public bool OwnProfile { get; set; }

        public string FullName { get; set; }

        public string UserInfo { get; set; }

        public int ActiveIndex { get; set; }

        public VideoListViewModel videos { get; set; }

        public VideoListViewModel audio { get; set; }
        
        public AlbumListViewModel albums { get; set; }


    }
}