﻿namespace Jugnoon.Utility
{
    public class UserUrlConfig
    {
        public static string ProfileUrl(string username)
        {
            if (username == null)
                return "#";

            return Config.GetUrl() + "user/" + username.ToLower();
        }

        public static string ProfileUrl(string username, string section)
        {
            if (username == null)
                return "#";

            if (section != "")
                section = section + "/";

            return Config.GetUrl() + "user/" + section + "" + username.ToLower();
        }

        public static string ProfilePhoto(string username, string picturename, int type)
        {
            if (username == null)
                return "";

            string URL = "";
            if (picturename == null || picturename == "" || picturename == "none")
                URL = GetDefaultPhoto();
            else if (picturename.StartsWith("http")) // media stored in cloud storage
                URL = PhotoUrlConfig.PrepareHttpPhotoUrl(new Entity.PhotoDataEntity()
                {
                    filename = picturename,
                    username = username
                }, type);
            else
            {
                // type = 0: thumb, 1: mid thumb, 2: original
                string Imagetype = ""; // original
                switch (type)
                {
                    case 0:
                        Imagetype = "thumbs/";
                        break;
                    case 1:
                        Imagetype = "midthumbs/";
                        break;
                }
                URL = Config.GetUrl() + "contents/member/" + username + "/photos/" + Imagetype + "" + picturename;
            }

            return URL;
        }

        public static string GetDefaultPhoto()
        {
            return Config.GetUrl() + "assets/images/default-user.jpg";
        }
    }

}