﻿using System;
using System.Security.Claims;


namespace Jugnoon.Utility
{
    public class Auth
    {
        public static string GetRole(ClaimsPrincipal user)
        {
            string value = "";
            var claims = user.Claims;
            if (user != null)
            {
                foreach (Claim claim in user.Claims)
                {
                    if (claim.Type.EndsWith("role"))
                        value = claim.Value;
                }
            }
            return value;
        }

        public static long GetUserID(ClaimsPrincipal user)
        {
            long id = 0;
            var claims = user.Claims;
            if (user != null)
            {
                foreach (Claim claim in user.Claims)
                {
                   if (claim.Type.EndsWith("nameidentifier"))
                         id = Convert.ToInt64(claim.Value);
                  
                }
            }
            return id;
        }

        public static string GetUserName(ClaimsPrincipal user)
        {
            string value = "";
            var claims = user.Claims;
            if (user != null)
            {
                foreach (Claim claim in user.Claims)
                {
                    if (claim.Type.EndsWith("name"))
                        value = claim.Value;
                }
            }
            return value;
        }

        public static string GetEmail(ClaimsPrincipal user)
        {
            string value = "";
            var claims = user.Claims;
            if (user != null)
            {
                foreach (Claim claim in user.Claims)
                {
                    if (claim.Type.EndsWith("emailaddress"))
                        value = claim.Value;
                    
                }
            }
            return value;
        }

        public static string GetPictureName(ClaimsPrincipal user)
        {
            string value = "";
            var claims = user.Claims;
            if (user != null)
            {
                foreach (Claim claim in user.Claims)
                {
                    if (claim.Type.EndsWith("thumbprint"))
                        value = claim.Value;

                }
            }
            return value;
        }

        public static int GetType(ClaimsPrincipal user)
        {
            int type = 0;
            switch(GetRole(user))
            {
                case "User":
                    type = 0;
                    break;
                case "Admin":
                    type = 1;
                    break;
                case "Paid":
                    type = 2;
                    break;
            }
            return type;
           
        }

        public static bool isAdmin(ClaimsPrincipal user)
        {
            if (GetRole(user) == "Admin")
                return true;
            else
                return false;
        }

       

    }
}