﻿using Microsoft.Owin.Security.Google;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using System.Web;
using Microsoft.AspNet.Identity;
using Microsoft.Owin.Security.Twitter;

namespace Jugnoon.Auth
{
    public class CustomGoogleProvider : GoogleOAuth2AuthenticationProvider
    {
        public override Task Authenticated(GoogleOAuth2AuthenticatedContext context)
        {          
            context.Identity.AddClaim(new Claim("urn:google:name", context.Identity.FindFirstValue(ClaimTypes.Name)));
            context.Identity.AddClaim(new Claim("urn:google:email", context.Identity.FindFirstValue(ClaimTypes.Email)));
            context.Identity.AddClaim(new Claim("urn:google:accesstoken", context.AccessToken, ClaimValueTypes.String, "Google"));

            var identity = ((ClaimsIdentity)context.Identity);
            var pictureUrl = context.User["image"].Value<string>("url");
            identity.AddClaim(new Claim("pictureUrl", pictureUrl));

            bool bAddClaim = false;
            string claimtype = "";
            foreach (var claim in context.User)
            {

                claimtype = string.Empty;
                bAddClaim = false;
                switch (claim.Key)
                {                   
                    case "given_name":
                        claimtype = "FirstName";
                        bAddClaim = true;
                        break;
                    case "family_name":
                        claimtype = "LastName";
                        bAddClaim = true;
                        break;
                    case "gender":
                        claimtype = "gender";
                        bAddClaim = true;
                        break;
                }

                if (bAddClaim)
                {
                    string claimValue = claim.Value.ToString();
                    if (claimValue.Contains("{"))
                    {
                        dynamic data = JObject.Parse(claimValue);
                        switch(claimtype)
                        {
                            case "email":
                                var Email = data.type;
                                if (!context.Identity.HasClaim(claimtype, data.type))
                                    context.Identity.AddClaim(new System.Security.Claims.Claim(claimtype, data.type, "XmlSchemaString", "Google"));
                                break;
                        }
                       
                    }
                    else
                    {
                        if (!context.Identity.HasClaim(claimtype, claimValue))
                            context.Identity.AddClaim(new System.Security.Claims.Claim(claimtype, claimValue, "XmlSchemaString", "Google"));
                    }
                   
                }
            }

            return base.Authenticated(context);
        }
    }
    
}