﻿using System;
using System.Linq;
using JgnEnt.Framework;
using Jugnoon.EntityFramework;

namespace Jugnoon.BLL
{
    public class PlayList_VideosBLL
    {
        public PlayList_VideosBLL()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        public static bool Add(long PlayListID, long VideoID)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var _entity = new playlist_videos()
                {
                    id = PlayListID,
                    videoid = VideoID,
                    added_date = DateTime.Now
                };

                dbCtx.Entry(_entity).State = System.Data.Entity.EntityState.Added;

                DataBLL.SaveChanges(dbCtx);
                
            }
            
            // update video statistics
            int count = PlayList_VideosBLL.Count(PlayListID); // count total no of videos in current playlist
            PlayListBLL.Update_Video_Stat(PlayListID, count); // update video statistic of play list
            return true;
        }

        // Delete single video from playlist
        public static bool Delete(long PlayListID, long VideoID)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new playlist_videos { id = PlayListID, videoid = VideoID };
                dbCtx.playlist_videos.Attach(entity);
                dbCtx.playlist_videos.Remove(entity);
                dbCtx.SaveChanges();
            }
            
            // update video statistics
            int count = PlayList_VideosBLL.Count(PlayListID); // count total no of videos in current playlist
            PlayListBLL.Update_Video_Stat(PlayListID, count); // update video statistic of play list
            return true;
        }

        // Delete all videos from playlist
        public static bool Delete(long PlayListID)
        {
            using (var dbCtx = new mvcportalEntities())
            {
                var entity = new playlist_videos { id = PlayListID };
                dbCtx.playlist_videos.Attach(entity);
                dbCtx.playlist_videos.Remove(entity);
                dbCtx.SaveChanges();
            }

            PlayListBLL.Update_Video_Stat(PlayListID, 0); // update video statistic of play list
            return true;
        }

        public static int Count(long PlayListID)
        {
            int Records = 0;
            using (var ctx = new mvcportalEntities())
            {
                Records = ctx.playlist_videos.Where(p => p.id == PlayListID).Count();
            }
            return Records;
        }


        public static bool Check(long PlayListID, long VideoID)
        {
            bool flag = false;
            using (var ctx = new mvcportalEntities())
            {
                if (ctx.playlist_videos.Where(p => p.id == PlayListID && p.videoid == VideoID).Count() > 0)
                    flag = true;
            }

            return flag;
        }

    }
}