﻿using Jugnoon.Entity;
using Jugnoon.Settings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Jugnoon.Utility
{
    public class VideoUrlConfig
    {
        public static string Source_Video_Path()
        {
            return UrlConfig.Upload_Path("default");
        }
        public static string Source_Video_Path(string username)
        {
            return UrlConfig.Upload_Path(username, "default");
        }
        public static string Source_Video_Url(string username)
        {
            return UrlConfig.Upload_URL(username, "default");
        }

        public static string Published_Video_Path()
        {
            return UrlConfig.Upload_Path("flv");
        }
        public static string Published_Video_Path(string username)
        {
            return UrlConfig.Upload_Path(username, "flv");
        }

        public static string Published_Audio_Path(string username)
        {
            return UrlConfig.Upload_Path(username, "mp3");
        }

        public static string MP3_Path()
        {
            return UrlConfig.Upload_Path("mp3");
        }
        public static string MP3_Path(string username)
        {
            return UrlConfig.Upload_Path(username, "mp3");
        }
        public static string Thumbs_Path()
        {
            return UrlConfig.Upload_Path("thumbs");
        }
        public static string Thumbs_Path(string username)
        {
            return UrlConfig.Upload_Path(username, "thumbs");
        }

        public static string Thumb_Url(string username)
        {
            return UrlConfig.Upload_URL(username, "thumbs");
        }


        public static string PrepareUrl(VideoDataEntity entity)
        {
            string _title = "";
            if (entity.title == null)
                entity.title = "";
            int maxium_length = Site_Settings.Maxiumum_Dynamic_Url_Length;
            if (entity.title.Length > maxium_length && maxium_length > 0)
                _title = entity.title.Substring(0, maxium_length);
            else if (entity.title.Length < 3)
                _title = "preview-video";
            else
                _title = entity.title;

            _title = UtilityBLL.ReplaceSpaceWithHyphin_v2(_title.Trim().ToLower());

            return Config.GetUrl("media/" + entity.videoid + "/" + _title);
        }

        /* Image path to load for unpublished videos */
        public static string get_Unpublished_Media_Url()
        {
            return Config.GetUrl("assets/images/video-thumbnail.jpg");
        }

    }
}