﻿using Jugnoon.Scripts;
using Jugnoon.Utility;

namespace Jugnoon.models
{
    public class ListViewModel
    {
        // Default Values
        private string _colCss = "col-md-4";
        private int _listMode = 1;  //0: list view, 1: grid view
        private string _headingtitle = "";
        private bool _isliststatus = true;
        private bool _islistnav = false;

        private string _pagetitle = "";
        private string _pagedescription = "";
        private string _norecordfoundtext = "No Record Found!";
        private int _pagesize = 20;
        private string _defaulturl = "";
        private string _paginationurl = "";
        private string _containerid = "";
        // short list properties
        private string _headingelement = "h1"; // html heading element
        private string _headercss = "text-center";
        private string _headertextcss = "mb20 text-white";
        private string _browseText = "Explore All";
        private string _browseUrl = "";
        private string _browseCss = "btn btn-white btn-lg btn-ghost";
        private ListItems _ListObject = new ListItems();
      
        // for message display purpose
        private string _message = ""; // for message display purpose
        private AlertTypes _alerttype = AlertTypes.Error;
        // for my account listing purpose
        private int _topmenuindex = 0;
        private int _mainmenuindex = 0;
        // for order
        private string _selectedOrderTag = Resources.vsk.recentlyadded;
        private string _orderlinkurl = "";

        public string HeadingTitle
        {
            set { _headingtitle = value; }
            get { return _headingtitle; }
        }

        public string HeadingElement
        {
            set { _headingelement = value; }
            get { return _headingelement; }
        }
        public bool isListStatus
        {
            set { _isliststatus = value; }
            get { return _isliststatus; }
        }
        public bool isListNav
        {
            set { _islistnav = value; }
            get { return _islistnav; }
        }
        public string PageTitle
        {
            set { _pagetitle = value; }
            get { return _pagetitle; }
        }
        public string PageDescription
        {
            set { _pagedescription = value; }
            get { return _pagedescription; }
        }
        public string NoRecordFoundText
        {
            set { _norecordfoundtext = value; }
            get { return _norecordfoundtext; }
        }
        public int PageSize
        {
            set { _pagesize = value; }
            get { return _pagesize; }
        }
        public int ListMode
        {
            set { _listMode = value; }
            get { return _listMode; }
        }
        public string DefaultUrl
        {
            set { _defaulturl = value; }
            get { return _defaulturl; }
        }
        public string PaginationUrl
        {
            set { _paginationurl = value; }
            get { return _paginationurl; }
        }
        public string ColCSS
        {
            set { _colCss = value; }
            get { return _colCss; }
        }
        public string ContainerID
        {
            set { _containerid = value; }
            get { return _containerid; }
        }
        public string HeaderCss
        {
            set { _headercss = value; }
            get { return _headercss; }
        }
        public string HeaderTextCss
        {
            set { _headertextcss = value; }
            get { return _headertextcss; }
        }
        public string BrowseText
        {
            set { _browseText = value; }
            get { return _browseText; }
        }
        public string BrowseUrl
        {
            set { _browseUrl = value; }
            get { return _browseUrl; }
        }

        public string BrowseCss
        {
            set { _browseCss = value; }
            get { return _browseCss; }
        }
        
        public ListItems ListObject
        {
            set { _ListObject = value; }
            get { return _ListObject; }
        }

        public string Message
        {
            set { _message = value; }
            get { return _message; }
        }
        
        public AlertTypes AlertType
        {
            set { _alerttype = value; }
            get { return _alerttype; }
        }

        public int TopMenuIndex
        {
            set { _topmenuindex = value; }
            get { return _topmenuindex; }
        }

        public int MainMenuIndex
        {
            set { _mainmenuindex = value; }
            get { return _mainmenuindex; }
        }

        public string SelectedOrderTag
        {
            set { _selectedOrderTag = value; }
            get { return _selectedOrderTag; }
        }

        public string OrderLinkUrl
        {
            set { _orderlinkurl = value; }
            get { return _orderlinkurl; }
        }
    }
}