﻿using Microsoft.AspNet.Identity;
using Microsoft.Owin;
using Microsoft.Owin.Security.Cookies;
using Microsoft.Owin.Security.Google;
using Owin;
using Jugnoon.Settings;
using Microsoft.Owin.Security;
using Microsoft.Owin.Security.Twitter;
using Microsoft.Owin.Security.Facebook;
using Microsoft.Owin.Security.MicrosoftAccount;

[assembly: OwinStartup(typeof(MSP.UI.Portal.Startup))]

namespace MSP.UI.Portal
{
    public class Startup
    {
        public void Configuration(IAppBuilder app)
        {
            app.SetDefaultSignInAsAuthenticationType(CookieAuthenticationDefaults.AuthenticationType);
            app.UseExternalSignInCookie();

            app.UseCookieAuthentication(new CookieAuthenticationOptions
            {
                AuthenticationType = DefaultAuthenticationTypes.ApplicationCookie,
                LoginPath = new PathString("/login"),
                CookieSecure = CookieSecureOption.SameAsRequest
            });

            // Google Account
            if(MultiLogin_Settings.Enable_GooglePlus)
            {
                var options = new GoogleOAuth2AuthenticationOptions
                {
                    ClientId = MultiLogin_Settings.Google_ClientID,
                    ClientSecret = MultiLogin_Settings.Google_SecretID,
                    Provider = new Jugnoon.Auth.CustomGoogleProvider()
                };
                options.Scope.Add("email");
                app.UseGoogleAuthentication(options);
            }
            // Twitter Account
            if(MultiLogin_Settings.Enable_Twitter)
            {
                var options = new TwitterAuthenticationOptions
                {
                    ConsumerKey = MultiLogin_Settings.Twitter_Key,
                    ConsumerSecret = MultiLogin_Settings.Twitter_Secrete
                };
                app.UseTwitterAuthentication(options);
            }
            // Facebook Account
            if (MultiLogin_Settings.Enable_Facebook)
            {
                var options = new FacebookAuthenticationOptions
                {
                    AppId = MultiLogin_Settings.Facebook_AppID,
                    AppSecret = MultiLogin_Settings.Facebook_AppSecret,
                };
                //options.Scope.Add("user_friends");
                app.UseFacebookAuthentication(options);
            }
            // Facebook Account
            if (MultiLogin_Settings.Enable_Microsoft)
            {
                var options = new MicrosoftAccountAuthenticationOptions
                {
                    ClientId = MultiLogin_Settings.Microsoft_ClientID,
                    ClientSecret = MultiLogin_Settings.Microsoft_SecretID,
                    /*Provider = new MicrosoftAccountAuthenticationProvider
                    {
                        OnAuthenticated = async context =>
                        {
                            // Retrieve the OAuth access token to store for subsequent API calls
                            string accessToken = context.AccessToken;

                            // Retrieve the user ID
                            string microsoftUserId = context.id;

                            // Retrieve the user's full name
                            string microsoftFullName = context.name;

                            // You can even retrieve the full JSON-serialized user
                            var serializedUser = context.User;
                        }
                    }*/
                };
                //options.Scope.Add("wl.calendars");
                app.UseMicrosoftAccountAuthentication(options);
            }

        }
    }
}
